Package: tximeta
Version: 1.16.0
Title: Transcript Quantification Import with Automatic Metadata
Description: Transcript quantification import from Salmon and
    alevin with automatic attachment of transcript ranges and
    release information, and other associated metadata. De novo
    transcriptomes can be linked to the appropriate sources with
    linkedTxomes and shared for computational reproducibility.
Authors@R: c(
    person("Michael", "Love", email="michaelisaiahlove@gmail.com", role = c("aut","cre")),
    person("Charlotte", "Soneson", role = c("aut","ctb")),
    person("Peter", "Hickey", role = c("aut","ctb")),
    person("Rob", "Patro", role = c("aut","ctb")),
    person("NIH NHGRI", role="fnd"),
    person("CZI", role="fnd")
    )
Maintainer: Michael Love <michaelisaiahlove@gmail.com>
License: GPL-2
VignetteBuilder: knitr
Imports: SummarizedExperiment, tximport, jsonlite, S4Vectors, IRanges,
        GenomicRanges, AnnotationDbi, GenomicFeatures, ensembldb,
        BiocFileCache, AnnotationHub, Biostrings, tibble, GenomeInfoDb,
        tools, utils, methods, Matrix
Suggests: knitr, rmarkdown, testthat, tximportData, org.Dm.eg.db,
        DESeq2, fishpond, edgeR, limma, devtools
URL: https://github.com/mikelove/tximeta
biocViews: Annotation, GenomeAnnotation, DataImport, Preprocessing,
        RNASeq, SingleCell, Transcriptomics, Transcription,
        GeneExpression, FunctionalGenomics, ReproducibleResearch,
        ReportWriting, ImmunoOncology
RoxygenNote: 7.2.1
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/tximeta
git_branch: RELEASE_3_16
git_last_commit: 189bd25
git_last_commit_date: 2022-11-01
Date/Publication: 2022-11-01
NeedsCompilation: no
Packaged: 2022-11-01 23:17:14 UTC; biocbuild
Author: Michael Love [aut, cre],
  Charlotte Soneson [aut, ctb],
  Peter Hickey [aut, ctb],
  Rob Patro [aut, ctb],
  NIH NHGRI [fnd],
  CZI [fnd]

Package: tximeta
Version: 1.31.4
Title: Transcript Quantification Import with Automatic Metadata
Description: Transcript quantification import from Salmon and
    other quantifiers with automatic attachment of transcript ranges
    and release information, and other associated metadata. De novo
    transcriptomes can be linked to the appropriate sources with
    linkedTxomes and shared for computational reproducibility.
Authors@R: c(
    person("Michael", "Love", email="michaelisaiahlove@gmail.com", role = c("aut","cre")),
    person("Charlotte", "Soneson", role = c("aut","ctb")),
    person("Peter", "Hickey", role = c("aut","ctb")),
    person("Rob", "Patro", role = c("aut","ctb")),
    person("NIH NHGRI", role="fnd"),
    person("CZI", role="fnd")
    )
Maintainer: Michael Love <michaelisaiahlove@gmail.com>
License: GPL-2
VignetteBuilder: knitr, rmarkdown
Depends: R (>= 4.1.0)
Imports: SummarizedExperiment (>= 1.39.1), tximport, jsonlite,
        S4Vectors, IRanges, GenomicRanges (>= 1.61.1), AnnotationDbi,
        DBI, GenomicFeatures, txdbmaker, ensembldb, BiocFileCache,
        AnnotationHub, Biostrings, tibble, Seqinfo, tools, utils,
        methods, Matrix
Suggests: knitr, rmarkdown, testthat, tximportData (>= 1.37.5),
        org.Dm.eg.db, DESeq2, edgeR (>= 4.9.2), limma, devtools,
        macrophage
URL: https://thelovelab.github.io/tximeta,
        https://github.com/thelovelab/tximeta
biocViews: Annotation, GenomeAnnotation, DataImport, Preprocessing,
        RNASeq, LongRead, SingleCell, Transcriptomics, Transcription,
        GeneExpression, FunctionalGenomics, ReproducibleResearch,
        ReportWriting, ImmunoOncology
Roxygen: list(markdown = TRUE)
Encoding: UTF-8
Config/Needs/website: r-lib/pkgdown
Config/roxygen2/version: 8.0.0
git_url: https://git.bioconductor.org/packages/tximeta
git_branch: devel
git_last_commit: 6825c7f
git_last_commit_date: 2026-06-15
Repository: Bioconductor 3.24
Date/Publication: 2026-06-16
NeedsCompilation: no
Packaged: 2026-06-17 00:43:34 UTC; biocbuild
Author: Michael Love [aut, cre],
  Charlotte Soneson [aut, ctb],
  Peter Hickey [aut, ctb],
  Rob Patro [aut, ctb],
  NIH NHGRI [fnd],
  CZI [fnd]

## tximeta: Transcript Quantification Import with Automatic Metadata

For a reference and citation for `tximeta`:

> Michael I. Love, Charlotte Soneson, Peter F. Hickey, Lisa K. Johnson,
> N. Tessa Pierce, Lori Shepherd, Martin Morgan, Rob Patro.
> "Tximeta: reference sequence checksums for provenance
> identification in RNA-seq" *PLOS Computational Biology* (2020)
> [doi: 10.1371/journal.pcbi.1007664](https://doi.org/10.1371/journal.pcbi.1007664)

# Idea in diagram

![](vignettes/diagram.png)

Quantification methods *Salmon* and *Alevin* propogate a 
*hashed checksum* of the transcriptome sequence into the index and
quantification directories. The signature is a SHA256 hash of
the transcriptome cDNA sequence, excluding transcript identifiers
(this may change going forward, to enable coordination with larger
efforts at data-driven identifiers for collections of sequences, see
the last section of vignette for details).

Following quantification, and even performed by a different analyst or
at a different institute, when importing quantifications into
R/Bioconductor, `tximeta` checks a local database of known
transcriptome checksums (see the vignette for up-to-date list), 
and upon finding a match, automatically adds
annotation and metadata to the quantifications, returning a
`SummarizedExperiment` object. Examples of metadata include transcript
locations, transcript and genome source and version, appropriate
chromosome lengths, etc. This ensures computational reproducibility by
attaching critical annotation information to the data object, such
that exact quantifications can be reproduced from raw data (all
software versions are also attached to the data object).

Other quantifiers can also be used as long as these alternative tools
are wrapped in workflows that include metadata information JSON files
along with each quantification file, storing the reference transcript
checksum. See vignette for details, and the `customMetaInfo` argument
details in `?tximeta`.

# Idea in text

`tximeta` performs numerous annotation and metadata gathering tasks on
behalf of users during the import of transcript quantifications from
*Salmon* or *Alevin* into R/Bioconductor. The goal is to provide
something similar to the experience of `GEOquery`, which downloaded
microarray expression data from NCBI GEO and simultaneously brought
along associated pieces of metadata. Doing this automatically helps to
prevent costly bioinformatic errors. To use `tximeta`, all one needs
is the `quant` directory output from *Salmon* or *Alevin*.

The key idea within `tximeta` is to store a *hashed checksum* of
the transcriptome sequence itself using the SHA256 hash, computed and
stored by the `index` and `quant` functions of *Salmon* and
*Alevin*. This checksum acts as the identifying information for later
building out rich annotations and metadata in the background, on
behalf of the user. This should greatly facilitate genomic workflows,
where the user can immediately begin overlapping their transcriptomic
data with other genomic datasets, e.g. epigenetic tracks such as ChIP
or methylation, as the data has been embedded within an organism and
genome context, including the proper genome version. We seek to
reduce wasted time of bioinformatic analysts, prevent costly
bioinformatic mistakes, and promote computational reproducibility by
avoiding situations of annotation and metadata ambiguity, when files
are shared publicly or among collaborators but critical details go
missing.

# Do I have to use R?

Much of the power of `tximeta` leverages the rich data objects,
annotation resources, and genomic range manipulation methods of the
Bioconductor project, which is built on the R programming
environment. However, it is possible to wrap up the relevant `tximeta`
commands into an R script which can be called from command line, using
[Rscript](https://stat.ethz.ch/R-manual/R-devel/library/utils/html/Rscript.html).
This will create a `SummarizedExperiment` object with relevant
metadata, then deconstruct the object and print its contents into
multiple files. A simple example of such a script is: 

```{r}
coldata <- read.csv("coldata.csv")
library(tximeta)
library(SummarizedExperiment)
se <- tximeta(coldata)
# write out the assay data
for (a in assayNames(se)) {
  write.csv(assays(se)[[a]], file=paste0(a,".csv"))
}
# write out the genomic ranges to BED file
library(rtracklayer)
export(rowRanges(se), con="rowRanges.bed")
# write out metadata about genomic ranges
write.csv(as.data.frame(seqinfo(se)), file="seqInfo.csv")
# write out metadata about the transcriptome
write.csv(as.data.frame(metadata(se)$txomeInfo), file="txomeInfo.csv")
```

This script could be run with the following command line call:

```
Rscript tximeta.R
```

# Where the transcript databases are stored

`tximeta` makes use of the Bioconductor *TxDb* object, which can be
saved and re-loaded from an `sqlite` file. These are saved in a
specific location using the *BiocFileCache* package. Since these
*TxDb* saved objects (sqlite databases) can be ~100 Mb, we want to
make sure the user is OK with these being saved to a given location. 
Also we want to allow for the situation that multiple users share a
*BiocFileCache* location, such that any *TxDb* / *EnsDb* objects or
*linkedTxome* information can be shared, reducing unnecessary
downloads or emails asking about the provenance of the transcriptome
for a given set of quantification files.

In order to allow that multiple users can read and write to the
same location, one should set the BiocFileCache directory to
have group write permissions (g+w). For use of *tximeta* across
multiple groups, it is recommended to create a new UNIX group that
encompasses multiple groups and assign the *tximeta* BiocFileCache
location to this new group. 

We use the following logic to specify the location of the
*BiocFileCache* used by `tximeta`:

* If run **non-interactively**, `tximeta` uses a temporary directory.
* If run **interactively**, and a location has not been previously
  saved, the user is prompted if she wants to use (1) the default directory
  or a (2) temporary directory.
    - If (1), then use the default directory, and save this choice.
    - If (2), then use a temporary directory for the rest of this R session,
      and ask again next R session.
* The prompt above also mentions that a specific function can be used to
  manually set the directory at any time point, and this choice is saved.
* The default directory is given by `rappdirs::user_cache_dir("BiocFileCache")`.
* The choice itself of the BiocFileCache directory that `tximeta` should use is
  saved in a JSON file here `rappdirs::user_cache_dir("tximeta")`.

# Take a look at the example

We have a *tximeta* vignette for how `tximeta` would look, and some
thoughts on next steps at the end of the document. 

# Feedback

We'd love to hear your feedback. Please file an 
[Issue on GitHub](https://github.com/mikelove/tximeta/issues),
or feel free to [send us a tweet](https://twitter.com/mikelove).

# Funding 

tximeta and its maintainers have been partially supported by 
NIH NHGRI R01-HG009937
and by a CZI EOSS award.

# tximeta <img id="tximeta_logo" src="man/figures/tximeta.png" align="right" width="180" alt="tximeta logo"/>

[![R build status](https://github.com/thelovelab/tximeta/actions/workflows/check-bioc.yml/badge.svg)](https://github.com/thelovelab/tximeta/actions/workflows/check-bioc.yml)

# Automatic metadata for RNA-seq

*tximeta* provides a set of functions for conveniently working with
metadata for transcript quantification data in Bioconductor. The
`tximeta()` function imports quantification data from *salmon* or
related quantifiers, and returns a 
[SummarizedExperiment](https://bioconductor.org/packages/release/bioc/vignettes/SummarizedExperiment/inst/doc/SummarizedExperiment.html#anatomy-of-a-summarizedexperiment)
object. *tximeta* works natively with 
[salmon](https://salmon.readthedocs.io/en/latest/),
[alevin](https://salmon.readthedocs.io/en/latest/alevin.html),
[piscem-infer](https://piscem-infer.readthedocs.io/en/latest/), and
[oarfish](https://github.com/COMBINE-lab/oarfish),
but can easily be configured to work with any transcript
quantification tool.

If `tximeta()` recognizes the reference transcripts used
for quantification, it will automatically download relevant
information about the location of the transcripts in the correct genome.
*These actions happen in the background without requiring any extra
effort or information from the user.*

This metadata is attached to the *SummarizedExperiment* in the
`metadata()` and `rowRanges()` or `rowData()` slots.

For a list of the reference transcriptomes supported by `tximeta()`,
see the "Pre-computed digests" section of the vignette in the 
`Get started` tab. 
Note that in _tximeta_ documentation, we call the computed identifier 
for the reference transcriptome a "digest" or sometimes a "checksum",
which is produced by hash function(s) employed by upstream software.

Further steps are also facilitated, e.g. `summarizeToGene()`, `addIds()`,
or even `retrieveCDNA()` (the transcripts used for quantification) or
`retrieveDb()` (the correct *TxDb* or *EnsDb* to match the
quantification data).

# How it works

The key idea behind *tximeta* is that *Salmon*, *alevin*, and
*piscem-infer* propagate a hash value
summarizing the reference transcripts into each quantification
directory it outputs. *tximeta* can be used with other tools as long
as the 
[hash of the transcripts](https://github.com/COMBINE-lab/FastaDigest) 
is also included in the output directories. See `customMetaInfo`
argument of `tximeta()` for more details.

![Diagram of tximeta workflow](man/figures/diagram.png)

In the Bioconductor 3.22 release (October 2025), tximeta's long read import
pipeline was updated to support mixed reference transcripts, where
[oarfish](https://github.com/COMBINE-lab/oarfish) is used to quantify against
a combination of `--annotated` (e.g. GENCODE, Ensembl) and `--novel`
(e.g. *de novo* assembled) reference transcripts. New functions `importData()`,
`inspectDigests()`, and `updateMetadata()` facilitate import and automatic
metadata attachment across both reference sets. Support for *salmon* mixed
reference workflows is also available via the `mixedDigest` argument of
`importData()`, using a companion Snakemake rule to record per-sub-index digests
at index time.
See the [mixed reference transcripts](https://thelovelab.github.io/tximeta/articles/tximeta.html#mixed-reference-transcripts)
section of the vignette for details.

![Diagram of tximeta mixed reference workflow](man/figures/mixed-ref-diagram.png)

# Reference

A reference for *tximeta* package is:

> Michael I. Love, Charlotte Soneson, Peter F. Hickey, Lisa K. Johnson,
> N. Tessa Pierce, Lori Shepherd, Martin Morgan, Rob Patro.
> "Tximeta: reference sequence checksums for provenance
> identification in RNA-seq" *PLOS Computational Biology* (2020)
> [doi: 10.1371/journal.pcbi.1007664](https://doi.org/10.1371/journal.pcbi.1007664)

# Feedback

We would love to hear your feedback. Please post to 
[Bioconductor support site](https://support.bioconductor.org) for
software usage help or post an
[Issue on GitHub](https://github.com/mikelove/tximeta/issues),
for software development questions.

# Funding 

tximeta was developed as part of NIH NHGRI R01-HG009937.

tximeta was also supported by the Chan Zuckerberg Initiative as part
of the EOSS grants.

![CZI logo](man/figures/czi.png)

# Creation of the Salmon indices in `extdata`

The `extdata` directory contains two directories, each with a
`header.json` file:

* `Drosophila_melanogaster.BDGP6.cdna.v92_salmon_0.10.2`
* `Drosophila_melanogaster.BDGP6.v92_salmon_0.10.2`

These directories were created by running the `index` step of *Salmon*
version 0.10.2 on the Drosophila melanogaster transcriptome. The only
files that have been posted are the `header.json` files from the index
directory, as the index itself is not needed by `tximeta` and is too
large to include. These directories allow us to demonstrate the use of
`tximeta` when the transcriptome is not known.

The transcriptome FASTA files were downloaded from the following FTP sites:

* <ftp://ftp.ensembl.org/pub/release-92/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.cdna.all.fa.gz>
* <ftp://ftp.ensembl.org/pub/release-92/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.ncrna.fa.gz>

The `Drosophila_melanogaster.BDGP6.v92_salmon_0.10.2` index was
created by `cat`-ing the `cdna` and `ncrna` gzipped FASTA together
before running `salmon index`.

#' Add IDs to rowRanges of a SummarizedExperiment
#'
#' For now this function just works with SummarizedExperiments
#' with Ensembl gene or transcript IDs. See example
#' of usage in tximeta vignette. For obtaining
#' multiple matching IDs for each row of the SummarizedExperiment
#' set \code{multiVals="list"}. See \code{select} for documentation
#' on use of \code{multiVals}.
#' 
#' @param se the SummarizedExperiment
#' @param column the name of the new ID to add (a \code{column} of the org package
#' database or of the TxDb/EnsDb is \code{fromDb=TRUE})
#' @param fromDb logical, whether to use the TxDb/EnsDb that is associated
#' with \code{se}. Default is FALSE, and an org package is used.
#' Currently only implemented for transcript level (gene=FALSE).
#' Column names can be viewed with \code{columns(retrieveDb(se))}
#' @param gene logical, whether to map by genes or transcripts (default is FALSE).
#' if rows are genes, and easily detected as such (ENSG or ENSMUSG), it will
#' automatically switch to TRUE. if rows are transcripts and \code{gene=TRUE},
#' then it will try to use a \code{gene_id} column to map IDs to \code{column}
#' @param ... arguments passed to \code{mapIds}
#'
#' @return a SummarizedExperiment
#'
#' @examples
#'
#' example(tximeta)
#' library(org.Dm.eg.db)	
#' se <- addIds(se, "REFSEQ", gene=FALSE)
#' 
#' @export
addIds <- function(se, column, fromDb=FALSE, gene=FALSE, ...) {
  missingMetadata(se, summarize=FALSE)
  keys <- rownames(se)
  if (!fromDb) {
    # works for GENCODE or Ensembl, or linkedTxomes with local GTF supplying the DB
    allowedSourceNames <- c("GENCODE","Ensembl","LocalGENCODE","LocalEnsembl")
    stopifnot(metadata(se)$txomeInfo$source %in% allowedSourceNames)
    # TODO probably should switch from package-based 'org.Hs.eg.db'
    # and instead obtain and load OrgDb through AnnotationHub
    dbname <- paste0("org.",
                     sub("(.).* (.).*","\\1\\2",metadata(se)$txomeInfo$organism),
                     ".eg.db")
    stopifnot(requireNamespace(dbname, quietly=TRUE))
    if (!isNamespaceLoaded(dbname)) attachNamespace(dbname)
    db <- get(dbname)
    if (!gene & grepl("ENSG|ENSMUSG",rownames(se)[1])) {
      message("it appears the rows are gene IDs, setting 'gene' to TRUE")
      gene <- TRUE
    }
    if (gene & grepl("ENST|ENSMUST",rownames(se)[1])) {
      message("gene=TRUE and rows are transcripts: using 'gene_id' column to map IDs")
      stopifnot("gene_id" %in% names(mcols(se)))
      keys <- mcols(se)$gene_id
    }
    keytype <- if (gene) "ENSEMBL" else "ENSEMBLTRANS"
    keys <- sub("\\..*","", keys)
  } else {
    if (gene) stop("fromDb=TRUE implemented only for gene=FALSE")
    db <- getTxDb(metadata(se)$txomeInfo)
    dbname <- class(db)
    keytype <- "TXNAME"
  }
  message(paste0("mapping to new IDs using ", dbname, "
if all matching IDs are desired, and '1:many mappings' are reported,
set multiVals='list' to obtain all the matching IDs"))
  newIds <- mapIds(db, keys, column, keytype, ...)
  mcols(se)[[column]] <- newIds
  se
}

#' Add exons to rowRanges of a transcript-level SummarizedExperiment
#'
#' After running \code{tximeta}, the \code{SummarizedExperiment} output
#' will have \code{GRanges} representing the transcript locations
#' attached as \code{rowRanges} to the object. These provide the
#' start and end of the transcript in the genomic coordiantes, and
#' strand information. However, the exonic locations are not provided.
#' This function, \code{addExons}, swaps out the \code{GRanges}
#' with a \code{GRangesList}, essentially a list along the rows of the
#' \code{SummarizedExperiment}, where each element of the list is a
#' \code{GRanges} providing the locations of the exons for that transcript.
#'
#' This function is designed only for transcript-level objects.
#' This "lack of a feature" reflects a belief on the part of the package author
#' that it makes more sense to think about exons belonging to transcripts
#' than to genes. For users desiring exonic information alongside
#' gene-level objects, for example, which exons are associated with
#' a particular gene, it is recommended to pull out the relevant
#' \code{GRangesList} for the transcripts of this gene, while the object
#' represents transcript-level data, such that the exons are still
#' associated with transcripts.
#'
#' For an example of \code{addExons}, please see the tximeta vignette.
#' 
#' @param se the SummarizedExperiment
#'
#' @return a SummarizedExperiment
#' @export
addExons <- function(se) {

  if (metadata(se)$level == "gene") {
    stop("addExons() is design for transcript-level SummarizedExperiments, see ?addExons")
  }
  missingMetadata(se, summarize=FALSE)

  txomeInfo <- metadata(se)$txomeInfo
  txdb <- getTxDb(txomeInfo)
  exons <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="exon")

  # need to add seqinfo for (some) GENCODE and RefSeq
  if (all(is.na(seqlengths(exons)))) {
    seqinfo(exons) <- seqinfo(se)
  }
  
  # check if all transcripts are present, and then subset
  stopifnot(all(rownames(se) %in% names(exons)))
  exons <- exons[rownames(se)]
  stopifnot(all(rownames(se) == names(exons)))

  # carry over the metadata from 'se'
  mcols(exons) <- mcols(se)
  # swap the rowRanges
  rowRanges(se) <- exons
  se
}

#' Add CDS to rowRanges of a transcript-level SummarizedExperiment
#'
#' Working similarly to \code{\link{addExons}}, this function
#' can be used to add information about CDS (coding sequence)
#' to the \code{SummarizedExperiment} object. As not all transcripts
#' are coding, we have CDS information for only a subset of the
#' rows of the object. For this reason, a logical indicator for
#' whether the transcript is coding, \code{mcols(se)$coding},
#' is added as a column to the metadata columns of the \code{rowRanges}
#' of the object. An additional column, \code{mcols(se)$cds},
#' is added to the metadata columns, which is a \code{GRangesList}
#' with either the CDS regions (if the transcript is coding),
#' or the original transcript/exon ranges (if the transcript is non-coding).
#' This is necessary, as \code{GRangesList} cannot have NA elements.
#' As with \code{\link{addExons}}, this function is designed only
#' for transcript-level objects.
#' 
#' @param se the SummarizedExperiment
#'
#' @return a SummarizedExperiment
#' @export
addCDS <- function(se) {

  if (metadata(se)$level == "gene") {
    stop("addCDS() is design for transcript-level SummarizedExperiments")
  }
  missingMetadata(se, summarize=FALSE)

  txomeInfo <- metadata(se)$txomeInfo
  txdb <- getTxDb(txomeInfo)
  cds <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="cds")

  # need to add seqinfo for (some) GENCODE and RefSeq
  if (all(is.na(seqlengths(cds)))) {
    seqinfo(cds) <- seqinfo(se)
  }

  cds.in.rows <- names(cds) %in% rownames(se)
  if (!all(cds.in.rows)) {
    stopifnot(any(cds.in.rows))
    message(paste(sum(!cds.in.rows),"CDS ranges not in rows of object, dropped"))
    cds <- cds[cds.in.rows]
  }
  idx <- rownames(se) %in% names(cds)

  # note whether the transcript is coding according to CDS entry
  mcols(se)$coding <- idx
  
  nms.se <- rownames(se)[idx]
  cds <- cds[nms.se]

  # fill in with transcript or exon ranges for all transcripts
  rngs <- rowRanges(se)
  if (!is(rngs, "GRangesList")) {
    rngs <- as(rngs, "GRangesList")
  }
  mcols(se)$cds <- rngs
  stopifnot(all(rownames(se)[idx] == names(cds)))

  message("adding CDS ranges for coding transcripts, original ranges for non-coding.
see ?addCDS for more information about how CDS ranges are added")

  # add CDS ranges when the transcript is coding
  mcols(se)$cds[idx] <- cds
  
  se
}

context("tximeta")
test_that("tximeta works as expected", {

  dir <- system.file("extdata/salmon_dm", package="tximportData")
  files <- file.path(dir, "SRR1197474", "quant.sf") 
  coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)
  
  indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
  fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
                "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
  
  gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
  makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
                  release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)

  # TODO why not throwing warnings on Bioc
  #expect_warning({se <- tximeta(coldata)}, "annotation is missing")
  se <- tximeta(coldata)

  # check adding IDs
  library(org.Dm.eg.db)
  se <- addIds(se, column="SYMBOL")
  
  # check adding IDs from TxDb/EnsDb (commented out due to Ahub/EnsDb issue)
  # se <- addIds(se, column="SYMBOL", fromDb=TRUE)
  
  # check adding CDS
  library(SummarizedExperiment)
  se2 <- addCDS(se)
  
  # check adding exons
  se <- addExons(se)

  # check adding CDS on exons
  se <- addCDS(se)

  # check summarize to gene
  gse <- summarizeToGene(se)
  expect_error(addExons(gse), "transcript-level")

  # check adding IDs
  library(org.Dm.eg.db)
  gse <- addIds(gse, "REFSEQ", gene=TRUE)

  # check retrieving the database
  edb <- retrieveDb(se)

  # check retrieving the cDNA sequence
  if (FALSE) {
    # this requires access to Ensembl ftp
    cdna <- retrieveCDNA(se)
  }
  
  # just a vector of file paths is ok...
  # TODO why not throwing warnings on Bioc
  #expect_warning({se <- tximeta(files)})
  se <- tximeta(files)

  # check error on txOut=FALSE
  expect_error({se <- tximeta(coldata, txOut=FALSE)},
               "transcript-level output")

  # check skipping metadata, appropriate warnings
  se <- tximeta(coldata, skipMeta=TRUE)
  expect_error({summarizeToGene(se)}, "transcriptome metadata")
  expect_error({addIds(se)}, "transcriptome metadata")

  # check customMetaInfo
  se <- tximeta(coldata, customMetaInfo="aux_info/meta_info.json")
  expect_error(tximeta(coldata, customMetaInfo="foobar.json"),
               "metadata files are missing")

  # check make DGEList
  library(edgeR)
  y <- makeDGEList(se)
  
})

test_that("tximeta can import GENCODE and Ensembl", {

  if (FALSE) {

    ### GENCODE ###
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"salmon", samples$run, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))

    # with AnnotationHub (default)
    se <- tximeta(coldata)
    gse <- summarizeToGene(se)

    # check adding IDs from TxDb/EnsDb
    se <- addIds(se, column="TXTYPE", fromDb=TRUE)
    
    # without AnnotationHub
    se <- tximeta(coldata, useHub=FALSE)

    ### Ensembl ###
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"salmon_gibbs", samples$run, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))

    # with AnnotationHub (default)
    se <- tximeta(coldata, dropInfReps=TRUE, useHub=TRUE)
    
    # without AnnotationHub
    se <- tximeta(coldata, dropInfReps=TRUE, useHub=FALSE)

    gse <- summarizeToGene(se)

    # test the mark duplicate code
    
    dir <- system.file("extdata", package="macrophage")
    samples <- list.files(file.path(dir, "quants"))[1:3]
    files <- file.path(dir,"quants", samples, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:3))

    se <- tximeta(coldata, dropInfReps=TRUE, markDuplicateTxps=TRUE)
    gse <- summarizeToGene(se)
    
  }

})

test_that("tximeta can import inferential replicates", {

  # don't want to rely on internet connection for tests...
  if (FALSE) {
    library(SummarizedExperiment)

    # check the GEUVADIS samples with Salmon Gibbs samples
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"salmon_gibbs", samples$run, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))
    se <- tximeta(coldata)
    expect_true("infRep1" %in% assayNames(se))

    se2 <- tximeta(coldata, varReduce=TRUE)
    expect_true("variance" %in% assayNames(se2))

    gse <- summarizeToGene(se)
    expect_true("infRep1" %in% assayNames(gse))

    gse <- summarizeToGene(se, varReduce=TRUE)
    expect_true("variance" %in% assayNames(gse))

    # check the macrophage dataset with Salmon Gibbs samples
    dir <- system.file("extdata", package="macrophage")
    coldata <- read.csv(file.path(dir, "coldata.csv"))
    coldata$files <- file.path(dir, "quants", coldata$names, "quant.sf.gz")
    coldata <- coldata[1:2,]
    se <- tximeta(coldata)
    se <- tximeta(coldata, skipSeqinfo=TRUE)
    
  }
  
})

test_that("tximeta can import alevin", {

  dir <- system.file("extdata", package="tximportData")
  samps <- list.files(file.path(dir, "alevin"))
  files <- file.path(dir,"alevin",samps[1],"alevin/quants_mat.gz")
  file.exists(files)
  coldata <- data.frame(files, names="neurons")

  #se <- tximeta(coldata, type="alevin")
  se <- tximeta(coldata, type="alevin", skipMeta=TRUE)
  
})

test_that("tximeta can import refseq", {

  if (FALSE) {
    dir <- system.file("extdata", package="tximportData")
    files <- file.path(dir,"refseq/ERR188021/quant.sf.gz")
    file.exists(files)
    coldata <- data.frame(files, names="A")

    # here the important test is if we can pull down seqinfo
    # (sequence names and lengths) from RefSeq FTP site
    se <- tximeta(coldata)
    seqinfo(se)
  }
    
})

test_that("tximeta can import kallisto", {

  if (requireNamespace(package="rhdf5", quietly=TRUE)) {
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"kallisto", samples$run, "abundance.tsv.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))
    se <- tximeta(coldata, type="kallisto", txOut=TRUE)
    
    # inferential replicates as well
    library(SummarizedExperiment)
    files <- file.path(dir,"kallisto_boot", samples$run, "abundance.h5")
    coldata <- data.frame(files, names=paste0("sample",1:6))
    se <- tximeta(coldata, type="kallisto", txOut=TRUE)
    expect_true("infRep1" %in% assayNames(se))
    se <- tximeta(coldata, type="kallisto", txOut=TRUE, varReduce=TRUE)
    expect_true("variance" %in% assayNames(se))
  }
  
})

context("tximeta")
test_that("tximeta works as expected", {

  dir <- system.file("extdata/salmon_dm", package="tximportData")
  files <- file.path(dir, "SRR1197474", "quant.sf") 
  coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)
  
  indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
  fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
                "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
  
  gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
  makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
                  release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)

  # TODO not throwing warnings on Bioc machines?
  expect_warning({se <- tximeta(coldata)}, "the annotation is missing")
  #se <- tximeta(coldata)

  # check adding IDs
  library(org.Dm.eg.db)
  se <- addIds(se, column="SYMBOL")
  
  # check adding IDs from TxDb/EnsDb (commented out due to Ahub/EnsDb issue)
  # se <- addIds(se, column="SYMBOL", fromDb=TRUE)
  
  # check adding CDS
  library(SummarizedExperiment)
  se_cds <- addCDS(se)
  
  # check adding exons
  se_exons <- addExons(se)

  # check adding CDS on exons
  se_cds <- addCDS(se)

  # check summarize to gene
  gse <- summarizeToGene(se)
  expect_error(addExons(gse), "transcript-level")

  gseAbndt <- summarizeToGene(se, assignRanges="abundant")

  gseAbndt <- summarizeToGene(se_exons, assignRanges="abundant")
  
  # check adding IDs
  library(org.Dm.eg.db)
  gse <- addIds(gse, "REFSEQ", gene=TRUE)

  # check retrieving the database
  edb <- retrieveDb(se)

  # check retrieving the cDNA sequence
  if (FALSE) {
    # this requires access to Ensembl ftp
    cdna <- retrieveCDNA(se)
  }
  
  expect_warning({se <- tximeta(files)}, "the annotation is missing")

  # check error on txOut=FALSE
  expect_error({se <- tximeta(coldata, txOut=FALSE)},
               "transcript-level output")

  # check skipping metadata, appropriate warnings
  se <- tximeta(coldata, skipMeta=TRUE)
  expect_error({summarizeToGene(se)}, "transcriptome metadata")
  expect_error({addIds(se)}, "transcriptome metadata")

  # check customMetaInfo
  expect_warning(
    {se <- tximeta(coldata, customMetaInfo="aux_info/meta_info.json")}, 
    "the annotation is missing"
  )
  expect_error(tximeta(coldata, customMetaInfo="foobar.json"),
               "metadata files are missing")

  # check make DGEList
  library(edgeR)
  y <- makeDGEList(se)
  
})

test_that("tximeta can import GENCODE and Ensembl", {

  # breaks with no internet
  if (FALSE) {

    ### GENCODE ###
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"salmon", samples$run, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))

    # with AnnotationHub (default)
    se <- tximeta(coldata)
    expect_true(metadata(se)$txomeInfo$source == "GENCODE")
    
    gse <- summarizeToGene(se)

    # check adding IDs from TxDb/EnsDb
    se <- addIds(se, column="TXTYPE", fromDb=TRUE)
    
    # without AnnotationHub
    se <- tximeta(coldata, useHub=FALSE)

    # chr_patch_hapl_scaff = comprehensive gene annotation on ALL regions (GENCODE)
    se <- tximeta(coldata, useHub=FALSE, gencode_gtf_prefix="chr_patch_hapl_scaff")
    expect_true(metadata(se)$txomeInfo$source == "GENCODE")

    ### Ensembl ###
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"salmon_gibbs", samples$run, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))

    # with AnnotationHub (default)
    se <- tximeta(coldata, dropInfReps=TRUE, useHub=TRUE)
    
    # without AnnotationHub
    se <- tximeta(coldata, dropInfReps=TRUE, useHub=FALSE)

    gse <- summarizeToGene(se)

    # test the mark duplicate code
    
    dir <- system.file("extdata", package="macrophage")
    samples <- list.files(file.path(dir, "quants"))[1:3]
    files <- file.path(dir,"quants", samples, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:3))

    se <- tximeta(coldata, dropInfReps=TRUE, markDuplicateTxps=TRUE)
    gse <- summarizeToGene(se)
    
  }

})

test_that("tximeta can import inferential replicates", {

  # breaks with no internet
  if (FALSE) {
    library(SummarizedExperiment)

    # check the GEUVADIS samples with Salmon Gibbs samples
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"salmon_gibbs", samples$run, "quant.sf.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))
    se <- tximeta(coldata)
    expect_true("infRep1" %in% assayNames(se))

    se2 <- tximeta(coldata, varReduce=TRUE)
    expect_true("variance" %in% assayNames(se2))

    gse <- summarizeToGene(se)
    expect_true("infRep1" %in% assayNames(gse))

    gse <- summarizeToGene(se, varReduce=TRUE)
    expect_true("variance" %in% assayNames(gse))

    # check the macrophage dataset with Salmon Gibbs samples

    dir <- system.file("extdata", package="macrophage")
    coldata <- read.csv(file.path(dir, "coldata.csv"))
    coldata$files <- file.path(dir, "quants", coldata$names, "quant.sf.gz")
    coldata <- coldata[1:2,]
    se <- tximeta(coldata)
    se <- tximeta(coldata, skipSeqinfo=TRUE)
    
  }
  
})

# refseq GTF files can't be imported by txdbmaker::makeTxDbFromGFF (August 2025)...
# so then tximeta won't really work anymore

# test_that("tximeta can import refseq", {
#     dir <- system.file("extdata", package="tximportData")
#     files <- file.path(dir,"refseq/ERR188021/quant.sf.gz")
#     file.exists(files)
#     coldata <- data.frame(files, names="A")
#     # here the important test is if we can pull down seqinfo
#     # (sequence names and lengths) from RefSeq FTP site
#     se <- tximeta(coldata)
#     seqinfo(se)
# })

test_that("tximeta can import kallisto", {

  # test requires rhdf5...
  if (FALSE) {
    dir <- system.file("extdata", package="tximportData")
    samples <- read.table(file.path(dir,"samples.txt"), header=TRUE)
    files <- file.path(dir,"kallisto", samples$run, "abundance.tsv.gz")
    coldata <- data.frame(files, names=paste0("sample",1:6))
    se <- tximeta(coldata, type="kallisto", txOut=TRUE)
    
    # inferential replicates as well
    library(SummarizedExperiment)
    files <- file.path(dir,"kallisto_boot", samples$run, "abundance.h5")
    coldata <- data.frame(files, names=paste0("sample",1:6))
    se <- tximeta(coldata, type="kallisto", txOut=TRUE)
    expect_true("infRep1" %in% assayNames(se))
    se <- tximeta(coldata, type="kallisto", txOut=TRUE, varReduce=TRUE)
    expect_true("variance" %in% assayNames(se))
  }
  
})

.onLoad <- function(libname, pkgname, ...) {

  envBFCLoc <- Sys.getenv("TXIMETA_HUB_CACHE")
  if (envBFCLoc != "") {
    bfcLoc <- getTximetaBFC()
    if (is.null(bfcLoc) || envBFCLoc != bfcLoc) {
      setTximetaBFC(envBFCLoc, quiet=TRUE)
    }
  }
  
}

makeDuplicateTxpsList <- function(txomeInfo) {
  dup.list.id <- paste0("dups-",substr(txomeInfo$sha256,1,32))
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  q <- bfcquery(bfc, dup.list.id)
  if (bfccount(q) == 1) {
    loadpath <- bfcrpath(bfc, dup.list.id)
    dup.list <- readRDS(loadpath)
    stopifnot(is(dup.list, "CharacterList"))
  } else {
    # download the cDNA from remote source (or load from cache)
    dna <- retrieveCDNA(txomeInfo, quiet=TRUE)
    if (txomeInfo$source == "Ensembl") {
      testTxp <- names(dna)[1]
      if (grepl("ENST|ENSMUST",testTxp)) {
        # for human and mouse, need to split on version number
        # (GTF has no version in txname, while FASTA has versions)
        names(dna) <- sub("\\..*", "", names(dna))
      } else {
        names(dna) <- sub(" .*", "", names(dna))
      }
    } else if (txomeInfo$source == "GENCODE") {
      names(dna) <- sub("\\|.*", "", names(dna))
    }
    # which are duplicated based on DNA sequence
    dups <- duplicated(dna)
    if (sum(dups) == 0) {
      dup.list <- NULL
    } else {
      # index of all seqs that participate in a dup
      all.dups <- dna %in% dna[dups]
      nms.all.dups <- names(dna)[all.dups]
      seq.all.dups <- as.character(dna[all.dups])
      dup.list <- split(nms.all.dups, seq.all.dups)
      names(dup.list) <- NULL
      dup.list <- CharacterList(dup.list)
    }
    # save it to BFC so as not to repeat the above operation
    savepath <- bfcnew(bfc, dup.list.id, ext=".rds")
    saveRDS(dup.list, file=savepath)
  }
  dup.list
}

makeDuplicateTxpsTable <- function(missing.txps, dup.list, txp.nms) {
  # dup.list is a list of the duplicate txps, according to the FASTA
  all.dups <- unlist(dup.list)

  # we want to try to fix those duplicate txps that are
  # in rownames of the assays but not in `txps`
  dups.to.fix <- intersect(all.dups, missing.txps)
  dups.to.fix.list <- LogicalList(split(all.dups %in% dups.to.fix, rep(seq_along(dup.list), lengths(dup.list))))
  dup.list <- dup.list[any(dups.to.fix.list)]
  dups.to.fix.list <- dups.to.fix.list[any(dups.to.fix.list)]
  names(dups.to.fix.list) <- NULL

  # if we have a set of duplicates where > 1 is in the rownames of assays,
  # this is unexpected (Salmon should have combined these)
  # and we pass on fixing this
  more.than.one <- sapply(dups.to.fix.list, sum) > 1
  dup.list <- dup.list[!more.than.one]
  dups.to.fix.list <- dups.to.fix.list[!more.than.one]

  # now we can name the duplicate sets by the missing txp
  names(dup.list) <- dup.list[dups.to.fix.list]
  all.dups <- unlist(dup.list)
  
  # is there an alternative in `txps`?
  dups.with.alt <- intersect(all.dups, txp.nms)
  dups.with.alt.list <- LogicalList(split(all.dups %in% dups.with.alt, rep(seq_along(dup.list), lengths(dup.list))))
  dup.list <- dup.list[any(dups.with.alt.list)]
  dups.with.alt.list <- dups.with.alt.list[any(dups.with.alt.list)]

  # pull out the alts
  names(dups.with.alt.list) <- names(dup.list)
  alts <- dup.list[dups.with.alt.list]

  # no reason to prefer one since they are all in `txps`
  alts <- sapply(alts, `[`, 1)
  stopifnot(all(alts %in% txp.nms))

  # return a table for the txp name swap
  dup.table <- data.frame(dups.to.fix=names(alts),
                          alts=unname(alts),
                          stringsAsFactors=FALSE)
  dup.table
}

#' Make a DGEList from tximeta output
#'
#' A simple wrapper function for constructing a DGEList for use with edgeR.
#' See vignette for an example. Requires installation of the edgeR
#' package from Bioconductor.
#'
#' @param se a SummarizedExperiment produced by tximeta
#'
#' @return a DGEList
#'
#' @export
makeDGEList <- function(se) {
  if (!requireNamespace("edgeR", quietly=TRUE)) {
    stop("this function requires the edgeR package is installed")
  }
  cts <- assays(se)[["counts"]]
  normMat <- assays(se)[["length"]]
  normMat <- normMat / exp(rowMeans(log(normMat)))
  o <- log(edgeR::calcNormFactors(cts/normMat)) + log(colSums(cts/normMat))
  y <- edgeR::DGEList(cts, samples=as.data.frame(colData(se)),
                      genes=as.data.frame(rowData(se)))
  y <- edgeR::scaleOffset(y, t(t(log(normMat)) + o))
  y
}

# identify the txome based on the digest
# - first look into the linkedTxomeTbl or linkedTxpDataTbl
# - secondly look into the pre-computed hash table in `extdata`
getTxomeInfo <- function(digest, prefer=c("txome","txpdata","precomputed"), quiet=FALSE) {
  stopifnot(all(prefer %in% c("txome","txpdata","precomputed")))
  # look through these registries in the preferred order
  for (which_registry in prefer) {
    if (which_registry %in% c("txome","txpdata")) {
      txomeInfo <- findDigestMatch(digest, which_registry, quiet)
    } else {
      txomeInfo <- findDigestMatchPrecomputed(digest, quiet)
    }
    # a non-null returned value indicates a match, return the txomeInfo
    if (!is.null(txomeInfo))
      return(txomeInfo)
  }  
  # at the end, return NULL = no match in any registry
  return(NULL)
}

findDigestMatch <- function(digest, which_registry, quiet) {
  type <- c(txome="Txome", txpdata="TxpData")[which_registry]
  stopifnot(type %in% c("Txome","TxpData"))
  bfc <- BiocFileCache(getBFCLoc())
  linkedName <- paste0("linked",type,"Tbl")
  q <- bfcquery(bfc, linkedName)
  # there should only be one such entry in the tximeta bfc
  stopifnot(bfccount(q) < 2)
  if (bfccount(q) == 1) {
    # first check linkedTxome/TxpData, which should take priority over pre-computed
    loadpath <- bfcrpath(bfc, rnames=linkedName)
    linkedTbl <- readRDS(loadpath)
    if (type == "Txome") {
      m <- match(digest, linkedTbl$sha256)
    } else if (type == "TxpData") {
      m <- match(digest, linkedTbl$digest)
    } else {
      stop("type must be one of Txome or TxpData")
    }
    if (length(m) > 1) {
      if (!quiet)
        message("found multiple matching digests, using first match")
      m <- m[1]
    }
    if (!is.na(m)) {
      txomeInfo <- as.list(linkedTbl[m,])
      txomeInfo$linkedTxome <- type == "Txome"
      txomeInfo$linkedTxpData <- type == "TxpData"
      if (!quiet) {
        message(paste0("found matching linked",type,":\n[ ",
                txomeInfo$source, " - ", txomeInfo$organism,
                " - release ", txomeInfo$release," ]"))
      }
      return(txomeInfo)
    } else {
      # no matching digest
      return(NULL)
    }
  }
  # no linked table yet
  return(NULL)
}

findDigestMatchPrecomputed <- function(digest, quiet) {
  hashfile <- file.path(system.file("extdata",package="tximeta"),"hashtable.csv")
  hashtable <- read.csv(hashfile,stringsAsFactors=FALSE)
  m <- match(digest, hashtable$sha256)
  if (!is.na(m)) {
    # now we can go get the GTF to annotate the ranges
    txomeInfo <- as.list(hashtable[m,])
    if (grepl(" ", txomeInfo$fasta)) {
      txomeInfo$fasta <- strsplit(txomeInfo$fasta, " ")
    }
    txomeInfo$linkedTxome <- FALSE
    txomeInfo$linkedTxpData <- FALSE
    if (!quiet) {
      message(paste0("found matching transcriptome:\n[ ",
                     txomeInfo$source, " - ", txomeInfo$organism,
                     " - release ", txomeInfo$release," ]"))
    }
    return(txomeInfo)
  }
  # no match in the pre-computed hash table
  return(NULL)
}

# build or load a TxDb/EnsDb for the dataset
# useHub = whether to look in AnnotationHub for a resoruce
# skipFtp = whether to replace `ftp` with `https`
getTxDb <- function(txomeInfo, useHub=TRUE, skipFtp=FALSE) {
  stopifnot(length(txomeInfo$gtf) == 1)
  stopifnot(txomeInfo$gtf != "")
  if (skipFtp) {
    txomeInfo$gtf <- sub("ftp://","https://",txomeInfo$gtf)
  }
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  txdbName <- basename(txomeInfo$gtf)
  q <- locateTxDb(txomeInfo, bfc)
  ### No TxDb was found in the BiocFilecache ###
  if (bfccount(q) == 0) {
    hubSources <- c("Ensembl","GENCODE")
    srcName <- txomeInfo$source
    hubWorked <- FALSE
    # Ensembl and GENCODE, no match in BFC
    if (srcName %in% hubSources) {
      ensSrc <- srcName == "Ensembl"
      dbType <- if (ensSrc) "EnsDb" else "TxDb"
      if (useHub) {
        txdb <- checkViaAHub(txomeInfo, srcName, ensSrc, dbType)
        hubWorked <- !is.null(txdb)
      }
      # if check on AnnotationHub failed (or wasn't attempted)
      if (!hubWorked) {
        # build db for Ensembl
        if (ensSrc) {
          txdb <- buildTxDbForEnsembl(txomeInfo, bfc, txdbName)
        }
      }
    }
    # two cases left:
    #   1. Neither Ensembl or GENCODE source
    #   2. GENCODE source but AHub didn't work
    # ...then build a TxDb with txdbmaker
    if ((!srcName %in% hubSources) | (srcName == "GENCODE" & !hubWorked)) {
      txdb <- buildTxDbFromGTF(txomeInfo, bfc, txdbName)
    }
  } else {
    ### Yes, a TxDb was found in the BiocFilecache ###
    txdb <- loadTxDbFromBFC(txomeInfo, bfc, txdbName, q)
  }
  txdb
}

locateTxDb <- function(txomeInfo, bfc) {
  txdbName <- basename(txomeInfo$gtf)
  # look up txdbName
  q <- bfcquery(bfc, txdbName)
  # filter for equality with rname
  q[q$rname==txdbName,]
}

checkViaAHub <- function(txomeInfo, srcName, ensSrc, dbType) {
  # first check for database on AnnotationHub
  message(paste("useHub=TRUE: checking for", dbType, "via 'AnnotationHub'"))
  ah <- AnnotationHub()
  # get records
  records <- query(ah, c(srcName, txomeInfo$organism, txomeInfo$release))
  # confirm source, organism, dbType through metadata columns
  records <- records[records$dataprovider==srcName &
    records$species==txomeInfo$organism &
    records$rdataclass==dbType,]        
    if (ensSrc) {
      # Confirm release number through grep on the title
      # EnsDb record titles look like "Ensembl 123 EnsDb for Homo sapiens"
      records <- records[grepl(paste(srcName, txomeInfo$release, dbType), records$title),]
    } else {
      # Narrow records based on the genome coordinates
      # GENCODE record titles look like "TxDb for Gencode v123 on hg38 coordinates"
      coords <- genome2UCSC(txomeInfo$genome)
      records <- records[grepl(coords, records$title),]
    }
    if (length(records) == 1) {
      message(paste("found matching", dbType, "via 'AnnotationHub'"))
      txdb <- ah[[names(records)]]
      bfcadd(bfc, rname=txdbName, fpath=dbfile(dbconn(txdb)))
    } else {
      message(paste("did not find matching", dbType, "via 'AnnotationHub'"))
      txdb <- NULL
    }
  txdb
}

buildTxDbForEnsembl <- function(txomeInfo, bfc, txdbName) {
  message("building EnsDb with 'ensembldb' package")
  # split code based on whether linkedTxome (bc GTF filename may be modified)
  if (!txomeInfo$linkedTxome) {
    # TODO what about suppressing all these warnings
    suppressWarnings({
      savepath <- ensDbFromGtf(
        txomeInfo$gtf,
        outfile = bfcnew(bfc, rname=txdbName, ext=".sqlite")
      )
    })
  } else {
    message(paste0(
      "NOTE: linkedTxome with source='Ensembl', ensembldb will be used to parse GTF.\n",
      ". this may produce errors if the GTF is not from Ensembl, or has been modified"
    ))
    # for linkedTxome, because the GTF filename may be modified
    # we manually provide organism, genomeVersion, and version
    suppressWarnings({
      savepath <- ensDbFromGtf(
        txomeInfo$gtf,
        outfile = bfcnew(bfc, rname=txdbName, ext=".sqlite"),
        organism = txomeInfo$organism,
        genomeVersion = txomeInfo$genome,
        version = txomeInfo$release
      )
    })
  }
  txdb <- EnsDb(savepath)
  txdb
}

buildTxDbFromGTF <- function(txomeInfo, bfc, txdbName) {
  message("building TxDb with 'txdbmaker' package")
  # allow .rds instead of GTF
  if (tools::file_ext(txomeInfo$gtf) == "rds") {
    gtf2gr <- readRDS(txomeInfo$gtf)
    txdb <- makeTxDbFromGRanges(gtf2gr)
  } else {
    # the typical case: parse the GTF
    txdb <- makeTxDbFromGFF(txomeInfo$gtf)
  }
  saveDb(
    txdb,
    file = bfcnew(bfc, rname=txdbName, ext=".sqlite")
  )
  txdb
}

loadTxDbFromBFC <- function(txomeInfo, bfc, txdbName, q) {
  loadpath <- bfcrpath(bfc, rnames=txdbName)
  # check the file exists at the loadpath
  if (!file.exists(loadpath))
  stop(paste0(
    "A match was found in the digest table for this SE object,\n",
    "  but a Db not found at expected location:",
    "\n  ", loadpath
  ))
  if (txomeInfo$source == "Ensembl") {
    message(paste("loading existing EnsDb created:", q$create_time[1]))
    txdb <- ensembldb::EnsDb(loadpath)
  } else {
    message(paste("loading existing TxDb created:", q$create_time[1]))
    txdb <- AnnotationDbi::loadDb(loadpath)
  }
  txdb
}

hashit <- function(source, organism, release, catNC=FALSE, ...) {

  if (source == "GENCODE") {
    if (organism == "Homo sapiens") {
      fasta <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_human/release_",
                      release,"/gencode.v",release,".transcripts.fa.gz")
      gtf <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_human/release_",
                    release,"/gencode.v",release,".annotation.gtf.gz")
      genome <- "GRCh38"
    }
    if (organism == "Mus musculus") {
      fasta <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_",
                      release,"/gencode.v",release,".transcripts.fa.gz")
      gtf <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_",
                    release,"/gencode.v",release,".annotation.gtf.gz")
      genome <- "GRCm38"
    }
  }
  
  if (source == "Ensembl") {
    org <- sub(" ","_",tolower(organism))
    org_upper <- sub(" ","_",organism)
    genome <- if (organism == "Homo sapiens") {
                "GRCh38"
              } else if (organism == "Mus musculus") {
                if (as.numeric(release) >= 103) {
                  "GRCm39"
                } else {
                  "GRCm38"
                }
              } else if (organism == "Drosophila melanogaster") {
                if (as.numeric(release) >= 103) {
                  "BDGP6.32"
                } else if (as.numeric(release) >= 99) {
                  "BDGP6.28"
                } else if (as.numeric(release) >= 96) {
                  "BDGP6.22"
                } else {
                  "BDGP6"
                }
              } 
  
    fasta <- paste0("ftp://ftp.ensembl.org/pub/release-",
                    release,"/fasta/",org,"/cdna/",org_upper,".",genome,".cdna.all.fa.gz")
    if (catNC) {
      nc <- paste0("ftp://ftp.ensembl.org/pub/release-",
                   release,"/fasta/",org,"/ncrna/",org_upper,".",genome,".ncrna.fa.gz")
      fasta <- c(fasta, nc)
    }
    gtf <- paste0("ftp://ftp.ensembl.org/pub/release-",
                  release,"/gtf/",org,"/",org_upper,".",genome,".",release,".gtf.gz")

  }

  if (source == "RefSeq") {
    org_upper <- sub(" ","_",organism)
    chop <- function(x) as.numeric(sub(".*\\.p","",x))
    if (organism == "Homo sapiens") {
      genome <- "GRCh38"
      release_num <- chop(release) + 26
      gcf <- "GCF_000001405"
    } else if (organism == "Mus musculus") {
      genome <- "GRCm38"
      release_num <- chop(release) + 20
      gcf <- "GCF_000001635"
    }
    fasta <- paste0("ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/vertebrate_mammalian/",org_upper,
                    "/all_assembly_versions/",gcf,".",release_num,"_",release,"/",
                    gcf,".",release_num,"_",release,"_rna.fna.gz")
    gtf <- paste0("ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/vertebrate_mammalian/",org_upper,
                  "/all_assembly_versions/",gcf,".",release_num,"_",release,"/",
                  gcf,".",release_num,"_",release,"_genomic.gff.gz")
  }

  #message(fasta)
  #message(gtf)
  
  stopifnot(all(sapply(fasta, RCurl::url.exists)))
  stopifnot(RCurl::url.exists(gtf))
  if (catNC) {
    for (f in fasta) {
      download.file(f, basename(f), ...)
    }
    system(paste("cat",paste(basename(fasta),collapse=" "),"> transcripts.fa.gz"))
    for (f in fasta) {
      system(paste("rm -f",basename(f)))
    }
  } else {
    download.file(fasta, "transcripts.fa.gz", ...)
  }
  system("gunzip transcripts.fa.gz")
  system("compute_fasta_digest --reference transcripts.fa --out hash.json")
  sha256 <- jsonlite::fromJSON("hash.json")$seq_hash
  df <- data.frame(source, organism, release, genome, paste(fasta, collapse=" "), gtf, sha256)
  write.table(df, file="newrows.csv", append=TRUE, quote=FALSE, sep=",", row.names=FALSE, col.names=FALSE)
  system("rm -f transcripts.fa")
  system("rm -f hash.json")
  message("done!")
}

# download method
m <- "wget"

i <- 42
hashit("GENCODE", "Homo sapiens", i, method=m)
i <- 31
hashit("GENCODE", "Mus musculus", paste0("M",i), method=m)
#
i <- 108
hashit("Ensembl", "Homo sapiens", i, method=m)
hashit("Ensembl", "Mus musculus", i, method=m)
hashit("Ensembl", "Drosophila melanogaster", i, method=m)
#
hashit("Ensembl", "Homo sapiens", i, catNC=TRUE, method=m)
hashit("Ensembl", "Mus musculus", i, catNC=TRUE, method=m)
hashit("Ensembl", "Drosophila melanogaster", i, catNC=TRUE, method=m)
#
# RefSeq permalink transcriptomes are rarely updated
# hashit("RefSeq", "Homo sapiens", paste0("GRCh38.p",i), method=m)
# hashit("RefSeq", "Mus musculus", paste0("GRCm38.p",i), method=m)

summarizeToGene.SummarizedExperiment <- function(object, varReduce=FALSE, ...) {

  missingMetadata(object, summarize=TRUE)

  txomeInfo <- metadata(object)$txomeInfo
  txdb <- getTxDb(txomeInfo)
  message("obtaining transcript-to-gene mapping from database")

  suppressMessages({
    tx2gene <- select(txdb, keys(txdb, "TXNAME"), "GENEID", "TXNAME")
  })

  # TODO what to do about warnings about out-of-bound ranges? pass along somewhere?
  suppressWarnings({
    g <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="gene")
  })

  # need to add seqinfo for GENCODE and RefSeq
  if (all(is.na(seqlengths(g)))) {
    seqinfo(g) <- seqinfo(object)
  }
  
  txi <- list(
    abundance=assays(object)[["abundance"]],
    counts=assays(object)[["counts"]],
    length=assays(object)[["length"]],
    countsFromAbundance="no"
  )
  if ("infRep1" %in% assayNames(object)) {
    infReps <- list(assays(object)[grep("infRep", assayNames(object))])
    if (varReduce) {
      # split from per replicate list into per sample list
      # (this is what tximport expects for varReduce=TRUE)
      infReps <- list(splitInfReps(infReps[[1]]))
    }
    txi <- c(txi, infReps=infReps)
  } else {
    if (varReduce) stop("cannot calculate inferential variance without inferential replicates")
  }

  txi.gene <- summarizeToGene(object=txi, tx2gene=tx2gene, varReduce=varReduce, ...)
  
  # put 'counts' in front to facilitate DESeqDataSet construction
  assays <- txi.gene[c("counts","abundance","length")]
  if (varReduce) {
    assays <- c(assays, txi.gene["variance"])
  } else if ("infRep1" %in% assayNames(object)) {
    infReps <- txi.gene$infReps
    assays <- c(assays, infReps)
  }

  # here do the same check/subset but with the gene-level
  # tximport assay matrices and gene ranges
  assays <- checkAssays2Txps(assays, g)

  # TODO give a warning here if there are genes in TxDb not in Salmon index?
  g <- g[rownames(assays[["counts"]])]

  # store txp IDS
  tx_ids <- CharacterList(split(tx2gene$TXNAME, tx2gene$GENEID))
  if (all(names(g) %in% names(tx_ids))) {
    tx_ids <- tx_ids[names(g)]
    mcols(g)$tx_ids <- tx_ids
  }
  
  # calculate duplication
  if ("hasDuplicate" %in% colnames(mcols(object))) {
    stopifnot(all(rownames(object) %in% tx2gene[,1]))
    t2g.o <- tx2gene[match(rownames(object),tx2gene[,1]),]
    has.dup.list <- LogicalList(split(mcols(object)$hasDuplicate, t2g.o$GENEID))
    mcols(g)$numDupObjects <- sum(has.dup.list)
  }
  
  metadata <- metadata(object)
  # stash countsFromAbundance value
  metadata$countsFromAbundance <- txi.gene$countsFromAbundance
  metadata$level <- "gene"
  
  gse <- SummarizedExperiment(assays=assays,
                              rowRanges=g,
                              colData=colData(object),
                              metadata=metadata)  
  gse
}

#' Summarize estimated quantitites to gene-level
#'
#' Summarizes abundances, counts, lengths, (and inferential
#' replicates or variance) from transcript- to gene-level.
#' Transcript IDs are stored as a CharacterList in the \code{mcols}
#' of the output object.
#' This function operates on SummarizedExperiment objects, and
#' will automatically access the relevant TxDb (by either finding it
#' in the BiocFileCache or by building it from an ftp location).
#' This function uses the tximport package to perform summarization,
#' where a method is defined that works on simple lists.
#'
#' @param object a SummarizedExperiment produced by \code{tximeta}
#' @param varReduce whether to reduce per-sample inferential replicates
#' information into a matrix of sample variances \code{variance} (default FALSE)
#' @param ... arguments passed to \code{tximport}
#'
#' @return a SummarizedExperiment with summarized quantifications
#' and transcript IDs as a CharacterList in the \code{mcols}
#'
#' @rdname summarizeToGene
#' @docType methods
#' @aliases summarizeToGene,SummarizedExperiment-method
#' 
#' @examples
#'
#' example(tximeta)
#' gse <- summarizeToGene(se)
#'
#' @importFrom tximport summarizeToGene
#' 
#' @export
setMethod("summarizeToGene", signature(object="SummarizedExperiment"),
          summarizeToGene.SummarizedExperiment)

#' Add exons to rowRanges of a transcript-level SummarizedExperiment
#'
#' After running \code{tximeta}, the \code{SummarizedExperiment} output
#' will have \code{GRanges} representing the transcript locations
#' attached as \code{rowRanges} to the object. These provide the
#' start and end of the transcript in the genomic coordiantes, and
#' strand information. However, the exonic locations are not provided.
#' This function, \code{addExons}, swaps out the \code{GRanges}
#' with a \code{GRangesList}, essentially a list along the rows of the
#' \code{SummarizedExperiment}, where each element of the list is a
#' \code{GRanges} providing the locations of the exons for that transcript.
#'
#' This function is designed only for transcript-level objects.
#' This "lack of a feature" reflects a belief on the part of the package author
#' that it makes more sense to think about exons belonging to transcripts
#' than to genes. For users desiring exonic information alongside
#' gene-level objects, for example, which exons are associated with
#' a particular gene, it is recommended to pull out the relevant
#' \code{GRangesList} for the transcripts of this gene, while the object
#' represents transcript-level data, such that the exons are still
#' associated with transcripts.
#'
#' For an example of \code{addExons}, please see the tximeta vignette.
#' 
#' @param se the SummarizedExperiment
#'
#' @return a SummarizedExperiment
#' @export
addExons <- function(se) {

  if (metadata(se)$level == "gene") {
    stop("addExons() is designed for transcript-level SummarizedExperiments, see ?addExons")
  }
  missingMetadata(se, summarize=FALSE)

  txomeInfo <- metadata(se)$txomeInfo
  txdb <- getTxDb(txomeInfo)
  exons <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="exon")

  # need to add seqinfo for (some) GENCODE and RefSeq
  if (all(is.na(seqlengths(exons)))) {
    seqinfo(exons) <- seqinfo(se)
  }
  
  # check if all transcripts are present, and then subset
  stopifnot(all(rownames(se) %in% names(exons)))
  exons <- exons[rownames(se)]
  stopifnot(all(rownames(se) == names(exons)))

  # carry over the metadata from 'se'
  mcols(exons) <- mcols(se)
  # swap the rowRanges
  rowRanges(se) <- exons
  se
}

#' Add CDS to rowRanges of a transcript-level SummarizedExperiment
#'
#' Working similarly to \code{\link{addExons}}, this function
#' can be used to add information about CDS (coding sequence)
#' to the \code{SummarizedExperiment} object. As not all transcripts
#' are coding, we have CDS information for only a subset of the
#' rows of the object. For this reason, a logical indicator for
#' whether the transcript is coding, \code{mcols(se)$coding},
#' is added as a column to the metadata columns of the \code{rowRanges}
#' of the object. An additional column, \code{mcols(se)$cds},
#' is added to the metadata columns, which is a \code{GRangesList}
#' with either the CDS regions (if the transcript is coding),
#' or the original transcript/exon ranges (if the transcript is non-coding).
#' This is necessary, as \code{GRangesList} cannot have NA elements.
#' As with \code{\link{addExons}}, this function is designed only
#' for transcript-level objects.
#' 
#' @param se the SummarizedExperiment
#'
#' @return a SummarizedExperiment
#' @export
addCDS <- function(se) {

  if (metadata(se)$level == "gene") {
    stop("addCDS() is design for transcript-level SummarizedExperiments")
  }
  missingMetadata(se, summarize=FALSE)

  txomeInfo <- metadata(se)$txomeInfo
  txdb <- getTxDb(txomeInfo)
  cds <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="cds")

  # need to add seqinfo for (some) GENCODE and RefSeq
  if (all(is.na(seqlengths(cds)))) {
    seqinfo(cds) <- seqinfo(se)
  }

  cds.in.rows <- names(cds) %in% rownames(se)
  if (!all(cds.in.rows)) {
    stopifnot(any(cds.in.rows))
    message(paste(sum(!cds.in.rows),"CDS ranges not in rows of object, dropped"))
    cds <- cds[cds.in.rows]
  }
  idx <- rownames(se) %in% names(cds)

  # note whether the transcript is coding according to CDS entry
  mcols(se)$coding <- idx
  
  nms.se <- rownames(se)[idx]
  cds <- cds[nms.se]

  # fill in with transcript or exon ranges for all transcripts
  rngs <- rowRanges(se)
  if (!is(rngs, "GRangesList")) {
    rngs <- as(rngs, "GRangesList")
  }
  mcols(se)$cds <- rngs
  stopifnot(all(rownames(se)[idx] == names(cds)))

  message("adding CDS ranges for coding transcripts, original ranges for non-coding.
see ?addCDS for more information about how CDS ranges are added")

  # add CDS ranges when the transcript is coding
  mcols(se)$cds[idx] <- cds
  
  se
}

# non-exported function:

# build or load ranges
# either transcript, exon-by-transcript, or gene ranges
getRanges <- function(txdb=txdb, txomeInfo=txomeInfo, type=c("txp","exon","cds","gene")) {
  long <- c(txp="transcript",exon="exon",cds="CDS",gene="gene")
  stopifnot(length(txomeInfo$gtf) == 1)
  stopifnot(txomeInfo$gtf != "")

  # TODO the entry in the BiocFileCache assumes that the GTF/GFF file
  # has a distinctive naming structure... works for GENCODE/Ensembl/RefSeq 
  rngsName <- paste0(type,"Rngs-",basename(txomeInfo$gtf))
  
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  q <- bfcquery(bfc, rngsName)
  if (bfccount(q) == 0) {
    # now generate ranges
    message(paste("generating",long[type],"ranges"))
    # TODO what to do about warnings about out-of-bound ranges? pass along somewhere?

    if (type == "txp") {
      ################
      ## txp ranges ##
      ################

      if (txomeInfo$source == "Ensembl") {
        suppressWarnings({
          rngs <- transcripts(txdb)
        })
      } else {
        suppressWarnings({
          rngs <- transcripts(txdb, columns=c("tx_id","gene_id","tx_name"))
        })
      }
      names(rngs) <- rngs$tx_name
      # dammit de novo transcript annotation will have
      # the transcript names as seqnames (seqid in the GFF3)
      if (tolower(txomeInfo$source) == "dammit") {
        names(rngs) <- seqnames(rngs)
      }
    } else if (type == "exon") {
      #################
      ## exon ranges ##
      #################

      # TODO suppress warnings about out-of-bound ranges for now... how to pass this on
      suppressWarnings({
        rngs <- exonsBy(txdb, by="tx", use.names=TRUE)
      })
    } else if (type == "cds") {
      #################
      ## CDS ranges ##
      #################

      # TODO suppress warnings about out-of-bound ranges for now... how to pass this on
      suppressWarnings({
        rngs <- cdsBy(txdb, by="tx", use.names=TRUE)
      })
    } else if (type == "gene") {
      #################
      ## gene ranges ##
      #################

      # TODO suppress warnings about out-of-bound ranges for now... how to pass this on
      suppressWarnings({
        rngs <- genes(txdb)
      })
    }
    savepath <- bfcnew(bfc, rngsName, ext=".rds")
    saveRDS(rngs, file=savepath)
  } else {
    loadpath <- bfcrpath(bfc, rnames=rngsName)
    message(paste("loading existing",long[type],"ranges created:",q$create_time[1]))
    rngs <- readRDS(loadpath)
  }
  rngs
}

#' Get or set the directory of the BiocFileCache used by tximeta
#'
#' Running \code{getTximetaBFC} will report the saved directory,
#' if it has been determined, or will return NULL.
#' Running \code{setTximetaBFC} will ask the user to specify a
#' BiocFileCache directory for accessing and saving TxDb sqlite files.
#' Note that tximeta's BiocFileCache can be set by the environmental
#' variable \code{TXIMETA_HUB_CACHE}, which will reset the cache location.
#' 
#' @param dir the location for tximeta's BiocFileCache. can be missing
#' in which case the function will call \code{file.choose} for choosing
#' location interactively
#' @param quiet whether to suppress feedback message
#' 
#' @return the directory of the BiocFileCache used by tximeta
#' (or nothing, in the case of \code{setTximetaBFC})
#'
#' @rdname getTximetaBFC
#'
#' @examples
#'
#' # getting the BiocFileCache used by tximeta
#' # (may not be set, which uses BiocFileCache default or temp directory)
#' getTximetaBFC()
#'
#' # don't want to actually change user settings so this is not run:
#' # setTximetaBFC()
#' 
#' @export
getTximetaBFC <- function() {
  bfclocFile <- bfclocFile()
  if (!file.exists(bfclocFile)) {
    message("tximeta's BiocFileCache location has not yet been set")
    NULL
  } else {
    readBFCLocFile(bfclocFile)
  }
}

#' @rdname getTximetaBFC
#' 
#' @export
setTximetaBFC <- function(dir, quiet=FALSE) {
  if (missing(dir)) {
    message("which BiocFileCache directory should tximeta use? (press Enter to cancel)")
    bfcloc <- file.choose()
  } else {
    stopifnot(is(dir, "character"))
    bfcloc <- dir
  }
  bfclocFile <- bfclocFile()
  writeBFCLocFile(bfcloc)
  if (!quiet) message("for group use, set the permissions of this directory to allow group write (g+w)")
  invisible()
}

# not exported:

# functions to read or edit the BiocFileCache location for tximeta (bfcloc)
# this information is stored in the 'tximeta' default R_user_dir
# under a file 'bfcloc.json'
bfclocFile <- function() {
  tximetaDir <- R_user_dir("tximeta", which="config")
  file.path(tximetaDir, "bfcloc.json")
}

writeBFCLocFile <- function(bfcloc) {
  tximetaDir <- R_user_dir("tximeta", which="config")
  if (!file.exists(tximetaDir)) dir.create(tximetaDir, recursive=TRUE)
  bfclocFile <- bfclocFile()
  write(toJSON(bfcloc, pretty=TRUE), file=bfclocFile)
}

readBFCLocFile <- function(bfclocFile) {
  fromJSON(bfclocFile)
}

# an internal function for getting the BFC location
# the logic here depends on whether a location has been set before,
# and whether tximport is being run interactively or not
getBFCLoc <- function() {
  defaultDir <- R_user_dir("BiocFileCache", which="cache")

  prompt <- paste("",
  "tximeta needs a BiocFileCache directory to access and save TxDb objects.",
  paste0("Do you wish to use the default directory: '",defaultDir,"'?"),
  "If not, a temporary directory that is specific to this R session will be used.","",
  "You can always change this directory later by running: setTximetaBFC()",
  "Or enter [0] to exit and set this directory manually now.",
  "This location can also be set by environmental variable TXIMETA_HUB_CACHE.",
  sep="\n")

  # this is the JSON file where we store the location of the tximeta BiocFileCache
  bfclocFile <- bfclocFile()
  
  # this file tells us which BFC dir has been previously chosen use with tximeta
  if (!file.exists(bfclocFile)) {
    if (interactive()) {

      # exception: temp dir already specified as BFC location in this session
      if (file.exists(file.path(tempdir(),"BiocFileCache.sqlite"))) {
        bfcloc <- tempdir()
        return(bfcloc)
      }
      
      # otherwise ask user:
      ans <- menu(c("Yes (use default)", "No (use temp)"), title=prompt)
      if (ans == 0) stop("no BiocFileCache directory choice made at this time")

      # user wants to use default dir:
      if (ans == 1) {
        bfcloc <- defaultDir
        writeBFCLocFile(bfcloc)
        
        # user wants to use temp dir:
      } else if (ans == 2) {
        bfcloc <- tempdir()
      }
      
      # not interactive, use temp dir:
    } else {
      bfcloc <- tempdir()
    }
    
    # file already exists, read BFC loc:
  } else {
    bfcloc <- readBFCLocFile(bfclocFile)
  }
  
  bfcloc
}

# cleaning duplicate txps -- i.e. swapping txp names to match those in GTF
duplicateTxpsClean <- function(assays, txps, txomeInfo, markDuplicateTxps, cleanDuplicateTxps) {
  assay.nms <- rownames(assays[["counts"]])
  txps.missing <- !assay.nms %in% names(txps) # logical vector
  if (sum(txps.missing) > 0) {
    dup.list <- makeDuplicateTxpsList(txomeInfo)
    # this function swaps out rows missing in `txps`
    # for duplicate txps which are in `txps`. needed bc
    # Ensembl includes haplotype chromosome txps that duplicate
    # standard chromosome txps (identical sequence)
    missing.txps <- assay.nms[txps.missing]
    dup.table <- makeDuplicateTxpsTable(missing.txps, dup.list, names(txps))
    if (is.null(dup.table)) {
      message("no duplicated transcripts to clean")
    } else {
      if (any(dup.table$alts %in% assay.nms)) {
        stop(
          "error from `cleanDuplicateTxps=TRUE`:\n",
          "duplicate transcript names are already present in the assay rownames,\n",
          "which may occur if `--keepDuplicates` was used during indexing,\n",
          "see ?tximeta Details section"
        )
      }
      message(paste("cleaning",nrow(dup.table),"duplicate transcript names"))
      # which rownames to fix
      m <- match(dup.table$dups.to.fix, assay.nms)
      stopifnot(all(!is.na(m)))
      # change the rownames to alternatives that are in `txps`
      assay.nms[m] <- dup.table$alts
      for (nm in names(assays)) {
        rownames(assays[[nm]]) <- assay.nms
      }
    }
  }
  return(list(assays=assays, txps=txps))
}

# marking duplicate txps
duplicateTxpsMark <- function(assays, txps, txomeInfo, markDuplicateTxps, cleanDuplicateTxps) {
  # mark duplicates in the rowData
  dup.list <- makeDuplicateTxpsList(txomeInfo)
  # assay names could have changed due to cleanDuplicateTxps
  assay.nms <- rownames(assays[["counts"]])
  dups.in.rownms <- unlist(dup.list) %in% assay.nms
  # a ragged list, with logical value: whether the transcript name is in assay rownames
  # this list has the same structure as the `dup.list`
  dups.in.rownms <- LogicalList(split(
    dups.in.rownms,
    rep(seq_along(dup.list), lengths(dup.list))
  ))
  names(dups.in.rownms) <- NULL
  # there can be 0, 1, or 2+ of the duplicates present in the rownames
  num.dups.in.rownms <- sapply(dups.in.rownms, sum)
  # subset to sets where only a single duplicate per set is in the rownames
  # other situations are too complex to handle here
  just.one <- num.dups.in.rownms == 1
  if (!all(just.one)) {
    dup.list <- dup.list[just.one]
    dups.in.rownms <- dups.in.rownms[just.one]
  }
  duplicates <- dup.list[!dups.in.rownms]
  duplicates.id <- as.character(dup.list[dups.in.rownms])
  mcols(txps)$hasDuplicate <- FALSE
  mcols(txps)$duplicates <- CharacterList(as.list(rep("", length(txps))))
  if (length(duplicates) > 0) {
    message(paste("marking",length(duplicates),"transcript sets as duplicate sets"))
    mcols(txps)$hasDuplicate[names(txps) %in% duplicates.id] <- TRUE
    # if necessary remove any of these not in txps
    duplicates <- duplicates[duplicates.id %in% names(txps)]
    duplicates.id <- duplicates.id[duplicates.id %in% names(txps)]
    mcols(txps)$duplicates[match(duplicates.id, names(txps))] <- duplicates
  } else {
    message("no duplicates found")
  }
  return(list(assays = assays, txps = txps))
}

makeDuplicateTxpsList <- function(txomeInfo) {
  dup.list.id <- paste0("dups-",substr(txomeInfo$sha256,1,32))
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  q <- bfcquery(bfc, dup.list.id)
  if (bfccount(q) == 1) {
    loadpath <- bfcrpath(bfc, dup.list.id)
    dup.list <- readRDS(loadpath)
    stopifnot(is(dup.list, "CharacterList"))
  } else {
    # download the cDNA from remote source (or load from cache)
    dna <- retrieveCDNA(txomeInfo, quiet=TRUE)
    if (txomeInfo$source == "Ensembl") {
      testTxp <- names(dna)[1]
      if (grepl("ENST|ENSMUST",testTxp)) {
        # for human and mouse, need to split on version number
        # (GTF has no version in txname, while FASTA has versions)
        names(dna) <- sub("\\..*", "", names(dna))
      } else {
        names(dna) <- sub(" .*", "", names(dna))
      }
    } else if (txomeInfo$source == "GENCODE") {
      names(dna) <- sub("\\|.*", "", names(dna))
    }
    # which are duplicated based on DNA sequence
    dups <- duplicated(dna)
    if (sum(dups) == 0) {
      dup.list <- NULL
    } else {
      # index of all seqs that participate in a dup
      all.dups <- dna %in% dna[dups]
      nms.all.dups <- names(dna)[all.dups]
      seq.all.dups <- as.character(dna[all.dups])
      dup.list <- split(nms.all.dups, seq.all.dups)
      names(dup.list) <- NULL
      dup.list <- CharacterList(dup.list)
    }
    # save it to BFC so as not to repeat the above operation
    savepath <- bfcnew(bfc, dup.list.id, ext=".rds")
    saveRDS(dup.list, file=savepath)
  }
  dup.list
}

makeDuplicateTxpsTable <- function(missing.txps, dup.list, txp.nms) {
  # dup.list is a list of the duplicate txps, according to the FASTA
  all.dups <- unlist(dup.list)

  # we want to try to fix those duplicate txps that are
  # in rownames of the assays but not in `txps`
  dups.to.fix <- intersect(all.dups, missing.txps)
  dups.to.fix.list <- LogicalList(
    split(all.dups %in% dups.to.fix, rep(seq_along(dup.list), lengths(dup.list)))
  )
  dup.list <- dup.list[any(dups.to.fix.list)]
  dups.to.fix.list <- dups.to.fix.list[any(dups.to.fix.list)]
  names(dups.to.fix.list) <- NULL

  # if we have a set of duplicates where > 1 is in the rownames of assays,
  # this is unexpected (Salmon should have combined these)
  # and we pass on fixing this
  more.than.one <- sapply(dups.to.fix.list, sum) > 1
  dup.list <- dup.list[!more.than.one]
  dups.to.fix.list <- dups.to.fix.list[!more.than.one]

  # now we can name the duplicate sets by the missing txp
  names(dup.list) <- dup.list[dups.to.fix.list]
  all.dups <- unlist(dup.list)
  
  # is there an alternative in `txps`?
  dups.with.alt <- intersect(all.dups, txp.nms)
  dups.with.alt.list <- LogicalList(
    split(all.dups %in% dups.with.alt, rep(seq_along(dup.list), lengths(dup.list)))
  )
  dup.list <- dup.list[any(dups.with.alt.list)]
  dups.with.alt.list <- dups.with.alt.list[any(dups.with.alt.list)]

  # pull out the alts
  names(dups.with.alt.list) <- names(dup.list)
  alts <- dup.list[dups.with.alt.list]

  # no reason to prefer one since they are all in `txps`
  alts <- sapply(alts, `[`, 1)
  stopifnot(all(alts %in% txp.nms))

  # return a table for the txp name swap
  dup.table <- data.frame(dups.to.fix=names(alts),
                          alts=unname(alts),
                          stringsAsFactors=FALSE)
  dup.table
}

#' Import transcript-level quantification data with automatic metadata
#' 
#' The tximeta package imports abundances (TPM), estimated counts,
#' and effective lengths from Salmon, alevin, or other quantification
#' tools, and will output a SummarizedExperiment object. For Salmon
#' and alevin quantification directories, \code{tximeta} will
#' try to identify the correct provenance of the reference transcripts
#' and automatically attach the transcript ranges to the
#' SummarizedExperiment, to facilitate downstream integration with
#' other datasets. The automatic identification of reference transcripts
#' should work out-of-the-box for human or mouse transcriptomes from
#' the sources: GENCODE, Ensembl, or RefSeq.
#'
#' The main functions are:
#' \itemize{
#' \item \code{\link{tximeta}} - with key argument: \code{coldata}
#' \item \code{\link{summarizeToGene}} - summarize quants to gene-level
#' \item \code{\link{retrieveDb}} - retrieve the transcript database
#' \item \code{\link{addIds}} - add transcript or gene ID (see \code{gene} argument)
#' \item \code{\link{addExons}} - convert from GRanges to GRangesList
#' }
#' 
#' All software-related questions should be posted to the Bioconductor Support Site:
#' 
#' \url{https://support.bioconductor.org}
#'
#' The code can be viewed at the GitHub repository,
#' which also lists the contributor code of conduct:
#'
#' \url{https://github.com/mikelove/tximeta}
#' 
#' @references
#'
#' \strong{tximeta} reference:
#' 
#' Michael I. Love, Charlotte Soneson, Peter F. Hickey, Lisa K. Johnson
#' N. Tessa Pierce, Lori Shepherd, Martin Morgan, Rob Patro (2020)
#' Tximeta: reference sequence checksums for provenance identification
#' in RNA-seq. PLOS Computational Biology.
#' \url{https://doi.org/10.1371/journal.pcbi.1007664}
#'
#' \strong{tximport} reference (the effective length offset and counts-from-abundance):
#' 
#' Charlotte Soneson, Michael I. Love, Mark D. Robinson (2015)
#' Differential analyses for RNA-seq: transcript-level estimates
#' improve gene-level inferences. F1000Research.
#' \url{http://doi.org/10.12688/f1000research.7563}
#'
#' @author Michael I. Love, Charlotte Soneson, Peter Hickey, Rob Patro
#' 
#' @docType package
#' @name tximeta-package
#' @aliases tximeta-package
#' @keywords package
NULL

#' tximeta: Transcript quantification import with automatic metadata
#'
#' \code{tximeta} leverages the hashed checksum of the Salmon index,
#' in addition to a number of core Bioconductor packages (GenomicFeatures,
#' ensembldb, AnnotationHub, GenomeInfoDb, BiocFileCache) to automatically
#' populate metadata for the user, without additional effort from the user.
#' Note that \code{tximeta} requires that the entire output directory of Salmon
#' or alevin is present and unmodified in order to identify the provenance of the
#' reference transcripts.
#'
#' Most of the code in \code{tximeta} works to add metadata and transcript ranges
#' when the quantification was performed with Salmon. However,
#' \code{tximeta} can be used with any quantification \code{type} that is supported
#' by \code{\link{tximport}}, where it will return an non-ranged SummarizedExperiment.
#' 
#' \code{tximeta} performs a lookup of the hashed checksum of the index
#' (stored in an auxilary information directory of the Salmon output)
#' against a database of known transcriptomes, which lives within the tximeta
#' package and is continually updated on Bioconductor's release schedule.
#' In addition, \code{tximeta} performs a lookup of the checksum against a
#' locally stored table of \code{linkedTxome}'s (see \code{link{makeLinkedTxome}}).
#' If \code{tximeta} detects a match, it will automatically populate,
#' e.g. the transcript locations, the transcriptome release,
#' the genome with correct chromosome lengths, etc. It allows for automatic
#' and correct summarization of transcript-level quantifications to the gene-level
#' via \code{\link{summarizeToGene}} without the need to manually build
#' a \code{tx2gene} table.
#'
#' \code{tximeta} on the first run will ask where the BiocFileCache for
#' this package should be kept, either using a default location or a temporary
#' directory. At any point, the user can specify a location using
#' \code{\link{setTximetaBFC}} and this choice will be saved for future sessions.
#' Multiple users can point to the same BiocFileCache, such that
#' transcript databases (TxDb or EnsDb) associated with certain Salmon indices
#' and \code{linkedTxomes} can be accessed by different users without additional
#' effort or time spent downloading and building the relevant TxDb / EnsDb.
#' Note that, if the TxDb or EnsDb is present in AnnotationHub, \code{tximeta} will
#' use this object instead of downloading and building a TxDb/EnsDb from GTF
#' (to disable this set useHub=FALSE).
#'
#' In order to allow that multiple users can read and write to the
#' same location, one should set the BiocFileCache directory to
#' have group write permissions (g+w).
#'
#' @param coldata a data.frame with at least two columns (others will propogate to object):
#' \itemize{
#' \item{\code{files} - character, paths of quantification files}
#' \item{\code{names} - character, sample names}
#' }
#' if \code{coldata} is a vector, it is assumed to be the paths of quantification files
#' and unique sample names are created
#' @param type what quantifier was used (see \code{\link{tximport}})
#' @param txOut whether to output transcript-level data.
#' \code{tximeta} is designed to have transcript-level output
#' with Salmon, so default is \code{TRUE},
#' and it's recommended to use \code{\link{summarizeToGene}}
#' following \code{tximeta} for gene-level summarization.
#' For an alevin file, \code{tximeta} will import the
#' gene level counts ignoring this argument (alevin
#' produces only gene-level quantification).
#' @param skipMeta whether to skip metadata generation
#' (e.g. to avoid errors if not connected to internet).
#' This calls \code{tximport} directly and so either
#' \code{txOut=TRUE} or \code{tx2gene} should be specified.
#' @param skipSeqinfo whether to skip the addition of Seqinfo,
#' which requires an internet connection to download the
#' relevant chromosome information table from UCSC
#' @param useHub whether to first attempt to download a TxDb/EnsDb
#' object from AnnotationHub, rather than creating from a
#' GTF file from FTP (default is TRUE). If FALSE, it will
#' force \code{tximeta} to download and parse the GTF
#' @param markDuplicateTxps whether to mark the status
#' (\code{hasDuplicate}) and names of duplicate transcripts
#' (\code{duplicates}) in the rowData of the SummarizedExperiment output.
#' Subsequent summarization to gene level will keep track
#' of the number of transcripts sets per gene (\code{numDupSets})
#' @param cleanDuplicateTxps whether to try to clean
#' duplicate transcripts (exact sequence duplicates) by replacing
#' the transcript names that do not appear in the GTF
#' with those that do appear in the GTF
#' @param customMetaInfo the relative path to a custom metadata
#' information JSON file, relative to the paths in \code{files} of
#' \code{coldata}. For example, \code{customMetaInfo="meta_info.json"}
#' would indicate that in the same directory as the quantification
#' files in \code{files}, there are custom metadata information
#' JSON files. These should contain the SHA-256 hash of the
#' reference transcripts with the \code{index_seq_hash} tag
#' (see details in vignette).
#' @param ... arguments passed to \code{tximport}
#' 
#' @return a SummarizedExperiment with metadata on the \code{rowRanges}.
#' (if the hashed checksum in the Salmon or Sailfish index does not match
#' any known transcriptomes, or any locally saved \code{linkedTxome},
#' \code{tximeta} will just return a non-ranged SummarizedExperiment)
#'
#' @examples
#'
#' # point to a Salmon quantification file:
#' dir <- system.file("extdata/salmon_dm", package="tximportData")
#' files <- file.path(dir, "SRR1197474", "quant.sf") 
#' coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)
#'
#' # normally we would just run the following which would download the appropriate metadata
#' # se <- tximeta(coldata)
#'
#' # for this example, we instead point to a local path where the GTF can be found
#' # by making a linkedTxome:
#' indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
#' fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
#'               "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
#' gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
#' makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
#'                 release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)
#' se <- tximeta(coldata)
#'
#' # to clear the entire linkedTxome table
#' # (don't run unless you want to clear this table!)
#' # bfcloc <- getTximetaBFC()
#' # bfc <- BiocFileCache(bfcloc)
#' # bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
#'
#' @importFrom SummarizedExperiment SummarizedExperiment assays assayNames colData rowData rowRanges<- rowRanges
#' @importFrom S4Vectors metadata mcols mcols<-
#' @importFrom IRanges CharacterList LogicalList
#' @importFrom GenomicRanges seqnames
#' @importFrom tximport tximport summarizeToGene
#' @importFrom jsonlite fromJSON toJSON
#' @importFrom AnnotationDbi loadDb saveDb select keys mapIds
#' @importFrom GenomicFeatures makeTxDbFromGFF makeTxDbFromGRanges transcripts genes exonsBy cdsBy
#' @importFrom ensembldb ensDbFromGtf EnsDb
#' @importFrom BiocFileCache BiocFileCache bfcquery bfcnew bfcadd bfccount bfcrpath
#' @importFrom AnnotationHub AnnotationHub query dbconn dbfile
#' @importFrom Biostrings readDNAStringSet %in%
#' @importFrom tibble tibble
#' @importFrom GenomeInfoDb Seqinfo genome<- seqlengths seqinfo seqinfo<- seqlevels
#' @importFrom tools R_user_dir file_ext
#' @importFrom utils menu packageVersion read.csv read.delim head
#' @importFrom methods is as
#'
#' @export
tximeta <- function(coldata,
                    type="salmon",
                    txOut=TRUE,
                    skipMeta=FALSE,
                    skipSeqinfo=FALSE,
                    useHub=TRUE,
                    markDuplicateTxps=FALSE,
                    cleanDuplicateTxps=FALSE,
                    customMetaInfo=NULL,
                    ...) {

  if (is(coldata, "vector")) {
    coldata <- data.frame(files=coldata, names=seq_along(coldata))
  }
  
  stopifnot(all(c("files","names") %in% names(coldata)))
  
  files <- as.character(coldata$files)
  names(files) <- coldata$names

  if (!all(file.exists(files))) {
    stop("the files do not exist at the location specified by 'coldata$files'")
  }

  if (type == "alevin") {
    if (length(files) > 1) stop("alevin import currently only supports a single experiment")
  }
  
  # remove the files column from colData
  coldata <- subset(coldata, select=-files)

  # tximeta metadata
  tximetaInfo <- list(version=packageVersion("tximeta"),
                      type=type,
                      importTime=Sys.time())

  metadata <- list(tximetaInfo=tximetaInfo)

  skipMetaLogic <- skipMeta |
    ( !type %in% c("salmon","sailfish","alevin") &
      is.null(customMetaInfo) )
  
  if (skipMetaLogic) {
    txi <- tximport(files, type=type, txOut=txOut, ...)
    metadata$countsFromAbundance <- txi$countsFromAbundance
    if (type == "alevin") {
      coldata <- data.frame(row.names=colnames(txi[["counts"]]))
    }
    se <- makeUnrangedSE(txi, coldata, metadata)
    return(se)
  } else {
    if (!txOut) stop("tximeta is designed to have transcript-level output for Salmon/Sailfish.
  set txOut=TRUE and use summarizeToGene for gene-level summarization")
  }

  if (type == "alevin") {
    metaInfo <- list(getMetaInfo(dirname(files),
                                 customMetaInfo=customMetaInfo))
  } else {
    # get quantifier metadata from JSON files within quant dirs
    metaInfo <- lapply(files, getMetaInfo,
                       customMetaInfo=customMetaInfo)
  }
  
  # Salmon's SHA-256 hash of the index is called "index_seq_hash" in the meta_info.json file
  indexSeqHash <- metaInfo[[1]]$index_seq_hash # first sample  
  if (length(files) > 1) {
    hashes <- sapply(metaInfo, function(x) x$index_seq_hash)
    if (!all(hashes == indexSeqHash)) {
      stop("the samples do not share the same index, and cannot be imported")
    }
    if ("num_bootstraps" %in% names(metaInfo[[1]])) {
      nboot <- sapply(metaInfo, function(x) x$num_bootstraps)
      if (!all(nboot == nboot[1])) {
        message("\nNOTE: inferential replicate number not equal across files,
may lead to errors in object construction, unless 'dropInfReps=TRUE'")
        if (any(nboot == 0)) {
          message(paste("\nNOTE: the following files (by #) have 0 inferential replicates:
  ",paste(which(nboot == 0),collapse=",")),"\n")
        }
      }
    }
  }
  # reshape
  metaInfo <- reshapeMetaInfo(metaInfo)
  # add to metadata list
  metadata$quantInfo <- metaInfo
  
  # try to import files early, so we don't waste user time
  # with metadata magic before a tximport error
  message("importing quantifications")
  txi <- tximport(files, type=type, txOut=TRUE, ...)
  metadata$countsFromAbundance <- txi$countsFromAbundance

  # try and find a matching txome
  txomeInfo <- getTxomeInfo(indexSeqHash)
  if (is.null(txomeInfo)) {
    message("couldn't find matching transcriptome, returning non-ranged SummarizedExperiment")
    if (type == "alevin") {
      coldata <- data.frame(row.names=colnames(txi[["counts"]]))
    }
    se <- makeUnrangedSE(txi, coldata, metadata)
    return(se)
  }

  # build or load a TxDb from the gtf
  txdb <- getTxDb(txomeInfo, useHub=useHub)

  # build or load transcript ranges (alevin gets gene ranges instead)
  if (type != "alevin") {
    txps <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="txp")
    metadata$level <- "txp"
  } else if (type == "alevin") {
    # alevin gets gene ranges instead
    message("generating gene ranges")
    # here gene ranges are named 'txps' for compatibility with code below...
    txps <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="gene")
    metadata$level <- "gene"
  }

  # package up the assays
  if (type == "alevin") {
    # special alevin code
    if ("variance" %in% names(txi)) {
      if ("infReps" %in% names(txi)) {
        assays <- c(txi[c("counts","variance")], txi$infReps)
        names(assays) <- c("counts", "variance", paste0("infRep", seq_along(txi$infReps)))
      } else {
        assays <- txi[c("counts","variance")]
      }
    } else {
      assays <- txi["counts"]
    }
    # add mean information as well if it exists in the list
    if ("mean" %in% names(txi)) {
      assays <- c(assays, txi["mean"])
    }
    # add tier information as well if it exists in the list
    if ("tier" %in% names(txi)) {
      assays <- c(assays, txi["tier"])
    }
    coldata <- data.frame(row.names=colnames(assays[["counts"]]))
  } else {
    # for methods other than alevin...
    # put 'counts' in front to facilitate DESeqDataSet construction
    # and remove countsFromAbundance
    txi.nms <- c("counts", c(setdiff(names(txi), c("counts","countsFromAbundance","infReps"))))
    assays <- txi[txi.nms]
    # if there are inferential replicates
    if ("infReps" %in% names(txi)) {
      infReps <- rearrangeInfReps(txi$infReps)
      infReps <- lapply(infReps, function(mat) {
        rownames(mat) <- rownames(assays[["counts"]])
        colnames(mat) <- colnames(assays[["counts"]])
        mat
      })
      assays <- c(assays, infReps)
    }
  }
  
  # Ensembl FASTA has txp version numbers,
  # but in the Ensembl GTF it is not in the txname,
  # so here we have to remove the version number to build the SummarizedExperiment
  if (txomeInfo$source %in% c("Ensembl","LocalEnsembl")) {
    txId <- sub("\\..*", "", rownames(assays[["counts"]]))
    for (nm in names(assays)) {
      rownames(assays[[nm]]) <- txId
    }
  }

  # code for marking or cleaning duplicate txps
  assay.nms <- rownames(assays[["counts"]])
  txps.missing <- !assay.nms %in% names(txps)
  # either we want to mark duplicates, or clean up duplicates (if we can)
  if (markDuplicateTxps | (cleanDuplicateTxps & sum(txps.missing) > 0)) {
    dup.list <- makeDuplicateTxpsList(txomeInfo)
  }
  if (cleanDuplicateTxps & sum(txps.missing) > 0) {
    # this function swaps out rows missing in `txps`
    # for duplicate txps which are in `txps`. needed bc
    # Ensembl includes haplotype chromosome txps that duplicate
    # standard chromosome txps (identical sequence)
    missing.txps <- assay.nms[txps.missing]
    dup.table <- makeDuplicateTxpsTable(missing.txps, dup.list, names(txps))
    if (is.null(dup.table)) {
      message("no duplicated transcripts to clean")
    } else {
      message(paste("cleaning",nrow(dup.table),"duplicate transcript names"))
      # which rownames to fix
      m <- match(dup.table$dups.to.fix, assay.nms)
      stopifnot(all(!is.na(m)))
      # change the rownames to alternatives that are in `txps`
      for (nm in names(assays)) {
        assay.nms[m] <- dup.table$alts
        rownames(assays[[nm]]) <- assay.nms
      }
    }
  }

  # special edits to rownames for GENCODE to remove chars after `|`
  # (and user didn't use --gencode when building Salmon index)
  testTxp <- rownames(assays[[1]])[1]
  if (grepl("ENST|ENSMUST", testTxp) & grepl("\\|", testTxp)) {
    for (i in names(assays)) {
      rownames(assays[[i]]) <- sub("\\|.*","",rownames(assays[[i]]))
    }
  }

  assays <- checkAssays2Txps(assays, txps)
  
  # TODO we could give a warning here if there are txps in TxDb not in index
  txps <- txps[rownames(assays[["counts"]])]

  # mark duplicates in the rowData
  if (markDuplicateTxps) {
    # assay names could have changed due to cleanDuplicateTxps
    assay.nms <- rownames(assays[["counts"]])
    dups.in.rownms <- unlist(dup.list) %in% assay.nms
    dups.in.rownms <- LogicalList(split(dups.in.rownms, rep(seq_along(dup.list), lengths(dup.list))))
    names(dups.in.rownms) <- NULL
    num.dups.in.rownms <- sapply(dups.in.rownms, sum)
    just.one <- num.dups.in.rownms == 1
    if (!all(just.one)) {
      dup.list <- dup.list[just.one]
      dups.in.rownms <- dups.in.rownms[just.one]
    }
    duplicates <- dup.list[ !dups.in.rownms ]
    duplicates.id <- as.character(dup.list[ dups.in.rownms ])
    mcols(txps)$hasDuplicate <- FALSE
    mcols(txps)$duplicates <- CharacterList(as.list(rep("",length(txps))))
    if (length(duplicates) > 0) {
      message(paste(length(duplicates), "duplicate set founds"))
      mcols(txps)$hasDuplicate[ names(txps) %in% duplicates.id ] <- TRUE
      # if necessary remove any of these not in txps
      duplicates <- duplicates[ duplicates.id %in% names(txps) ]
      duplicates.id <- duplicates.id[ duplicates.id %in% names(txps) ]
      mcols(txps)$duplicates[ match(duplicates.id, names(txps)) ] <- duplicates
    } else {
      message("no duplicates found")
    }
  }
  
  # Ensembl already has nice seqinfo attached...
  # if GENCODE, and not from AHub (which have seqinfo)
  missingSeqinfo <- any(is.na(seqlengths(txps)))
  if (txomeInfo$source == "GENCODE" & !skipSeqinfo & missingSeqinfo) {
    message("fetching genome info for GENCODE")
    ucsc.genome <- genome2UCSC(txomeInfo$genome)
    try(seqinfo(txps) <- Seqinfo(genome=ucsc.genome)[seqlevels(txps)])
  } else if (txomeInfo$source == "RefSeq" & !skipSeqinfo & missingSeqinfo) {
    # if RefSeq...
    message("fetching genome info for RefSeq")
    refseq.genome <- gtf2RefSeq(txomeInfo$gtf, txomeInfo$genome)
    stopifnot(all(seqlevels(txps) %in% seqnames(refseq.genome)))
    try(seqinfo(txps) <- refseq.genome[seqlevels(txps)])
  }
  
  # add more metadata
  txdbInfo <- metadata(txdb)$value
  names(txdbInfo) <- metadata(txdb)$name
  metadata$txomeInfo <- txomeInfo
  metadata$txdbInfo <- txdbInfo

  se <- SummarizedExperiment(assays=assays,
                             rowRanges=txps,
                             colData=coldata,
                             metadata=metadata)
  se
  
}

missingMetadata <- function(se, summarize=FALSE) {
  msg <- "use of this function requires transcriptome metadata which is missing.
  either: (1) the object was not produced by tximeta, or
  (2) tximeta could not recognize the checksum of the transcriptome.
  If (2), use a linkedTxome to provide the missing metadata and rerun tximeta"
  if (summarize) {
    msg <- paste0(msg, "
  or use tx2gene, txOut=FALSE (and skipMeta=TRUE if Salmon)")
  }
  if (is.null(metadata(se)$txomeInfo)) stop(msg)
}

# read metadata files from Salmon directory
# customMetaInfo = path of the custom metadata info file
getMetaInfo <- function(file, customMetaInfo=NULL) {
  dir <- dirname(file)
  if (is.null(customMetaInfo)) {
    auxDir <- "aux_info" # the default auxiliary information location
    if (!file.exists(file.path(dir, auxDir))) {
      # just in case this was changed...
      jsonPath <- file.path(dir, "cmd_info.json")
      if (!file.exists(jsonPath)) {
        stop("metadata files are missing, tximeta requires the full Salmon output directory")
      }
      cmd_info <- jsonlite::fromJSON(jsonPath)
      if ("auxDir" %in% names(cmd_info)) {
        auxDir <- cmd_info$auxDir
      }
    }
    # ok now we read in the metadata
    jsonPath <- file.path(dir, auxDir, "meta_info.json")
  } else {
    jsonPath <- file.path(dir, customMetaInfo)
  }
  if (!file.exists(jsonPath)) {
    stop("\n\n  the quantification files exist, but the metadata files are missing.
  tximeta (and other downstream software) require the entire output directory
  of Salmon/alevin, including the quantification files and many other files
  that contain critical metadata. make sure to preserve the entire directory
  for use with tximeta (and other downstream software).\n\n") 
  }
  fromJSON(jsonPath)
}

# reshape metadata info from Salmon
reshapeMetaInfo <- function(metaInfo) {
  unionTags <- unique(unlist(lapply(metaInfo, names)))
  out <- lapply(unionTags, function(t) {
    sapply(seq_along(metaInfo), function(i) {
      metaInfo[[i]][[t]]
    })
  })
  names(out) <- unionTags
  if (all(out$eq_class_properties == list())) {
    out$eq_class_properties <- NULL
  }
  stopifnot(all(out$index_seq_hash == out$index_seq_hash[1]))
  stopifnot(all(out$index_name_hash == out$index_name_hash[1]))
  out$index_seq_hash <- out$index_seq_hash[1]
  out$index_name_hash <- out$index_name_hash[1]
  out
}

# temporary function to map from GRCh38 to hg38 to allow easy
# comparison with UCSC objects from AnnotationHub...
# TODO we need a better solution for obtaining seqinfo for GENCODE
genome2UCSC <- function(x) {
  if (x == "GRCh38") {
    "hg38"
  } else if (x == "GRCm38") {
    "mm10"
  } else {
    x
  }
}

gtf2RefSeq <- function(gtf, genome) {
  report <- sub("genomic.gff.gz","assembly_report.txt",basename(gtf))
  dir <- dirname(gtf)
  reportFtp <- paste0(dir, "/", report)
  tab <- read.delim(reportFtp, comment.char="#", header=FALSE, sep="\t", stringsAsFactors=FALSE)
  # TODO - need to figure out what to do about these un-parser friendly files
  tab <- tab[,c(7,9,10)]
  names(tab) <- c("refseqAccn","length","ucscName")
  Seqinfo(seqnames=tab$refseqAccn,
          seqlengths=tab$length,
          isCircular=NA,
          genome=genome)
}

# identify the txome based on the indexSeqHash
# - first look into the linkedTxomeTbl
# - secondly look into the pre-computed hash table in `extdata`
getTxomeInfo <- function(indexSeqHash) {

  # first try to find any linkedTxomes in the linkedTxomeTbl
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  q <- bfcquery(bfc, "linkedTxomeTbl")
  # there should only be one such entry in the tximeta bfc
  stopifnot(bfccount(q) < 2)
  if (bfccount(q) == 1) {
    loadpath <- bfcrpath(bfc, "linkedTxomeTbl")
    linkedTxomeTbl <- readRDS(loadpath)
    m <- match(indexSeqHash, linkedTxomeTbl$sha256)
    if (!is.na(m)) {
      txomeInfo <- as.list(linkedTxomeTbl[m,])
      txomeInfo$linkedTxome <- TRUE
      message(paste0("found matching linked transcriptome:\n[ ",
                     txomeInfo$source," - ",txomeInfo$organism," - release ",txomeInfo$release," ]"))
      return(txomeInfo)
    }
  }

  # if not in linkedTxomes try the pre-computed hashtable...

  # TODO best this would be an external data package / future GA4GH RefGet API
  hashfile <- file.path(system.file("extdata",package="tximeta"),"hashtable.csv")
  hashtable <- read.csv(hashfile,stringsAsFactors=FALSE)
  m <- match(indexSeqHash, hashtable$sha256)
  if (!is.na(m)) {
    # now we can go get the GTF to annotate the ranges
    txomeInfo <- as.list(hashtable[m,])
    if (grepl(" ", txomeInfo$fasta)) {
      txomeInfo$fasta <- strsplit(txomeInfo$fasta, " ")
    }
    txomeInfo$linkedTxome <- FALSE
    message(paste0("found matching transcriptome:\n[ ",
                   txomeInfo$source," - ",txomeInfo$organism," - release ",txomeInfo$release," ]"))
    return(txomeInfo)
  }
  
  return(NULL)
}

# build or load a TxDb/EnsDb for the dataset
getTxDb <- function(txomeInfo, useHub=TRUE) {
  # TODO what if there are multiple GTF files?
  stopifnot(length(txomeInfo$gtf) == 1)
  stopifnot(txomeInfo$gtf != "")
  txdbName <- basename(txomeInfo$gtf)
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  # look up txdbName
  q <- bfcquery(bfc, txdbName)
  # then filter for equality with rname
  q <- q[q$rname==txdbName,]

  ### No TxDb was found in the BiocFilecache ###
  if (bfccount(q) == 0) {

    # Ensembl and GENCODE best case we can find database on AnnotationHub
    hubSources <- c("Ensembl","GENCODE")
    srcName <- txomeInfo$source
    hubWorked <- FALSE
    if (srcName %in% hubSources) {
      ensSrc <- srcName == "Ensembl"
      dbType <- if (ensSrc) "EnsDb" else "TxDb"
      if (useHub) {
        message(paste("useHub=TRUE: checking for", dbType, "via 'AnnotationHub'"))
        ah <- AnnotationHub()
        # get records
        records <- query(ah, c(srcName, txomeInfo$organism, txomeInfo$release))
        # confirm source, organism, dbType through metadata columns
        records <- records[records$dataprovider==srcName &
                           records$species==txomeInfo$organism &
                           records$rdataclass==dbType,]        
        if (ensSrc) {
          # Confirm release number through grep on the title
          # EnsDb record titles look like "Ensembl 123 EnsDb for Homo sapiens"
          records <- records[grepl(paste(srcName, txomeInfo$release, dbType), records$title),]
        } else {
          # Narrow records based on the genome coordinates
          # GENCODE record titles look like "TxDb for Gencode v123 on hg38 coordinates"
          coords <- genome2UCSC(txomeInfo$genome)
          records <- records[grepl(coords, records$title),]
        }
        if (length(records) == 1) {
          message(paste("found matching", dbType, "via 'AnnotationHub'"))
          hubWorked <- TRUE
          txdb <- ah[[names(records)]]
          bfcadd(bfc, rname=txdbName, fpath=dbfile(dbconn(txdb)))
        } else {
          message(paste("did not find matching", dbType, "via 'AnnotationHub'"))
        }
      }
      # if check on AnnotationHub failed (or wasn't attempted)
      if (!hubWorked) {
        # build db for Ensembl
        if (ensSrc) {
          message("building EnsDb with 'ensembldb' package")
          # split code based on whether linkedTxome (bc GTF filename may be modified)
          if (!txomeInfo$linkedTxome) {
            # TODO what about suppressing all these warnings
            suppressWarnings({
              savepath <- ensDbFromGtf(
                txomeInfo$gtf,
                outfile = bfcnew(bfc, rname=txdbName, ext=".sqlite")
              )
            })
          } else {
            message("NOTE: linkedTxome with source='Ensembl', ensembldb will be used to parse GTF.
this may produce errors if the GTF is not from Ensembl, or has been modified")
            # for linkedTxome, because the GTF filename may be modified
            # we manually provide organism, genomeVersion, and version
            suppressWarnings({
              savepath <- ensDbFromGtf(
                txomeInfo$gtf,
                outfile = bfcnew(bfc, rname=txdbName, ext=".sqlite"),
                organism = txomeInfo$organism,
                genomeVersion = txomeInfo$genome,
                version = txomeInfo$release
              )
            })
          }
          txdb <- EnsDb(savepath)
        }
      }
    }

    # two cases left:
    # 1) Neither Ensembl or GENCODE source
    # 2) GENCODE source but AHub didn't work
    if ((!srcName %in% hubSources) | (srcName == "GENCODE" & !hubWorked)) {
      message("building TxDb with 'GenomicFeatures' package")
      # allow .rds instead of GTF
      if (tools::file_ext(txomeInfo$gtf) == "rds") {
        gtf2gr <- readRDS(txomeInfo$gtf)
        txdb <- makeTxDbFromGRanges(gtf2gr)
      } else {
        # the typical case: parse the GTF
        txdb <- makeTxDbFromGFF(txomeInfo$gtf)
      }
      saveDb(
        txdb,
        file = bfcnew(bfc, rname=txdbName, ext=".sqlite")
      )
    }

  } else {
    ### Yes, TxDb was found in the BiocFilecache ###
    loadpath <- bfcrpath(bfc, txdbName)
    if (txomeInfo$source == "Ensembl") {
      message(paste("loading existing EnsDb created:",q$create_time[1]))
      txdb <- EnsDb(loadpath)
    } else {
      message(paste("loading existing TxDb created:",q$create_time[1]))
      txdb <- loadDb(loadpath)
    }
  }
  
  txdb
}

# check to see if there are any missing transcripts not available
# for the rows of the tximport assay matrices. if so, give warning and subset
# (or error if all are missing)
checkAssays2Txps <- function(assays, txps) {
  assay.nms <- rownames(assays[["counts"]])
  txps.missing <- !assay.nms %in% names(txps)
  if (!all(assay.nms %in% names(txps))) {

    # it's probably ok that the messaging here uses the term 'txps',
    # because it's unlikely that we'd have genes not present in the GTF
    # which nevertheless had txps in the GTF...
    
    if (all(!assay.nms %in% names(txps))) {
      stop("none of the transcripts in the quantification files are in the GTF")
    } else {

      if (sum(txps.missing) > 3) {
        example.missing <- paste0("Example missing txps: [",
                                  paste(head(assay.nms[txps.missing],3),collapse=", "),
                                  ", ...]")
      } else {
        example.missing <- paste0("Missing txps: [",
                                  paste(assay.nms[txps.missing],collapse=", "), "]")
      }
      
      # TODO what to do here, GTF is missing some txps in FASTA for Ensembl
      warning(paste0("

Warning: the annotation is missing some transcripts that were quantified.
", sum(txps.missing), " out of ", nrow(assays[["counts"]]),
" txps were missing from GTF/GFF but were in the indexed FASTA.
(This occurs sometimes with Ensembl txps on haplotype chromosomes.)
In order to build a ranged SummarizedExperiment, these txps were removed.
To keep these txps, and to skip adding ranges, use skipMeta=TRUE

", example.missing, "
"))

      # after warning, then subset
      for (nm in names(assays)) {
        assays[[nm]] <- assays[[nm]][!txps.missing,,drop=FALSE]
      }
      
    }
  }
  assays
}

makeUnrangedSE <- function(txi, coldata, metadata) {
  assays <- txi[c("counts","abundance","length")]
  # if there are inferential replicates
  if ("infReps" %in% names(txi)) {
    infReps <- rearrangeInfReps(txi$infReps)
    assays <- c(assays, infReps)
  } else if ("variance" %in% names(txi)) {
    assays <- c(assays, txi["variance"])
  }
  if ("mean" %in% names(txi)) {
    assays <- c(assays, txi["mean"])
  }
  if ("tier" %in% names(txi)) {
    assays <- c(assays, txi["tier"])
  }
  assays <- assays[!sapply(assays, is.null)]
  SummarizedExperiment(assays=assays,
                       colData=coldata,
                       metadata=metadata)
}

# arrange list of inferential replicate matrices (per sample)
# into per replicate (infRep1, infRep2, ...)
rearrangeInfReps <- function(infReps) {
  nreps <- ncol(infReps[[1]])
  stopifnot(all(sapply(infReps, ncol) == nreps))
  getCols <- function(j,l) do.call(cbind, lapply(seq_along(l), function(k)  l[[k]][,j]))
  infReps <- lapply(seq_len(nreps), getCols, infReps)
  names(infReps) <- paste0("infRep",seq_len(nreps))
  infReps
}

# split list of inferential replicate matrices (per replicate)
# into per sample (sample1, sample2, ...)
splitInfReps <- function(infReps) {
  nsamps <- ncol(infReps[[1]])
  sample.names <- colnames(infReps[[1]])
  getCols <- function(j,l) do.call(cbind, lapply(seq_along(l), function(k)  l[[k]][,j]))
  infReps <- lapply(seq_len(nsamps), getCols, infReps)
  names(infReps) <- sample.names
  infReps
}

# build or load ranges
# either transcript, exon-by-transcript, or gene ranges
getRanges <- function(txdb=txdb, txomeInfo=txomeInfo, type=c("txp","exon","cds","gene")) {
  long <- c(txp="transcript",exon="exon",cds="CDS",gene="gene")
  stopifnot(length(txomeInfo$gtf) == 1)
  stopifnot(txomeInfo$gtf != "")

  # TODO the entry in the BiocFileCache assumes that the GTF/GFF file
  # has a distinctive naming structure... works for GENCODE/Ensembl/RefSeq 
  rngsName <- paste0(type,"Rngs-",basename(txomeInfo$gtf))
  
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  q <- bfcquery(bfc, rngsName)
  if (bfccount(q) == 0) {
    # now generate ranges
    message(paste("generating",long[type],"ranges"))
    # TODO what to do about warnings about out-of-bound ranges? pass along somewhere?

    if (type == "txp") {
      ################
      ## txp ranges ##
      ################

      if (txomeInfo$source == "Ensembl") {
        suppressWarnings({
          rngs <- transcripts(txdb)
        })
      } else {
        suppressWarnings({
          rngs <- transcripts(txdb, columns=c("tx_id","gene_id","tx_name"))
        })
      }
      names(rngs) <- rngs$tx_name
      # dammit de novo transcript annotation will have
      # the transcript names as seqnames (seqid in the GFF3)
      if (tolower(txomeInfo$source) == "dammit") {
        names(rngs) <- seqnames(rngs)
      }
    } else if (type == "exon") {
      #################
      ## exon ranges ##
      #################

      # TODO suppress warnings about out-of-bound ranges for now... how to pass this on
      suppressWarnings({
        rngs <- exonsBy(txdb, by="tx", use.names=TRUE)
      })
    } else if (type == "cds") {
      #################
      ## CDS ranges ##
      #################

      # TODO suppress warnings about out-of-bound ranges for now... how to pass this on
      suppressWarnings({
        rngs <- cdsBy(txdb, by="tx", use.names=TRUE)
      })
    } else if (type == "gene") {
      #################
      ## gene ranges ##
      #################

      # TODO suppress warnings about out-of-bound ranges for now... how to pass this on
      suppressWarnings({
        rngs <- genes(txdb)
      })
    }
    savepath <- bfcnew(bfc, rngsName, ext=".rds")
    saveRDS(rngs, file=savepath)
  } else {
    loadpath <- bfcrpath(bfc, rngsName)
    message(paste("loading existing",long[type],"ranges created:",q$create_time[1]))
    rngs <- readRDS(loadpath)
  }
  rngs
}

context("alevin")

test_that("tximeta can import alevin", {

  dir <- system.file("extdata", package="tximportData")
  samps <- list.files(file.path(dir, "alevin"))
  files <- file.path(dir,"alevin",samps[1],"alevin/quants_mat.gz")
  file.exists(files)
  coldata <- data.frame(files, names="neurons")

  #se <- tximeta(coldata, type="alevin")
  se <- tximeta(coldata, type="alevin", skipMeta=TRUE)
  expect_true(metadata(se)$tximetaInfo$type == "alevin")
  
})

context("skipMeta")
test_that("you can still use summarizeToGene", {

  dir <- system.file("extdata/salmon_dm", package="tximportData")
  files <- file.path(dir, "SRR1197474", "quant.sf") 
  coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)

  se <- tximeta(coldata, skipMeta=TRUE)

  expect_error(summarizeToGene(se), "skipRanges")

  tx2gene <- data.frame(tx=rownames(se), gene=sort(rep(1:1000, length.out=nrow(se))))
  gse <- summarizeToGene(se, skipRanges=TRUE, tx2gene=tx2gene)
  
})

#' Make and load linked transcriptomes ("linkedTxome")
#'
#' \code{makeLinkedTxome} reads the checksum associated with a Salmon
#' index at \code{indexDir}, and links it to key information
#' about the transcriptome, including the \code{source}, \code{organism},
#' \code{release}, and \code{genome} (these are custom character strings),
#' as well as the locations (e.g. local, HTTP, or FTP) for one or more \code{fasta}
#' files and one \code{gtf} file. \code{loadLinkedTxome} loads this
#' information from a JSON file. See Details.
#'
#' \code{makeLinkedTxome} links the information about the transcriptome
#' used for quantification in two ways:
#' 1) the function will store a record in tximeta's cache such that
#' future import of quantification data will automatically access and
#' parse the GTF as if the transcriptome were one of those automatically
#' detected by tximeta. Then all features of tximeta (e.g. summarization
#' to gene, programmatic adding of IDs or metadata) will be available;
#' 2) it will by default write out a JSON file
#' that can be shared, or posted online, and which can be read by
#' \code{loadLinkedTxome} which will store the information in tximeta's
#' cache. This should make the full quantification-import pipeline
#' computationally reproducible / auditable even for transcriptomes
#' which differ from those provided by references (GENCODE, Ensembl,
#' RefSeq).
#' 
#' For further details please see the "Linked transcriptomes"
#' section of the tximeta vignette.
#' 
#' @param indexDir the local path to the Salmon index
#' @param source the source of transcriptome (e.g. "de-novo").
#' Note: if you specify "GENCODE" or "Ensembl", this will trigger
#' behavior by tximeta that may not be desired: e.g. attempts to
#' download canonical transcriptome data from AnnotationHub
#' (unless useHub=FALSE when running tximeta) and parsing of
#' Ensembl GTF using ensembldb (which may fail if the GTF file
#' has been modified). For transcriptomes that are defined by
#' local GTF files, it is recommended to use the terms "LocalGENCODE"
#' or "LocalEnsembl". Setting "LocalEnsembl" will also strip
#' version numbers from the FASTA transcript IDs to enable matching
#' with the Ensembl GTF.
#' @param organism organism (e.g. "Homo sapiens")
#' @param release release number (e.g. "27")
#' @param genome genome (e.g. "GRCh38", or "none")
#' @param fasta location(s) for the FASTA transcript sequences
#' (of which the transcripts used to build the index is equal or a subset).
#' This can be a local path, or an HTTP or FTP URL
#' @param gtf location for the GTF/GFF file
#' (of which the transcripts used to build the index is equal or a subset).
#' This can be a local path, or an HTTP or FTP URL
#' While the \code{fasta} argument can take a vector of length greater than one
#' (more than one FASTA file containing transcripts used in indexing),
#' the \code{gtf} argument has to be a single GTF/GFF file.
#' This can also be a serialized GRanges object (location of a .rds file)
#' imported with rtracklayer.
#' If transcripts were added to a standard set of reference transcripts (e.g. fusion genes,
#' or pathogen transcripts), it is recommended that the tximeta user would manually
#' add these to the GTF/GFF file, and post the modified GTF/GFF publicly, such as
#' on Zenodo. This enables consistent annotation and downstream annotation
#' tasks, such as by \code{summarizeToGene}.
#' @param write logical, should a JSON file be written out
#' which documents the transcriptome checksum and metadata? (default is TRUE)
#' @param jsonFile the path to the json file for the linkedTxome
#'
#' @return nothing, the function is run for its side effects
#' 
#' @name linkedTxome
#' @rdname linkedTxome
#'
#' @examples
#'
#' # point to a Salmon quantification file with an additional artificial transcript
#' dir <- system.file("extdata/salmon_dm", package="tximportData")
#' file <- file.path(dir, "SRR1197474.plus", "quant.sf")
#' coldata <- data.frame(files=file, names="SRR1197474", sample="1",
#'                       stringsAsFactors=FALSE)
#'
#' # now point to the Salmon index itself to create a linkedTxome
#' # as the index will not match a known txome
#' indexDir <- file.path(dir, "Dm.BDGP6.22.98.plus_salmon-0.14.1")
#'
#' # point to the source FASTA and GTF:
#' fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
#'               "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz",
#'               "extra_transcript.fa.gz")
#' gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz")
#'
#' # now create a linkedTxome, linking the Salmon index to its FASTA and GTF sources
#' makeLinkedTxome(indexDir=indexDir, source="Ensembl", organism="Drosophila melanogaster",
#'                 release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)
#'
#' # to clear the entire linkedTxome table
#' # (don't run unless you want to clear this table!)
#' # bfcloc <- getTximetaBFC()
#' # bfc <- BiocFileCache(bfcloc)
#' # bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
#' 
#' @export
makeLinkedTxome <- function(indexDir, source, organism, release,
                            genome, fasta, gtf, write=TRUE, jsonFile) {
  indexJson <- file.path(indexDir, "info.json")
  if (!file.exists(indexJson)) {
    indexJson <- file.path(indexDir, "header.json")
  }
  indexList <- fromJSON(indexJson)
  # Salmon's SHA-256 hash of the index is called "SeqHash" in the index JSON
  # Pre-Salmon 1.0.0 the header.json file has a "value0" sublist, 
  # from Salmon 1.0.0 the info.json file doesn't
  if ("value0" %in% names(indexList)) {
    indexSeqHash <- indexList$value0$SeqHash
  } else {
    indexSeqHash <- indexList$SeqHash
  }
  # here and in the data frame where we record linkedTxome's,
  # 'index' is just the basename of the Salmon index
  index <- basename(indexDir)
  # standardize capitalization
  std.sources <- c("GENCODE","Ensembl")
  for (src in std.sources) {
    if (tolower(source) == tolower(src)) {
      source <- src
    }
  }
  if (source %in% std.sources) {
    if (source == "Ensembl") {
      message("NOTE: linkedTxome with source='Ensembl', ensembldb will be used to parse GTF.
this may produce errors if the GTF is not from Ensembl, or has been modified.
set useHub=FALSE in tximeta to avoid download of reference txome from AnnotationHub.
alternatively use a different string for source argument")
    } else {
      message("NOTE: linkedTxome with source='GENCODE', set useHub=FALSE in tximeta
to avoid download of reference txome from AnnotationHub.
alternatively use a different string for source argument")
    }
  }
  # a single-row tibble for the linkedTxomeTbl
  lt <- tibble(index=index,
               source=source,
               organism=organism,
               release=release,
               genome=genome,
               fasta=list(fasta),
               gtf=gtf,
               sha256=indexSeqHash)
  stopifnot(nrow(lt) == 1)
  if (write) {
    if (missing(jsonFile)) {
      jsonFile <- paste0(indexDir,".json")
    }
    message(paste("writing linkedTxome to", jsonFile))
    # TODO be more careful about writing to a file (ask)
    write(toJSON(lt, pretty=TRUE), file=jsonFile)
  }
  stashLinkedTxome(lt)
}

#' @name linkedTxome
#' @rdname linkedTxome
#' 
#' @export
loadLinkedTxome <- function(jsonFile) {
  stashLinkedTxome(do.call(tibble, fromJSON(jsonFile)))
}

# given a single-row tibble 'lt', save this into the linkedTxomeTbl
# (the linkedTxome tibble lives in the tximeta BiocFileCache)
stashLinkedTxome <- function(lt) {
  stopifnot(is(lt, "tbl"))
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  q <- bfcquery(bfc, "linkedTxomeTbl")
  if (bfccount(q) == 0) {
    message("saving linkedTxome in bfc (first time)")
    savepath <- bfcnew(bfc, "linkedTxomeTbl", ext=".rds")
    linkedTxomeTbl <- lt
    saveRDS(linkedTxomeTbl, file=savepath)
  } else {
    loadpath <- bfcrpath(bfc, "linkedTxomeTbl")
    linkedTxomeTbl <- readRDS(loadpath)
    if (lt$index %in% linkedTxomeTbl$index) {
      m <- match(lt$index, linkedTxomeTbl$index)
      stopifnot(length(m) == 1)
      if (all(mapply(identical, lt, linkedTxomeTbl[m,]))) {
        message("linkedTxome is same as already in bfc")
      } else {
        message("linkedTxome was different than one in bfc, replacing")
        linkedTxomeTbl[m,] <- lt
      }
    } else {
      message("saving linkedTxome in bfc")
      linkedTxomeTbl <- rbind(linkedTxomeTbl, lt)
    }
    saveRDS(linkedTxomeTbl, file=loadpath)
  }
  invisible()
}

hashit <- function(source, organism, release, catNC=FALSE, ...) {

  if (source == "GENCODE") {
    if (organism == "Homo sapiens") {
      fasta <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_human/release_",
                      release,"/gencode.v",release,".transcripts.fa.gz")
      gtf <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_human/release_",
                    release,"/gencode.v",release,".annotation.gtf.gz")
      genome <- "GRCh38"
    }
    if (organism == "Mus musculus") {
      fasta <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_",
                      release,"/gencode.v",release,".transcripts.fa.gz")
      gtf <- paste0("ftp://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_",
                    release,"/gencode.v",release,".annotation.gtf.gz")
      if (as.numeric(sub("M", "", release)) >= 26) {
        genome <- "GRCm39"
      } else {
        genome <- "GRCm38"
      }
    }
  }
  
  if (source == "Ensembl") {
    org <- sub(" ","_",tolower(organism))
    org_upper <- sub(" ","_",organism)
    genome <- if (organism == "Homo sapiens") {
                "GRCh38"
              } else if (organism == "Mus musculus") {
                if (as.numeric(release) >= 103) {
                  "GRCm39"
                } else {
                  "GRCm38"
                }
              } else if (organism == "Drosophila melanogaster") {
                if (as.numeric(release) >= 114) {
                  "BDGP6.54"
                } else if (as.numeric(release) >= 110) {
                  "BDGP6.46"
                } else if (as.numeric(release) >= 103) {
                  "BDGP6.32"
                } else if (as.numeric(release) >= 99) {
                  "BDGP6.28"
                } else if (as.numeric(release) >= 96) {
                  "BDGP6.22"
                } else {
                  "BDGP6"
                }
              } 
  
    fasta <- paste0("ftp://ftp.ensembl.org/pub/release-",
                    release,"/fasta/",org,"/cdna/",org_upper,".",genome,".cdna.all.fa.gz")
    if (catNC) {
      nc <- paste0("ftp://ftp.ensembl.org/pub/release-",
                   release,"/fasta/",org,"/ncrna/",org_upper,".",genome,".ncrna.fa.gz")
      fasta <- c(fasta, nc)
    }
    gtf <- paste0("ftp://ftp.ensembl.org/pub/release-",
                  release,"/gtf/",org,"/",org_upper,".",genome,".",release,".gtf.gz")

  }

  if (source == "RefSeq") {
    org_upper <- sub(" ","_",organism)
    chop <- function(x) as.numeric(sub(".*\\.p","",x))
    if (organism == "Homo sapiens") {
      genome <- "GRCh38"
      release_num <- chop(release) + 26
      gcf <- "GCF_000001405"
    } else if (organism == "Mus musculus") {
      genome <- "GRCm38"
      release_num <- chop(release) + 20
      gcf <- "GCF_000001635"
    }
    fasta <- paste0("ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/vertebrate_mammalian/",org_upper,
                    "/all_assembly_versions/",gcf,".",release_num,"_",release,"/",
                    gcf,".",release_num,"_",release,"_rna.fna.gz")
    gtf <- paste0("ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/vertebrate_mammalian/",org_upper,
                  "/all_assembly_versions/",gcf,".",release_num,"_",release,"/",
                  gcf,".",release_num,"_",release,"_genomic.gff.gz")
  }

  #message(fasta)
  #message(gtf)
  
  stopifnot(all(sapply(fasta, RCurl::url.exists)))
  stopifnot(RCurl::url.exists(gtf))
  if (catNC) {
    for (f in fasta) {
      download.file(f, basename(f), ...)
    }
    system(paste("cat",paste(basename(fasta),collapse=" "),"> transcripts.fa.gz"))
    for (f in fasta) {
      system(paste("rm -f",basename(f)))
    }
  } else {
    download.file(fasta, "transcripts.fa.gz", ...)
  }
  system("gunzip transcripts.fa.gz")
  system("compute_fasta_digest --reference transcripts.fa --out hash.json")
  sha256 <- jsonlite::fromJSON("hash.json")$seq_hash
  df <- data.frame(source, organism, release, genome, paste(fasta, collapse=" "), gtf, sha256)
  write.table(df, file="newrows.csv", append=TRUE, quote=FALSE, sep=",", row.names=FALSE, col.names=FALSE)
  system("rm -f transcripts.fa")
  system("rm -f hash.json")
  message("done!")
}

# download method
m <- "wget"

i <- 50
hashit("GENCODE", "Homo sapiens", i, method=m)
i <- 39
hashit("GENCODE", "Mus musculus", paste0("M",i), method=m)
#
i <- 116
hashit("Ensembl", "Homo sapiens", i, method=m)
hashit("Ensembl", "Mus musculus", i, method=m)
hashit("Ensembl", "Drosophila melanogaster", i, method=m)
#
hashit("Ensembl", "Homo sapiens", i, catNC=TRUE, method=m)
hashit("Ensembl", "Mus musculus", i, catNC=TRUE, method=m)
hashit("Ensembl", "Drosophila melanogaster", i, catNC=TRUE, method=m)
#
# RefSeq permalink transcriptomes are rarely updated
hashit("RefSeq", "Homo sapiens", paste0("GRCh38.p",i), method=m)
hashit("RefSeq", "Mus musculus", paste0("GRCm38.p",i), method=m)

#' Retrieve the TxDb or EnsDb associated with a SummarizedExperiment
#'
#' SummarizedExperiment objects returned by \code{\link{tximeta}} have
#' associated TxDb or EnsDb databases which are cached locally and used
#' to perform various metadata related tasks. This helper function
#' retrieves the database itself for the user to perform any additional
#' operations.
#'
#' @param se the SummarizedExperiment
#'
#' @return a database object
#'
#' @examples
#'
#' example(tximeta)
#' edb <- retrieveDb(se)
#' 
#' @export
retrieveDb <- function(se) {
  missingMetadata(se, summarize=FALSE)
  txomeInfo <- metadata(se)$txomeInfo
  getTxDb(txomeInfo)
}

#' Retrieve the cDNA transcript sequence for a SummarizedExperiment
#'
#' This helper function retrieves the cDNA sequence of
#' the transcripts used for expression quantification.
#' This function either downloads or loads the transcript
#' sequence from cache, it does not re-order or check against
#' the rows of the SummarizedExperiment (which could be
#' already summarized to genes for example).
#'
#' @param se the SummarizedExperiment
#' @param quiet logical, suppress messages
#'
#' @return a DNAStringSet object
#'
#' @examples
#'
#' \dontrun{
#' # this example is not run because it requires access to Ensembl ftp
#' example(tximeta)
#' cdna <- retrieveCDNA(se)
#' }
#' 
#' @export
retrieveCDNA <- function(se, quiet=FALSE) {
  if (!is(se, "SummarizedExperiment")) {
    txomeInfo <- se
  } else {
    missingMetadata(se, summarize=FALSE)
    txomeInfo <- metadata(se)$txomeInfo
  }
  cdna.id <- paste0("cdna-",substr(txomeInfo$sha256,1,32))
  bfcloc <- getBFCLoc()
  bfc <- BiocFileCache(bfcloc)
  q <- bfcquery(bfc, cdna.id)
  if (bfccount(q) == 1) {
    loadpath <- bfcrpath(bfc, cdna.id)
    cdna <- readRDS(loadpath)
  } else { 
    if (is.list(txomeInfo$fasta)) {
      cdna <- list()
      for (i in seq_along(txomeInfo$fasta[[1]])) {
        cdna[[i]] <- readDNAStringSet(txomeInfo$fasta[[1]][i])
      }
      cdna <- do.call(c, cdna)
    } else {
      cdna <- readDNAStringSet(txomeInfo$fasta)
    }
    # save it to BFC so as not to repeat the above operation
    savepath <- bfcnew(bfc, cdna.id, ext=".rds")
    saveRDS(cdna, file=savepath)
  }
  if (!quiet) message("retrieving cDNA, note that sequence is not ordered or matched to the rows of 'se'")
  cdna
}

summarizeToGene.SummarizedExperiment <- function(object,
                                                 assignRanges=c("range","abundant"),
                                                 varReduce=FALSE,
                                                 skipRanges=FALSE,
                                                 ...) {

  # arguments:
  # assignRanges -
  #   "range" or "abundant", whether to return an SE
  #   with the GRanges set to the *range* of the isoforms,
  #   or the ranges of the most *abundant* isoform
  # varReduce - see ?tximport
  # skipRanges - whether to not make use of, or output, rowRanges

  assignRanges <- match.arg(assignRanges)

  # some preparation of txdb etc for working on ranges
  if (!skipRanges) {
    missingMetadata(object, summarize=TRUE)
    txomeInfo <- metadata(object)$txomeInfo
    txdb <- getTxDb(txomeInfo)
    message("obtaining transcript-to-gene mapping from database")
    suppressMessages({
      tx2gene <- select(txdb, keys(txdb, "TXNAME"), "GENEID", "TXNAME")
    })
    suppressWarnings({
      g <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="gene")
    })
    # need to add seqinfo for GENCODE and RefSeq
    if (all(is.na(seqlengths(g)))) {
      seqinfo(g) <- seqinfo(object)
    }
    # note here about how ranges will be assigned
    if (assignRanges == "abundant") {
      message("assignRanges='abundant': gene ranges assigned by isoform abundance
  see details at: ?summarizeToGene,SummarizedExperiment-method")
    } else {
      message("assignRanges='range': gene ranges assigned by total range of isoforms
  see details at: ?summarizeToGene,SummarizedExperiment-method")
    }
  }

  # make a txi list like tximport would output
  txi <- list(
    abundance=assays(object)[["abundance"]],
    counts=assays(object)[["counts"]],
    length=assays(object)[["length"]],
    countsFromAbundance="no"
  )

  # deal with inferential replicates, if present
  if ("infRep1" %in% assayNames(object)) {
    infReps <- list(assays(object)[grep("infRep", assayNames(object))])
    if (varReduce) {
      # split from per replicate list into per sample list
      # (this is what tximport expects for varReduce=TRUE)
      infReps <- list(splitInfReps(infReps[[1]]))
    }
    txi <- c(txi, infReps=infReps)
  } else {
    if (varReduce) stop("cannot calculate inferential variance without inferential replicates")
  }

  if (skipRanges) {
    txi.gene <- summarizeToGene(object=txi, varReduce=varReduce, ...)
  } else {
    txi.gene <- summarizeToGene(object=txi, tx2gene=tx2gene, varReduce=varReduce, ...)
  }
  
  # put 'counts' in front to facilitate DESeqDataSet construction
  assays <- txi.gene[c("counts","abundance","length")]
  if (varReduce) {
    assays <- c(assays, txi.gene["variance"])
  } else if ("infRep1" %in% assayNames(object)) {
    infReps <- txi.gene$infReps
    assays <- c(assays, infReps)
  }

  if (!skipRanges) {
    # here do the same check/subset but with the gene-level
    # tximport assay matrices and gene ranges
    assays <- checkAssays2Txps(assays, g)
    
    # TODO give a warning here if there are genes in TxDb not in Salmon index?
    g <- g[rownames(assays[["counts"]])]
    
    # store txp IDS
    tx_ids <- CharacterList(split(tx2gene$TXNAME, tx2gene$GENEID))
    if (all(names(g) %in% names(tx_ids))) {
      tx_ids <- tx_ids[names(g)]
      mcols(g)$tx_ids <- tx_ids
    }
    
    # calculate duplication
    if ("hasDuplicate" %in% colnames(mcols(object))) {
      stopifnot(all(rownames(object) %in% tx2gene[,1]))
      t2g.o <- tx2gene[match(rownames(object),tx2gene[,1]),]
      has.dup.list <- LogicalList(split(mcols(object)$hasDuplicate, t2g.o$GENEID))
      mcols(g)$numDupObjects <- sum(has.dup.list)
    }
    
    # assign ranges based on most abundant isoform
    # (for the expressed genes)
    if (assignRanges == "abundant") {
      stopifnot(!is.null(rowRanges(object)))
      iso_prop <- getIsoProps(tpm=assays(object)[["abundance"]],
                              t2g=tx2gene)
      # order by the rowRanges of the outgoing object
      iso_prop <- iso_prop[names(g)]
      # remove unexpressed genes
      expressed <- !sapply(iso_prop, \(x) all(is.nan(x)))
      # compute the most abundant isoform of expressed genes
      mostAbundant <- sapply(iso_prop[expressed], \(x) names(x)[which.max(x)])
      # assign all this data to mcols(g)
      mcols(g)$isoform <- NA
      assignIdx <- names(g) %in% names(mostAbundant)
      assignNms <- names(g)[assignIdx]
      mcols(g)$isoform[assignIdx] <- mostAbundant[assignNms]
      mcols(g)$max_prop <- sapply(iso_prop, max)
      mcols(g)$iso_prop <- NumericList(iso_prop)
      # bring over new start and end positions for the subset
      # of genes that have a most abundant isoform
      txp <- rowRanges(object)
      # if addExons has been called, here we flatten
      # we could also return a GRangesList but this would be complex
      if (is(txp, "GRangesList")) {
        txp <- unlist(range(txp))
      }
      txp <- txp[mcols(g)$isoform[assignIdx]]
      # assume seqnames and strand are the same
      stopifnot(all(seqnames(g)[assignIdx] == seqnames(txp)))
      stopifnot(all(strand(g)[assignIdx] == strand(txp)))
      start(g)[assignIdx] <- start(txp)
      end(g)[assignIdx] <- end(txp)
    }
  }
    
  metadata <- metadata(object)
  # stash countsFromAbundance value
  metadata$countsFromAbundance <- txi.gene$countsFromAbundance
  metadata$level <- "gene"
  metadata$assignRanges <- assignRanges # how were ranges assigned

  if (skipRanges) {
    return(SummarizedExperiment(assays=assays, colData=colData(object),
                                metadata=metadata))
  }

  gse <- SummarizedExperiment(
    assays=assays,
    rowRanges=g,
    colData=colData(object),
    metadata=metadata
  )
  
  gse
}

#' Summarize estimated quantitites to gene-level
#'
#' Summarizes abundances, counts, lengths, (and inferential
#' replicates or variance) from transcript- to gene-level.
#' Transcript IDs are stored as a CharacterList in the \code{mcols}
#' of the output object.
#' This function operates on SummarizedExperiment objects, and
#' will automatically access the relevant TxDb (by either finding it
#' in the BiocFileCache or by building it from an ftp location).
#' This function uses the tximport package to perform summarization,
#' where a method is defined that works on simple lists.
#'
#' @param object a SummarizedExperiment produced by \code{tximeta}
#' @param assignRanges \code{"range"} or \code{"abundant"}, this argument
#' controls the way that the \code{rowRanges} of the output object are assigned
#' (note that this argument does not affect data aggregation at all).
#' The default is to just output the entire \code{range} of the gene,
#' i.e. the leftmost basepair to the rightmost basepair across all isoforms.
#' Alternatively, for expressed genes, one can obtain the start and end
#' of the most \code{abundant} isoform (averaging over all samples).
#' Non-expressed genes will have \code{range}-based positions.
#' For \code{abundant}, for expressed genes,
#' the name of the range-assigned \code{isoform}, \code{max_prop}
#' (maximum isoform proportion), and \code{iso_prop} (numeric values for
#' isoform proportions) are also returned in \code{mcols}
#' @param varReduce whether to reduce per-sample inferential replicates
#' information into a matrix of sample variances \code{variance} (default FALSE)
#' @param skipRanges whether to skip making use of, or outputting, rowRanges
#' (default FALSE)
#' @param ... arguments passed to \code{tximport}
#'
#' @return a SummarizedExperiment with summarized quantifications
#' and transcript IDs as a CharacterList in the \code{mcols}
#'
#' @rdname summarizeToGene
#' @docType methods
#' @aliases summarizeToGene,SummarizedExperiment-method
#' 
#' @examples
#'
#' example(tximeta)
#' gse <- summarizeToGene(se)
#'
#' @importFrom tximport summarizeToGene
#' 
#' @export
setMethod("summarizeToGene", signature(object="SummarizedExperiment"),
          summarizeToGene.SummarizedExperiment)

getIsoProps <- function(tpm, t2g) {
    rownames(t2g) <- t2g[,1]
    txId <- rownames(tpm)
    stopifnot(all(txId %in% t2g[,1]))
    t2g <- t2g[txId,]
    geneId <- t2g[,2]
    tpmGene <- rowsum(tpm, geneId)
    tpmGeneExpanded <- tpmGene[match(geneId,rownames(tpmGene)),,drop=FALSE]
    isoPropMat <- tpm / tpmGeneExpanded
    isoPropMat[is.nan(isoPropMat)] <- NA
    # want to pick an isoform even if some samples have 0 expression
    split(rowMeans(isoPropMat, na.rm=TRUE), geneId)
}

#' Split SummarizedExperiment by gene categories
#' 
#' Construct a new SummarizedExperiment by splitting one of the assays 
#' into a list of assays, each of which contains features of a given 
#' 'type'. It is assumed that there is a one-to-one correspondence 
#' between feature sets of different types; for example, these can be 
#' spliced and unspliced variants of the same transcripts. The type of
#' each feature in the original SummarizedExperiment, and the correspondence
#' between the features of different types, are given in a \code{data.frame}.
#' 
#' @param se A \code{SummarizedExperiment} object.
#' @param splitDf A \code{data.frame} with feature IDs. Each column 
#'   represents a separate feature type, and the features in a given 
#'   row are considered representatives of the same feature (and will 
#'   be represented as one feature in the output object).
#' @param assayName A character scalar, indicating the assay of \code{se}
#'   that will be split. Must be one of \code{assayNames(se)}.
#' 
#' @export
#' 
#' @return A \code{SummarizedExperiment} object with the same columns 
#'   as the input object, and the same number of assays as the number 
#'   of columns in \code{splitDf}. The assays will be named by the 
#'   column names of \code{splitDf}. The \code{colData} and \code{metadata}
#'   of the input \code{SummarizedExperiment} object are copied to the 
#'   output object. The row names are set to the feature IDs in the 
#'   first column of \code{splitDf}. 
#' 
#' @importFrom SummarizedExperiment assayNames assay SummarizedExperiment
#'   colData
#' @importFrom Matrix sparseMatrix
#' @importFrom S4Vectors SimpleList metadata
#'   
#' @examples
#' se <- SummarizedExperiment::SummarizedExperiment(
#'   assays = S4Vectors::SimpleList(
#'     counts = as(matrix(1:15, nrow = 5), "sparseMatrix"),
#'     logcounts = log2(matrix(1:15, nrow = 5))
#'   ), 
#'   colData = S4Vectors::DataFrame(sID = paste0("S", 1:3),
#'                                  condition = c("A", "A", "B")),
#'   metadata = list(md1 = "annotation")
#' )
#' rownames(se) <- paste0("G", 1:5)
#' colnames(se) <- paste0("P", 1:3)
#' splitDf <- data.frame(spliced = c("G1", "G2", "G6"), 
#'                       unspliced = c("G3", "G5", "G4"),
#'                       stringsAsFactors = FALSE)
#'                       
#' splse <- splitSE(se = se, splitDf = splitDf, assayName = "counts")
#' 
splitSE <- function(se, splitDf, assayName) {
    if (!(assayName %in% SummarizedExperiment::assayNames(se))) {
        stop("'assayName' must be one of assayNames(se)")
    }
    if (!is(se, "SummarizedExperiment")) {
        stop("'se' must be a SummarizedExperiment object")
    }
    if (!is(splitDf, "data.frame")) {
        stop("'splitDf' must be a data.frame")
    }
    for (cn in colnames(splitDf)) {
        if (is(splitDf[[cn]], "factor")) {
            warning("Converting the '", cn, "' column to character")
            splitDf[[cn]] <- as.character(splitDf[[cn]])
        }
    }
    
    ## Subset splitDf to rows where at least one of the features 
    ## are in the SE.
    l <- vapply(splitDf, function(i) any(i %in% rownames(se)), FALSE)
    l <- names(l[!l])
    if (length(l) > 0) {
        stop("None of the IDs in the ", 
             paste(l, collapse = ", "), " column", ifelse(length(l) > 1, "s", ""), 
             " are present in rownames(se)")
    }
    splitDf <- splitDf[
        rowSums(sapply(splitDf, function(i) i %in% rownames(se))) > 0, 
        , drop = FALSE]
    
    ## Create new assays from the 'assayName' assay, 
    ## named by the columns of 'splitDf'.
    ## All assays will have rownames from the first 
    ## column in 'splitDf'.
    assays <- lapply(splitDf, function(i) {
        if (is(SummarizedExperiment::assay(se, assayName), "sparseMatrix")) {
            tmp <- Matrix::sparseMatrix(
                i = integer(0), j = integer(0), x = numeric(0),
                dims = c(length(i), ncol(se)),
                dimnames = list(i, colnames(se))
            )
        } else {
            tmp <- matrix(0, nrow = length(i), ncol = ncol(se),
                          dimnames = list(i, colnames(se)))
        }
        idx <- intersect(i, rownames(se))
        tmp[idx, ] <- SummarizedExperiment::assay(se, assayName)[idx, ]
        rownames(tmp) <- splitDf[, 1]
        tmp
    })
    
    SummarizedExperiment::SummarizedExperiment(
        assays = S4Vectors::SimpleList(assays), 
        colData = SummarizedExperiment::colData(se),
        metadata = S4Vectors::metadata(se)
    )
}

context("splitSE")

test_that("splitSE works as expected", {
    ## --------------------------------------------------------------------- ##
    ## Regular dense matrix
    ## --------------------------------------------------------------------- ##
    se <- SummarizedExperiment::SummarizedExperiment(
        assays = SimpleList(
            counts = matrix(1:15, nrow = 5),
            logcounts = log2(matrix(1:15, nrow = 5))
        ), 
        colData = S4Vectors::DataFrame(sID = paste0("S", 1:3),
                                       condition = c("A", "A", "B")),
        metadata = list(md1 = "annotation")
    )
    splitDf <- data.frame(spliced = c("G1", "G2", "G4"), 
                          unspliced = c("G3", "G5", "G6"),
                          stringsAsFactors = FALSE)
    ## Check that splitting fails if SE does not have row names
    expect_error(splitSE(se = se, splitDf = splitDf, assayName = "counts"),
                 regexp = "None of the IDs in the spliced, unspliced columns")
    ## Check that splitting fails if the row names of SE do not match 
    ## the IDs in splitDf
    rownames(se) <- paste0("G", c(1, 2, 33, 4, 55))
    expect_error(splitSE(se = se, splitDf = splitDf, assayName = "counts"),
                 regexp = "None of the IDs in the unspliced column")
    
    ## Set correct dimnames
    rownames(se) <- paste0("G", 1:5)
    colnames(se) <- paste0("P", 1:3)
    
    splse <- splitSE(se = se, splitDf = splitDf, assayName = "counts")
    
    expect_equal(nrow(splse), 3L)
    expect_equal(ncol(splse), 3L)
    expect_equal(colnames(splse), colnames(se))
    expect_equal(rownames(splse), splitDf[, 1])
    expect_equal(SummarizedExperiment::assayNames(splse), 
                 colnames(splitDf))
    expect_equal(S4Vectors::metadata(splse),
                 S4Vectors::metadata(se))
    expect_equal(SummarizedExperiment::colData(splse),
                 SummarizedExperiment::colData(se))
    expect_equal(assay(splse, "spliced"), 
                 matrix(c(1, 2, 4, 6, 7, 9, 11, 12, 14), 
                        nrow = 3L, ncol = 3L,
                        dimnames = list(c("G1", "G2", "G4"),
                                        c("P1", "P2", "P3"))))
    expect_equal(assay(splse, "unspliced"), 
                 matrix(c(3, 5, 0, 8, 10, 0, 13, 15, 0), 
                        nrow = 3L, ncol = 3L,
                        dimnames = list(c("G1", "G2", "G4"),
                                        c("P1", "P2", "P3"))))
    
    ## --------------------------------------------------------------------- ##
    ## Sparse matrix
    ## --------------------------------------------------------------------- ##
    se <- SummarizedExperiment::SummarizedExperiment(
        assays = SimpleList(
            counts = as(matrix(1:15, nrow = 5), "sparseMatrix"),
            logcounts = log2(matrix(1:15, nrow = 5))
        ), 
        colData = S4Vectors::DataFrame(sID = paste0("S", 1:3),
                                       condition = c("A", "A", "B")),
        metadata = list(md1 = "annotation")
    )
    rownames(se) <- paste0("G", 1:5)
    colnames(se) <- paste0("P", 1:3)
    splitDf <- data.frame(spliced = c("G1", "G2", "G6"), 
                          unspliced = c("G3", "G5", "G4"),
                          stringsAsFactors = FALSE)
    
    splse <- splitSE(se = se, splitDf = splitDf, assayName = "counts")
    
    expect_equal(nrow(splse), 3L)
    expect_equal(ncol(splse), 3L)
    expect_equal(colnames(splse), colnames(se))
    expect_equal(rownames(splse), splitDf[, 1])
    expect_equal(SummarizedExperiment::assayNames(splse), 
                 colnames(splitDf))
    expect_equal(S4Vectors::metadata(splse),
                 S4Vectors::metadata(se))
    expect_equal(SummarizedExperiment::colData(splse),
                 SummarizedExperiment::colData(se))
    expect_equal(assay(splse, "spliced"), 
                 as(matrix(c(1, 2, 0, 6, 7, 0, 11, 12, 0), 
                           nrow = 3L, ncol = 3L,
                           dimnames = list(c("G1", "G2", "G6"),
                                           c("P1", "P2", "P3"))), "sparseMatrix"))
    expect_equal(assay(splse, "unspliced"), 
                 as(matrix(c(3, 5, 4, 8, 10, 9, 13, 15, 14), 
                           nrow = 3L, ncol = 3L,
                           dimnames = list(c("G1", "G2", "G6"),
                                           c("P1", "P2", "P3"))), "sparseMatrix"))
    
    ## --------------------------------------------------------------------- ##
    ## Sparse matrix, check that factors are converted to characters
    ## --------------------------------------------------------------------- ##
    se <- SummarizedExperiment::SummarizedExperiment(
        assays = SimpleList(
            counts = as(matrix(1:15, nrow = 5), "sparseMatrix"),
            logcounts = log2(matrix(1:15, nrow = 5))
        ), 
        colData = S4Vectors::DataFrame(sID = paste0("S", 1:3),
                                       condition = c("A", "A", "B")),
        metadata = list(md1 = "annotation")
    )
    rownames(se) <- paste0("G", 1:5)
    colnames(se) <- paste0("P", 1:3)
    splitDf <- data.frame(spliced = c("G1", "G6", "G2"), 
                          unspliced = c("G3", "G5", "G4"),
                          stringsAsFactors = TRUE)
    
    expect_warning(splse <- splitSE(se = se, splitDf = splitDf, assayName = "counts"),
                   regexp = "Converting the 'spliced' column to character")
    
    expect_equal(nrow(splse), 3L)
    expect_equal(ncol(splse), 3L)
    expect_equal(colnames(splse), colnames(se))
    expect_equal(rownames(splse), as.character(splitDf[, 1]))
    expect_equal(SummarizedExperiment::assayNames(splse), 
                 colnames(splitDf))
    expect_equal(S4Vectors::metadata(splse),
                 S4Vectors::metadata(se))
    expect_equal(SummarizedExperiment::colData(splse),
                 SummarizedExperiment::colData(se))
    expect_equal(assay(splse, "spliced"), 
                 as(matrix(c(1, 0, 2, 6, 0, 7, 11, 0, 12), 
                           nrow = 3L, ncol = 3L,
                           dimnames = list(c("G1", "G6", "G2"),
                                           c("P1", "P2", "P3"))), "sparseMatrix"))
    expect_equal(assay(splse, "unspliced"), 
                 as(matrix(c(3, 5, 4, 8, 10, 9, 13, 15, 14), 
                           nrow = 3L, ncol = 3L,
                           dimnames = list(c("G1", "G6", "G2"),
                                           c("P1", "P2", "P3"))), "sparseMatrix"))
    
})

# breaking out a lot of alevin specific code that was in main tximeta() body
# Sep 2025 -- this could be cleaned up more...
# mostly this is being preserved as legacy code for importing alevin as SE/SCE
tximetaAlevin <- function(
  coldata,
  type = "alevin",
  txOut,
  skipMeta,
  skipSeqinfo,
  useHub,
  markDuplicateTxps,
  cleanDuplicateTxps,
  customMetaInfo,
  skipFtp,
  ...
) {
  message(paste("importing", type, "quantification files"))

  files <- as.character(coldata$files)

  if (length(files) > 1) {
    stop("alevin import currently only supports a single experiment")
  }

  # remove the files column from colData
  coldata <- subset(coldata, select = -files)

  # tximeta metadata
  metadata <- makeMetadata(type)

  if (skipMeta) {
    txi <- tximport(files, type = type, txOut = txOut, ...)
    metadata$countsFromAbundance <- txi$countsFromAbundance
    coldata <- data.frame(row.names = colnames(txi[["counts"]]))
    se <- makeUnrangedSE(txi, coldata, metadata)
    return(se)
  } else {
    if (!txOut) {
      stop(
        "tximeta is designed to have transcript-level output for Salmon and piscem.
  set txOut=TRUE and use summarizeToGene for gene-level summarization"
      )
    }
  }

  metaInfo <- list(getMetaInfo(
    dirname(files),
    type = "salmon",
    customMetaInfo = customMetaInfo
  ))

  # Salmon's SHA-256 hash of the index is called "index_seq_hash" in the meta_info.json file
  indexSeqHash <- metaInfo[[1]]$index_seq_hash # first sample

  # reshape
  metaInfo <- reshapeMetaInfo(metaInfo, hashType="salmon")
  # add to metadata list
  metadata$quantInfo <- metaInfo

  # try to import files early, so we don't waste user time
  # with metadata magic before a tximport error
  txi <- tximport(files, type = type, txOut = TRUE, ...)
  metadata$countsFromAbundance <- txi$countsFromAbundance

  # try and find a matching txome
  txomeInfo <- getTxomeInfo(digest = indexSeqHash, prefer=c("txome","precomputed"))
  if (is.null(txomeInfo)) {
    message(
      "couldn't find matching transcriptome, returning non-ranged SummarizedExperiment"
    )
    coldata <- data.frame(row.names = colnames(txi[["counts"]]))
    se <- makeUnrangedSE(txi, coldata, metadata)
    return(se)
  }

  # build or load a TxDb from the gtf
  txdb <- getTxDb(txomeInfo, useHub = useHub, skipFtp = skipFtp)

  # build or load transcript ranges (alevin gets gene ranges instead)
  # alevin gets gene ranges instead
  message("generating gene ranges")
  # here gene ranges are named 'txps' for compatibility with code below...
  txps <- getRanges(txdb = txdb, txomeInfo = txomeInfo, type = "gene")
  metadata$level <- "gene"

  # package up the assays
  if ("variance" %in% names(txi)) {
    if ("infReps" %in% names(txi)) {
      assays <- c(txi[c("counts", "variance")], txi$infReps)
      names(assays) <- c(
        "counts",
        "variance",
        paste0("infRep", seq_along(txi$infReps))
      )
    } else {
      assays <- txi[c("counts", "variance")]
    }
  } else {
    assays <- txi["counts"]
  }
  # add mean information as well if it exists in the list
  if ("mean" %in% names(txi)) {
    assays <- c(assays, txi["mean"])
  }
  # add tier information as well if it exists in the list
  if ("tier" %in% names(txi)) {
    assays <- c(assays, txi["tier"])
  }
  coldata <- data.frame(row.names = colnames(assays[["counts"]]))

  # Ensembl FASTA has txp version numbers,
  # but in the Ensembl GTF it is not in the txname,
  # so here we have to remove the version number to build the SummarizedExperiment
  if (txomeInfo$source %in% c("Ensembl", "LocalEnsembl")) {
    txId <- sub("\\..*", "", rownames(assays[["counts"]]))
    for (nm in names(assays)) {
      rownames(assays[[nm]]) <- txId
    }
  }

  # the following functions modifies assays and txps to clean/mark duplicate txps 
  # (this occurs when salmon collapses identical transcripts during indexing)
  if (cleanDuplicateTxps) {
    dup.output.list <- duplicateTxpsClean(
      assays, txps, txomeInfo,
      markDuplicateTxps, cleanDuplicateTxps
    )
    assays <- dup.output.list$assays
    txps <- dup.output.list$txps
  }
  assays <- stripAllCharsAfterBar(assays)
  assays <- checkAssays2Txps(assays, txps)
  txps <- txps[rownames(assays[["counts"]])]
  if (markDuplicateTxps) {
    dup.output.list <- duplicateTxpsMark(
      assays, txps, txomeInfo,
      markDuplicateTxps, cleanDuplicateTxps
    )
    assays <- dup.output.list$assays
    txps <- dup.output.list$txps
  }

  # Ensembl already has nice seqinfo attached...
  # if GENCODE, and not from AHub (which have seqinfo)
  missingSeqinfo <- any(is.na(seqlengths(txps)))
  if (txomeInfo$source == "GENCODE" & !skipSeqinfo & missingSeqinfo) {
    message("fetching genome info for GENCODE")
    ucsc.genome <- genome2UCSC(txomeInfo$genome)
    try(seqinfo(txps) <- Seqinfo(genome = ucsc.genome)[seqlevels(txps)])
  } else if (txomeInfo$source == "RefSeq" & !skipSeqinfo & missingSeqinfo) {
    # if RefSeq...
    message("fetching genome info for RefSeq")
    refseq.genome <- gtf2RefSeq(txomeInfo$gtf, txomeInfo$genome)
    stopifnot(all(seqlevels(txps) %in% seqnames(refseq.genome)))
    try(seqinfo(txps) <- refseq.genome[seqlevels(txps)])
  }

  # add more metadata
  txdbInfo <- metadata(txdb)$value
  names(txdbInfo) <- metadata(txdb)$name
  metadata$txomeInfo <- txomeInfo
  metadata$txdbInfo <- txdbInfo

  se <- SummarizedExperiment(
    assays = assays,
    rowRanges = txps,
    colData = coldata,
    metadata = metadata
  )
  se
}

#' Import quantification across mixed reference transcripts
#'
#' The _oarfish_ and _salmon_ quantification tools allow a mix of
#' `--annotated` reference transcripts (e.g. GENCODE, Ensembl) and
#' `--novel` or custom transcripts (e.g. de novo assembled transcripts not present
#' in the annotated set) to be used as the index for quantification.
#' `importData()` and associated functions facilitate import, reference identification,
#' and addition of metadata across `annotated` and/or `novel` transcripts.
#' The `importData()` function alone imports the data, while inspection of the
#' recognized digests and updating of transcript metadata is handled by subsequent functions
#' (listed in _See also_ section below).
#'
#' oarfish with mixed reference transcript sets may have been generated with e.g.
#'
#' \preformatted{
#' oarfish --only-index --annotated gencode.v48.transcripts.fa.gz \
#'   --novel my_novel_txps.fa.gz --seq-tech ont-cdna --threads 32 \
#'   --index-out gencode_plus_novel
#' oarfish --reads reads/experiment_rep1.fastq.gz --index gencode_plus_novel \
#'   --output quants/experiment_rep1 --seq-tech ont-cdna \
#'   --filter-group no-filters --threads 32
#' }
#'
#' For _salmon_, per-sub-index digests are not recorded natively. Instead, a
#' companion Snakemake rule runs `compute_fasta_digest` on each FASTA at index
#' time and writes `mixed_ref_digests.json` into each quantification directory.
#' Pass the filename via `mixedDigest` so that `importData()` can find it:
#'
#' \preformatted{
#' se <- importData(coldata, type="salmon", mixedDigest="mixed_ref_digests.json")
#' }
#'
#' @param coldata data.frame with columns `files` and `names` as in `tximeta()`
#' @param type what quantifier was used (see [tximport::tximport()]);
#' `importData()` supports `"oarfish"` and `"salmon"` (with `mixedDigest`)
#' @param mixedDigest for `type="salmon"`, the filename (relative to each
#' sample's quantification directory) of the JSON file containing per-sub-index
#' sha256 digests, e.g. `"mixed_ref_digests.json"`. This file is produced by
#' the companion Snakemake rule that runs `compute_fasta_digest` on the
#' annotated and novel FASTAs at index time and writes the results in
#' a structure compatible with `inspectDigests()` and `updateMetadata()`.
#' Not needed for `type="oarfish"`, which records digests natively.
#' @param quiet whether to suppress printed messages
#' @param ... arguments passed to [tximport::tximport()]
#'
#' @return an un-ranged SummarizedExperiment (SE) object, for 
#' use with subsequent functions described in _See also_ section
#'
#' @seealso `inspectDigests()` and `updateMetadata()` for subsequent tasks
#' of inspecting digest matches and updating metadata, respectively.
#' `makeLinkedTxome()` can be used to add custom metadata into the registry used
#' for inspecting digests and then updating transcript data. A user may 
#' follow the workflow `importData()` > `inspectDigests()` > 
#' `makeLinkedTxome()` > `inspectDigests()` > `updateMetadata()`.
#' See also `makeLinkedTxpData()` for a lightweight alternative of linking
#' _GRanges_ metadata to a digest.
#' 
#' @examples
#' 
#' # oarfish files using a mix of --annotated and --novel transcripts
#' dir <- system.file("extdata/oarfish", package="tximportData")
#' names <- paste0("rep", 2:4)
#' files <- file.path(dir, paste0("sgnex_h9_", names, ".quant.gz"))
#' coldata <- data.frame(files, names)
#' 
#' # returns an un-ranged SE object
#' se <- importData(coldata, type="oarfish")
#' 
#' @export
importData <- function(coldata, type="oarfish", mixedDigest=NULL, quiet=FALSE, ...) {

  if (!type %in% c("oarfish", "salmon")) {
    warning("importData() supports oarfish and salmon files; broader support is planned in future updates")
  }
  if (type == "salmon" && is.null(mixedDigest)) {
    stop("for type='salmon', provide `mixedDigest` with the filename of the per-sub-index digest JSON (e.g. 'mixed_ref_digests.json')")
  }
  
  # tximeta metadata
  metadata <- makeMetadata(type)

  files <- as.character(coldata$files)
  names(files) <- coldata$names
  txi <- tximport(files, type=type, txOut=TRUE, ...)
  metadata$countsFromAbundance <- txi$countsFromAbundance

  # `metaInfo` = list with quantification tool metadata from JSON files
  # that are alongside quantification files in newer tools
  metaInfo <- lapply(
    files,
    getMetaInfo,
    type=type,
    mixedDigest=mixedDigest
  )

  # different styles of storing hash value by method
  hashType <- type2hashType(type)
  
  # check the sequence digest (hash) of the transcriptome index with 1st sample
  # readIndexSeqHash() returns a list of functions
  # TODO - Sep 2025: currently this code just looks at the annotated digest,
  # could also look at the novel and confirm it is also consistent
  indexSeqHash <- readIndexSeqHash()[[hashType]](metaInfo[[1]])
  if (length(files) > 1) {
    hashes <- sapply(metaInfo, readIndexSeqHash()[[hashType]])
    if (!all(hashes == indexSeqHash)) {
      stop("the samples do not share the same index, and cannot be imported")
    }
  }

  digestList <- names(metaInfo[[1]]$digest)
  if (!all(paste0(c("annotated","novel"),"_transcripts_digest") %in% digestList))
      stop(
      "importData() is designed for mixed `annotated` and `novel` transcript references\n",
      "otherwise use tximeta() which will prioritize the `annotated` transcript set\n",
      "or tximeta(..., skipMeta=TRUE) to import all transcripts"
    )
  
  # reshape this list object, invert the JSON hierarchy 
  # and examine consistency of the digest 'index_seq_hash'
  metaInfo <- reshapeMetaInfo(metaInfo, hashType="oarfish")
  
  # add the per-sample metadata from quantification JSON files to the metadata list object
  metadata$quantInfo <- metaInfo

  # assemble list of matrices for outputting an unranged SE
  assays <- txi[c("counts","abundance","length")]

  # GENCODE usually has characters after the ENST... 
  # these disrupt metadata operations (adding ranges or IDs)
  assays <- stripAllCharsAfterBar(assays)

  se <- makeUnrangedSE(assays, coldata, metadata)
  
  if (!quiet)
    message("returning un-ranged SummarizedExperiment, see functions:\n",
            "-- inspectDigests() to check matching digests\n",
            "-- makeLinkedTxome/makeLinkedTxpData() to link digests to metadata\n",
            "-- updateMetadata() to update metadata and optionally add ranges"
          )

  return(se)
}

#' Inspect digest matches from `importData()` imported data
#' 
#' This function takes as input a _SummarizedExperiment_ as output by `importData()`
#' and returns a tibble with information about the digest-match status of two
#' indices (`annotated` and `novel`), with respect to _tximeta_ metadata.
#' Inspection of index digests can be run iteratively, checking if
#' the digests used in the mixed reference transcript set 
#' have a match against 1) pre-computed digests representing 
#' standard annotated sets (e.g. GENCODE, Ensembl, etc.) 
#' or 2) digests added by the user to a local registry with 
#' `makeLinkedTxome()` (GTF file)
#' or `makeLinkedTxpData` (_GRanges_-based metadata). 
#' Optional columns may be added if specified by 
#' `fullDigest=TRUE` (include the full digest) and/or 
#' `count=TRUE` (add matching transcript ID counts per index).
#' Following inspection, one can run `updateMetadata()` to automatically update
#' the transcript metadata using the sources indicated by this function.
#'
#' @param se the _SummarizedExperiment_ output by `importData()`,
#'  or alternatively just
#' `metadata(se)$quantInfo`, a list of metadata
#' information from the quantification tool 
#' (assuming `annotated` and `novel` indices both used)
#' @param type what quantifier was used (see [tximport::tximport()])
#' @param prefer vector of length up to 3, giving the preferred order of 
#' _tximeta_'s transcript registries to when finding matches, with elements:
#' `txome`: linkedTxome, 
#' `txpdata`: linkedTxpData,
#' `precomputed`: the pre-computed digests in tximeta
#' @param fullDigest whether to include the full digest string in the output, 
#' in addition to the shortened 6-char version
#' @param count whether to count the number of matching transcripts ID to each index
#' (only possible for those indices that have matching metadata).
#' Counting requires loading transcript data, either from locally cached databases
#' or from GTF files.
#' 
#' @return a 2-row tibble of the `annotated` and `novel` index, 
#' their matching information if available
#' (source, organism, release), for matches, 
#' whether it is a `linkedTxome` or a `linkedTxpData`
#' (both `FALSE`` for pre-computed) 
#' and a small 6 character version of the digest itself.
#' 
#' @examples
#' 
#' example(importData)
#' # now we have an `se` created by importData()...
#' inspectDigests(se)
#' # can then update the registry via makeLinkedTxome() and re-run inspection
#' 
#' @export
inspectDigests <- function(
  se, 
  type="oarfish", 
  prefer=c("txome","txpdata","precomputed"),
  fullDigest=FALSE, 
  count=FALSE
) {

  stopifnot(all(prefer %in% c("txome","txpdata","precomputed")))
  
  # take from first sample
  if (is(se, "SummarizedExperiment")) {
    digestList <- metadata(se)$quantInfo$digest[,1]
  } else {
    stopifnot(!count) # counting transcripts to indices requires rownames of an SE
    # assume `se` isn't SE but the `quantInfo` item
    digestList <- se$digest[,1]
  }
  
  # need to check, even though importData would have thrown error
  stopifnot(all(paste0(c("annotated","novel"),"_transcripts_digest") %in% names(digestList)))

  digests <- c(
    annotated = digestList$annotated_transcripts_digest$sha256_digests$sha256_seqs,
    novel = digestList$novel_transcripts_digest$sha256_digests$sha256_seqs
  )

  small_digest <- substr(digests, 1, 6)
 
  txomeInfo <- lapply(digests, getTxomeInfo, prefer, quiet=TRUE)

  # this is the tibble the function will return
  out <- tibble(
    index=c("annotated","novel"), 
    source=NA, organism=NA, release=NA, genome=NA,
    linkedTxome=NA, linkedTxpData=NA, small_digest
  )

  # put in the full digest if requested
  if (fullDigest) {
    out$digest <- digests
  }

  # columns to pull from the txomeInfo item
  cols <- c("source","organism","release","genome","linkedTxome","linkedTxpData")
  for (i in c("annotated","novel")) {
    # if there is a txomeInfo match, populate the outgoing tibble
    if (!is.null(txomeInfo[[i]])) {
      out[match(i,out$index),cols] <- txomeInfo[[i]][cols]
    }
  }

  if (count) {
    out$count <- 0
    for (i in c("annotated","novel")) {
      if (!is.null(txomeInfo[[i]])) {
        txps <- getTxpsFromTxome(txomeInfo = txomeInfo[[i]])
        out[match(i,out$index),"count"] <- sum(names(txps) %in% rownames(se))
      }
    }
  }

  out
}

#' Update transcript metadatda for `importData()` imported data
#'
#' This function takes as input a _SummarizedExperiment_ as output by `importData()`,
#' and will update the metadata on the transcripts when possible 
#' (updating `rowData` and/or `rowRanges` depending on the value of `ranges`).
#' `importData()` uses metadata pulled from digest matches in registries used by _tximeta_
#' (`linkedTxome`, `linkedTxpData`, and the pre-computed digests).
#' Additionally, _GRanges_ or _data.frame_-type data can be provided on a one-time basis 
#' via the argument `txpData`, which will annotate transcripts with `index="user"`.
#' See `inspectDigests()` for how to inspect which indices have matching digests, 
#' and how to link data to local metadata in a persistent manner.
#'
#' @param se the _SummarizedExperiment_ (SE) output by `importData()`
#' @param txpData either _GRanges_ or _data.frame_-type object
#' to use if there is not a match based on digest. 
#' This is used on a one-time basis, and transcripts
#' will be marked in metadata columns as `index = "user"``.
#' See `makeLinkedTxome()` or `makeLinkedTxpData()` for persistent
#' metadata storage/retrieval
#' @param ranges logical, whether to add `rowRanges` (or just `rowData`)
#' @param prefer vector of length up to 3, giving the preferred order of 
#' _tximeta_'s transcript registries to when finding matches, with elements:
#' `txome`: linkedTxome, 
#' `txpdata`: linkedTxpData,
#' `precomputed`: the pre-computed digests in tximeta
#' @param order order of index, in which to update the metadata, by default 
#' the order is `annotation`, then `novel`, then `user`, info supplied 
#' here as `txpData`
#' @param key a named character vector of length 3. For each index
#' (annotated, novel, and user) `key` is the name of the column to 
#' use for merging metadata with `rownames(se)`.
#' The `user` index corresponds to data provided here as `txpData`
#' Defaults to `"tx_name"` which often matches the transcript 
#' names in GENCODE
#'
#' @return a _SummarizedExperiment_ with new `rowData`,
#' or a _RangedSummarizedExperiment_ with new metadata
#'
#' @examples
#' 
#' example(importData)
#' 
#' # build custom novel GRanges data
#' library(GenomicRanges)
#' novel <- data.frame(
#'   seqnames = paste0("chr", rep(1:22, each=500)),  
#'   start = 1e6 + 1 + 0:499 * 1000, end = 1e6 + 1 + 0:499 * 1000 + 1000 - 1,
#'   strand = "+", tx_name = paste0("novel", 1:(22*500)),
#'   gene_id = paste0("novel_gene", rep(1:(22*10), each=50)), type = "protein_coding"
#' )
#' novel_gr <- as(novel, "GRanges")
#' names(novel_gr) <- novel$tx_name
#' 
#' # now update the metadata + ranges:
#' \dontrun{
#' # this requires connection to internet (will download GENCODE GTF via FTP)
#' se_with_ranges <- updateMetadata(
#'   se, txpData=novel_gr, ranges=TRUE
#' )
#' mcols(se_with_ranges)
#' }
#' 
#' @export
updateMetadata <- function(
  se,
  txpData = NULL,
  ranges = FALSE,
  prefer=c("txome","txpdata","precomputed"),
  order = c("annotated", "novel", "user"),
  key = c(annotated="tx_name", novel="tx_name", user="tx_name")
) {

  # check our standard index names
  idx_nms <- c("annotated","novel")
  all_idx_nms <- c(idx_nms, "user")
  stopifnot(all(order %in% all_idx_nms))
  stopifnot(all(names(key) %in% all_idx_nms))

  # pull out our digest's list of info:
  # this lives in metadata as information coming from the quantification tool
  digestList <- metadata(se)$quantInfo$digest[, 1]
  stopifnot(all(paste0(c("annotated","novel"),"_transcripts_digest") %in% names(digestList)))

  # we will just use a named list for `digest` here 
  # (maybe taking advantage of partial matching from seqcol later)
  digests <- c(
    annotated = digestList$annotated_transcripts_digest$sha256_digests$sha256_seqs,
    novel = digestList$novel_transcripts_digest$sha256_digests$sha256_seqs
  )

  # pull out the txomeInfo for each index
  txomeInfo <- lapply(digests, getTxomeInfo, prefer=c("txome","txpdata","precomputed"), quiet = TRUE)

  # empty GRanges, add to this per index / txpData in loop below
  if (ranges) {
    ranges_to_add <- GenomicRanges::GRanges()
  }

  # Proceed for each index `i` in a user-specified `order`, 
  # (by default annotated then novel then `txpData`),
  # updating the metadata columns in the rowData:
  #  
  # - pulling out rowData, 
  # - seeing what columns could be added/updated,
  # - resaving to the rowData slot. 
  # 
  # then move to the next index.
  for (i in order) {

    # get transcript data and determine 
    # the matches of rownames of `se` to these
    matches <- c()
    # first, annotated / novel index
    if (i %in% idx_nms) {
      if (!is.null(txomeInfo[[i]])) {
        txps <- getTxpsFromTxome(txomeInfo = txomeInfo[[i]])
        names_txps <- names(txps) # used for matching later
        txpDataToAdd <- mcols(txps) # metadata columns to work with
        matches <- intersect(rownames(se), names_txps)
      } else {
        # no match
        message(
          paste0("--", i, ": no transcript metadata found\n"),
          "  consider using `linkedTxome`, or `linkedTxpData` (see man pages)"
        )
      }

      # for the txpData-provided information..
    } else if (i == "user") {
      # either `txpData` is GRanges or data.frame-like thing
      if (!is.null(txpData)) {
        if (is(txpData, "GRanges")) {
          txps <- txpData # these will be used for the ranges
          names_txps <- names(txps) # used for matching later
          txpDataToAdd <- mcols(txpData) # metadata columns to work with
          mcols(txps) <- NULL
        } else {
          # no ranges just data.frame-like thing
          txpDataToAdd <- as(txpData, "DataFrame")
          names_txps <- txpData[[key[i]]]
        }
        matches <- intersect(rownames(se), names_txps)
      } else {

        # txpData wasn't provided, we are in the "user" part of the loop
        # need to skip to the end... and not do the next part again
        break

      }
    }

    # now we have `txps`/`txpDataToAdd` and `matches`
    if (length(matches) > 0) {
      message(paste0(
        "--",
        i,
        ": adding metadata for ",
        length(matches),
        " transcripts"
      ))
      idx_txps <- match(matches, names_txps) # index of the matches in the ranges
      txpDataToAdd <- txpDataToAdd[idx_txps, ] # put in order of matches
      
      # later in the function, ranges will be added
      if (ranges) {
        if (i %in% idx_nms | is(txpData, "GRanges")) {
          ranges_to_add <- c(ranges_to_add, txps[idx_txps])
        }
      }

      # pull out rowData for metadata additions
      rowdata <- rowData(se)
      # if rowdata is totally empty, need to add one column
      if (ncol(rowdata) == 0) {
        rowdata[[key[i]]] <- rownames(se)
      }
      # add in the metadata to the matching rows, and the index name
      rowdata <- mergeTxpDataIntoRowData(rowdata, txpDataToAdd, matches, indexName=i)
    } else {
      # matches of the transcripts from various sources to the rows of SE was 0
      message(paste0("--", i, ": no matching transcripts"))
    }

    # finally add the newly updated rowdata back to the SE
    SummarizedExperiment::rowData(se) <- rowdata

    # go to next index...
  }

  if (ranges) {
    # we've already dealt with metadata columns above, just add bare ranges
    mcols(ranges_to_add) <- NULL
    rng_matches <- intersect(rownames(se), names(ranges_to_add))
    if (length(rng_matches) < nrow(se)) {
      # print a note that we are subsetting to a smaller RangedSE than input
      message(paste(
        "building RangedSE: subsetting to",
        length(rng_matches),
        "out of",
        nrow(se),
        "rows with range data"
      ))
    }
    ranges_to_add <- ranges_to_add[rng_matches]
    se <- se[rng_matches, ]
    mcols(ranges_to_add) <- rowData(se)
    rowRanges(se) <- ranges_to_add
  }

  se
}

### un-exported helper functions ###

# txpDataToAdd and matches are in same order, not true for rowdata
mergeTxpDataIntoRowData <- function(rowdata, txpDataToAdd, matches, indexName) {
  # store the new transcript data back in the appropriate rows of the SE
  idx_rowdata <- match(matches, rownames(rowdata)) # index of the matches in the SE
  for (col in colnames(txpDataToAdd)) {
    if (!col %in% colnames(rowdata)) {
      # initialize with NA
      vector <- txpDataToAdd[, col]
      vector <- S4Vectors::endoapply(vector, \(x) NA)
      rowdata[col] <- rep(vector, length.out = nrow(rowdata))
    }
    rowdata[idx_rowdata, col] <- txpDataToAdd[, col]
  }
  # add the 'index' column and the indexName to the matching rows
  if (!"index" %in% colnames(rowdata)) {
    rowdata["index"] <- NA
  }
  rowdata[idx_rowdata, "index"] <- indexName
  rowdata
}

# function to pull out GRanges txps from txomeInfo whether 
# linkedTxome, pre-computed, or linkedTxpData
getTxpsFromTxome <- function(txomeInfo) {
  if (!txomeInfo$linkedTxpData) {
    # we have a linkedTxome or pre-computed digest match
    suppressMessages({
      txdb <- getTxDb(txomeInfo, useHub = FALSE, skipFtp = FALSE)
      txps <- getRanges(txdb = txdb, txomeInfo = txomeInfo, type = "txp")
    })
  } else if (txomeInfo$linkedTxpData) {
    # we have a linkedTxpData match
    digest32 <- substr(txomeInfo$digest, 1, 32)
    txpDataName <- paste0("txpdata-", digest32)
    bfc <- BiocFileCache(getBFCLoc())
    if (!existsInBFC(txpDataName, bfc)) {
      stop(paste0("TxpData of name: [", txpDataName, "] was expected in BFC"))
    }
    loadpath <- bfcrpath(bfc, rnames = txpDataName)
    txps <- readRDS(loadpath)
  }
  txps
}

context("mixed reference")
test_that("importing oarfish with mixed reference works as expected", {

  dir <- system.file("extdata/oarfish", package="tximportData")
  names <- paste0("rep", 2:4)
  files <- file.path(dir, paste0("sgnex_h9_", names, ".quant.gz"))
  coldata <- data.frame(files, names)

  # setting: user has run oarfish with, e.g. 
  # --annotated gencode.v48.transcripts.fa.gz 
  # --novel novel.fa.gz

  # skipMeta: we get back the quantification counts but no metadata
  se0 <- tximeta(coldata, type="oarfish", skipMeta=TRUE)

  gtf_dir <- system.file("extdata/gencode", package="tximportData")
  gtf <- file.path(gtf_dir, "gencode.v48.annotation.gtf.gz")
  makeLinkedTxome(
    digest = "6fc626c828b7a342ab0c6ff753055761989bf0e2306370e8766fedf45ad3adb3",
    indexName = "gencode.v48",
    source = "LocalGENCODE",
    organism = "Homo sapiens",
    release = "48",
    genome = "GRCh38",
    fasta = "/path/to/fasta.fa",
    gtf = gtf,
    write = FALSE
  )

  # this prompts them to use importData etc.
  expect_warning({
    se <- tximeta(coldata, type="oarfish")
  }, "the annotation is missing some transcripts")
  
  not_in_annotated <- rownames(se0)[!rownames(se0) %in% rownames(se)]
  
  # 22 chr x 500 txps per chrom = 11000 novel txps
  expect_equal(sum(grepl("novel",not_in_annotated)), 11000L)

  # rowData(se) # has tx_id, gene_id, tx_name from TxDb also ranges

  # define novel set so we can add metadata
  novel <- data.frame(
    seqnames = paste0("chr", rep(1:22, each=500)),
    start = 1e6 + 1 + 0:499 * 1000,
    end = 1e6 + 1 + 0:499 * 1000 + 1000 - 1,
    strand = "+",
    tx_name = paste0("novel", 1:(22*500)),
    gene_id = paste0("novel_gene", rep(1:(22*10), each=50)),
    type = "protein_coding"
  )
  library(GenomicRanges)
  novel_gr <- as(novel, "GRanges")
  names(novel_gr) <- novel$tx_name
  seqinfo(novel_gr) <- seqinfo(se)

  # importData for mixed references: first step returns an un-ranged SE
  se_mix <- importData(coldata, type="oarfish")
  
  # shows the indices and their digests
  inspectDigests(se_mix)
  # show full digest
  inspectDigests(se_mix, fullDigest=TRUE)
  # this is slower, requires loading the TxDb and ranges...
  inspectDigests(se_mix, count=TRUE)

  # populate what transcript metadata we can find:
  se_update <- updateMetadata(se_mix)
  mcols(se_update)

  # can add ranges, but that requires subsetting to a smaller object 
  # as we can't have a mix of ranges + no-range-data rows
  se_update_w_ranges <- updateMetadata(se_mix, ranges=TRUE)
  mcols(se_update_w_ranges)

  # the user then can add metadata via:
  # linkedTxome() / linkedTxpData() -- they can go do this
  # GRanges or data.frame-like thing
  se_update <- updateMetadata(se_mix, txpData=novel[,-(1:4)])
  mcols(se_update)
  table(mcols(se_update)$index)

  se_update_w_ranges <- updateMetadata(se_mix, txpData=novel_gr, ranges=TRUE)
  mcols(se_update_w_ranges)
  table(mcols(se_update_w_ranges)$index)

  library(BiocFileCache)
  bfc <- BiocFileCache(getBFCLoc())
  bfcinfo(bfc)

  # try out makeLinkedTxpData
  makeLinkedTxpData(
    digest = "43158f2c8e88e3acd77c22aee557625a6f1b6a5038cfc7deb5e64903892d8070",
    digestType = "sha256",
    indexName = "my_novel_txps",
    txpData = novel_gr,
    source = "novel", organism="Homo sapiens", 
    release="v1", genome="GRCh38"
  )

  inspectDigests(se_mix)

  inspectDigests(se_mix, count=TRUE)

})

test_that("mergeTxpDataIntoRowData() works with list-types from S4Vectors", {

  # mergeTxpDataIntoRowData() adds missing columns and fills in data for updating rowData
  # initializing list-type vectors from S4Vectors with NA is tested here

  library(S4Vectors)
  rowdata <- DataFrame(test=1:4, row.names=letters[1:4])
  txpDataToAdd <- DataFrame(
    foo=11:12,
    row.names=letters[2:3]
  )
  out <- mergeTxpDataIntoRowData(
    rowdata, txpDataToAdd,
    matches=c("b","c"), indexName="foobar"
  )
  out
  expect_equal(out$foo, c(NA,11,12,NA))

  # again, with list-like vector, `charlist`
  txpDataToAdd2 <- DataFrame(
    charlist = CharacterList("a","c","d"),
    row.names=letters[c(1,3,4)]
  )
  out2 <- mergeTxpDataIntoRowData(
    out, txpDataToAdd2,
    matches=c("a","c","d"), indexName="foobar"
  )
  expect_equal(out2$charlist, CharacterList("a",NA,"c","d"))
  
})

#' Get or set the directory of the BiocFileCache used by tximeta
#'
#' Running \code{getTximetaBFC} will report the saved directory,
#' if it has been determined, or will return NULL.
#' Running \code{setTximetaBFC} will ask the user to specify a
#' BiocFileCache directory for accessing and saving TxDb sqlite files.
#' Note that tximeta's BiocFileCache can be set by the environmental
#' variable \code{TXIMETA_HUB_CACHE}, which will reset the cache location.
#' 
#' @param dir the location for tximeta's BiocFileCache. can be missing
#' in which case the function will call \code{file.choose} for choosing
#' location interactively
#' @param quiet whether to suppress feedback message
#' 
#' @return the directory of the BiocFileCache used by tximeta
#' (or nothing, in the case of \code{setTximetaBFC})
#'
#' @rdname getTximetaBFC
#'
#' @examples
#'
#' # getting the BiocFileCache used by tximeta
#' # (may not be set, which uses BiocFileCache default or temp directory)
#' getTximetaBFC()
#'
#' # don't want to actually change user settings so this is not run:
#' # setTximetaBFC()
#' 
#' @export
getTximetaBFC <- function() {
  bfclocFile <- bfclocFile()
  if (!file.exists(bfclocFile)) {
    message("tximeta's BiocFileCache location has not yet been set")
    NULL
  } else {
    readBFCLocFile(bfclocFile)
  }
}

#' @rdname getTximetaBFC
#' 
#' @export
setTximetaBFC <- function(dir, quiet=FALSE) {
  if (missing(dir)) {
    message("which BiocFileCache directory should tximeta use? (press Enter to cancel)")
    bfcloc <- file.choose()
  } else {
    stopifnot(is(dir, "character"))
    bfcloc <- dir
  }
  bfclocFile <- bfclocFile()
  writeBFCLocFile(bfcloc)
  if (!quiet) message("for group use, set the permissions of this directory to allow group write (g+w)")
  invisible()
}

# not exported:

# Function to read the BiocFileCache location used by tximeta.
# The path is stored in the `tximeta` location  by R_user_dir().
# The file is 'bfcloc.json', and this simple file just records
# tximeta’s BiocFileCache (for storing the rest of the data).
bfclocFile <- function() {
  tximetaDir <- R_user_dir("tximeta", which="config")
  file.path(tximetaDir, "bfcloc.json")
}

writeBFCLocFile <- function(bfcloc) {
  tximetaDir <- R_user_dir("tximeta", which="config")
  if (!file.exists(tximetaDir)) dir.create(tximetaDir, recursive=TRUE)
  bfclocFile <- bfclocFile()
  write(toJSON(bfcloc, pretty=TRUE), file=bfclocFile)
}

readBFCLocFile <- function(bfclocFile) {
  fromJSON(bfclocFile)
}

# an internal function for getting the BFC location
# the logic here depends on whether a location has been set before,
# and whether tximport is being run interactively or not
getBFCLoc <- function() {
  defaultDir <- R_user_dir("BiocFileCache", which="cache")

  prompt <- paste("",
  "tximeta needs a BiocFileCache directory to access and save TxDb objects.",
  paste0("Do you wish to use the default directory: '",defaultDir,"'?"),
  "If not, a temporary directory that is specific to this R session will be used.","",
  "You can always change this directory later by running: setTximetaBFC()",
  "Or enter [0] to exit and set this directory manually now.",
  "This location can also be set by environmental variable TXIMETA_HUB_CACHE.",
  sep="\n")

  # this is the JSON file where we store the location of the tximeta BiocFileCache
  bfclocFile <- bfclocFile()
  
  # this file tells us which BFC dir has been previously chosen use with tximeta
  if (!file.exists(bfclocFile)) {
    if (interactive()) {

      # exception: temp dir already specified as BFC location in this session
      if (file.exists(file.path(tempdir(),"BiocFileCache.sqlite"))) {
        bfcloc <- tempdir()
        return(bfcloc)
      }
      
      # otherwise ask user:
      ans <- menu(c("Yes (use default)", "No (use temp)"), title=prompt)
      if (ans == 0) stop("no BiocFileCache directory choice made at this time")

      # user wants to use default dir:
      if (ans == 1) {
        bfcloc <- defaultDir
        writeBFCLocFile(bfcloc)
        
        # user wants to use temp dir:
      } else if (ans == 2) {
        bfcloc <- tempdir()
      }
      
      # not interactive, use temp dir:
    } else {
      bfcloc <- tempdir()
    }
    
    # file already exists, read BFC loc:
  } else {
    bfcloc <- readBFCLocFile(bfclocFile)
  }
  
  bfcloc
}

#' Import transcript quantification with metadata
#' 
#' The tximeta package imports abundances (TPM), estimated counts,
#' and effective lengths from quantification tools, 
#' and will output a _SummarizedExperiment_ (SE) object. 
#' For salmon and related quantification tools, [tximeta()] will
#' attempt to identify the correct provenance of the reference transcripts
#' and automatically attach the transcript ranges to the
#' SummarizedExperiment, to facilitate downstream integration with
#' other datasets. The automatic identification of reference transcripts
#' should work out-of-the-box for human or mouse transcriptomes from
#' the sources: GENCODE, Ensembl, or RefSeq. See also [importData()] for
#' importing data when the reference transcripts were derived from 
#' a mix of annotated (e.g. GENCODE) and novel or custom transcripts.
#'
#' The main functions are:
#'   - [tximeta()] - with key argument `coldata` specifying sample information
#'   - [`summarizeToGene()`][summarizeToGene,SummarizedExperiment-method] - summarize quantification to gene-level
#'   - [importData()] - import quantification with mixed reference transcript sets
#' 
#' All software-related questions should be posted to the Bioconductor Support Site:
#' 
#' <https://support.bioconductor.org>
#'
#' The code can be viewed at the GitHub repository,
#' which also lists the contributor code of conduct:
#'
#' <https://github.com/thelovelab/tximeta>
#' 
#' @references
#'
#'   - _tximeta_ reference:
#' 
#' Michael I. Love, Charlotte Soneson, Peter F. Hickey, Lisa K. Johnson
#' N. Tessa Pierce, Lori Shepherd, Martin Morgan, Rob Patro (2020)
#' _Tximeta: reference sequence checksums for provenance identification
#' in RNA-seq_. PLOS Computational Biology.
#' <https://doi.org/10.1371/journal.pcbi.1007664>
#'
#'   - _tximport_ reference (the effective length GLM offset and counts-from-abundance):
#' 
#' Charlotte Soneson, Michael I. Love, Mark D. Robinson (2015)
#' _Differential analyses for RNA-seq: transcript-level estimates
#' improve gene-level inferences_. F1000Research.
#' <http://doi.org/10.12688/f1000research.7563>
#'
#' @author Michael I. Love, Charlotte Soneson, Peter Hickey, Rob Patro
#' 
#' @name tximeta-package
#' @aliases tximeta-package
#' @keywords package
"_PACKAGE"

#' Import transcript quantification with metadata
#' 
#' `tximeta` leverages the digest of the reference transcripts that were indexed
#' in order to identify metadata from the output of quantification tools. 
#' A computed digest (a hash value) can be used to uniquely identify the collection 
#' of reference sequences, and associate the dataset with other useful metadata.
#' After identification, tximeta uses a number of core Bioconductor packages (GenomicFeatures,
#' ensembldb, AnnotationHub, Seqinfo, BiocFileCache) to automatically
#' populate metadata for the user.
#' 
#' Most of the code in tximeta works to add metadata and transcript ranges
#' when the quantification was performed with salmon or related tools. However,
#' tximeta can be used with any quantification type that is supported
#' by [tximport::tximport()], where it will return an non-ranged SummarizedExperiment.
#' For other quantification tools see also the `customMetaInfo` argument below.
#' This behavior can also be triggered with `skipMeta=TRUE`.
#' 
#' tximeta performs a lookup of the digest (or hash value) of the index
#' stored in an auxilary information directory of the quantification tool's output
#' against a database of known transcriptomes, which is stored within the tximeta
#' package (`extdata/hashtable.csv`) and is continually updated to match Ensembl 
#' and GENCODE releases, with updates pushed to Bioconductor current release branch.
#' In addition, tximeta performs a lookup of the digest against a
#' locally stored table of linkedTxome references, see [makeLinkedTxome()].
#' If tximeta detects a match in either source, it will automatically populate
#' the transcript locations, the transcriptome release,
#' the genome with correct chromosome lengths, and connect the SE object to locally
#' cached derived metadata. tximeta also facilitates automatic summarization of 
#' transcript-level quantifications to the gene-level via `summarizeToGene`` without the need to 
#' manually build the correct `tx2gene` table for the reference used for indexing.
#'
#' tximeta on the first run will ask where the [BiocFileCache::BiocFileCache()] 
#' location for this package (_tximeta_) should be kept, either using a default location or a temporary
#' directory. At any point, the user can specify a location using
#' [setTximetaBFC()] and this choice will be saved for future sessions.
#' Multiple users can point to the same BiocFileCache, such that
#' transcript databases (TxDb or EnsDb) associated with certain salmon indices
#' and linkedTxomes can be accessed by different users without additional
#' effort or time spent downloading and building the relevant TxDb / EnsDb.
#' In order to allow that multiple users can read and write to the
#' same location, one should set the BiocFileCache directory to
#' have group write permissions (g+w).
#' Note that, if the TxDb or EnsDb is present in AnnotationHub, tximeta will
#' use this object instead of downloading and building a TxDb/EnsDb from GTF
#' (to disable this set `useHub=FALSE`).
#'
#' Regarding `markDuplicateTxps` and `cleanDuplicateTxps`: these functions
#' may be used when salmon has been run in default mode (where it reduces
#' exact sequence duplicates in the index by replacing them with a single 
#' representative). These won't make sense (and the latter will give an error)
#' when `--keepDuplicates` has been used by salmon during indexing.
#' They help by either adding metadata ("marking") regarding transcript
#' duplicates to the rowData, or changing names of transcripts ("cleaning")
#' where possible to provide better alignment with GTF.
#'
#' @param coldata a data.frame with at least two columns (others will propogate to object):
#'   - `files` - character, paths of quantification files
#'   - `names` - character, sample names
#' if `coldata` is a vector, it is assumed to be the paths of quantification files
#' and unique sample names are created
#' @param type what quantifier was used, see [tximport::tximport()]
#' @param txOut whether to output transcript-level data.
#' `tximeta` is designed to have transcript-level output
#' with salmon, so default is `TRUE`,
#' and it's recommended to use `summarizeToGene`
#' following `tximeta` for gene-level summarization.
#' For an alevin file, `tximeta` will import the
#' gene level counts ignoring this argument (alevin
#' produces only gene-level quantification).
#' @param skipMeta whether to skip metadata generation
#' (e.g. to avoid errors if not connected to internet).
#' This calls `tximport` directly and so either
#' `txOut=TRUE` or `tx2gene` should be specified.
#' @param skipSeqinfo whether to skip the addition of Seqinfo,
#' which requires an internet connection to download the
#' relevant chromosome information table from UCSC
#' @param useHub whether to first attempt to download a TxDb/EnsDb
#' object from AnnotationHub, rather than creating from a
#' GTF file from FTP (default is TRUE). If FALSE, it will
#' force `tximeta` to download and parse the GTF
#' @param markDuplicateTxps whether to mark the status
#' (`hasDuplicate`) and names of duplicate transcripts
#' (`duplicates`) in the rowData of the SummarizedExperiment output.
#' Subsequent summarization to gene level will keep track
#' of the number of transcripts sets per gene (`numDupSets`).
#' see Details
#' @param cleanDuplicateTxps whether to "clean"
#' duplicate transcripts (exact sequence duplicates) by 
#' replacing, when possible, transcript names that do not 
#' appear in the GTF with those that do appear in the GTF. 
#' see Details
#' @param customMetaInfo the relative path to a custom metadata
#' information JSON file, relative to the paths in `files` of
#' `coldata`. For example, `customMetaInfo="meta_info.json"`
#' would indicate that in the same directory as the quantification
#' files in `files`, there are custom metadata information
#' JSON files. These should contain the SHA-256 hash of the
#' reference transcripts with the `index_seq_hash` tag
#' (see details in vignette).
#' @param skipFtp whether to avoid `ftp://` in case of
#' firewall, default is FALSE
#' @param gencode_gtf_prefix for GENCODE transcriptomes, optionally specify
#' a non-default GTF file by providing the prefix that appears between
#' `gencode.vXX.` and `.annotation.gtf.gz` in the GENCODE FTP filename.
#' For example, `"primary_assembly"`, `"basic"`, `"chr_patch_hapl_scaff"`,
#' `"primary_assembly.basic"`, `"chr_patch_hapl_scaff.basic"`.
#' Has no effect for non-GENCODE transcriptomes.
#' @param ... arguments passed to `tximport`
#' 
#' @return a SummarizedExperiment with metadata on the `rowRanges`.
#' (if the hashed digest in the salmon or Sailfish index does not match
#' any known transcriptomes, or any locally saved `linkedTxome`,
#' `tximeta` will just return a non-ranged SummarizedExperiment)
#'
#' @examples
#'
#' # point to a salmon quantification file:
#' dir <- system.file("extdata/salmon_dm", package="tximportData")
#' files <- file.path(dir, "SRR1197474", "quant.sf") 
#' coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)
#'
#' # normally we would just run the following which would download the appropriate metadata
#' # se <- tximeta(coldata)
#'
#' # for this example, we instead point to a local path where the GTF can be found
#' # by making a linkedTxome:
#' indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
#' dmFTP <- "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/"
#' fastaFTP <- paste0(
#'   dmFTP,
#'   c("cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
#'     "ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
#' )
#' gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
#' makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
#'                 release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)
#' se <- tximeta(coldata)
#'
#' # to clear the entire linkedTxome table
#' # (don't run unless you want to clear this table!)
#' # bfcloc <- getTximetaBFC()
#' # bfc <- BiocFileCache(bfcloc)
#' # bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
#'
#' @importFrom SummarizedExperiment SummarizedExperiment assays assayNames colData rowData rowRanges<- rowRanges
#' @importFrom S4Vectors metadata mcols mcols<-
#' @importFrom IRanges CharacterList LogicalList NumericList
#' @importFrom GenomicRanges seqnames strand start end start<- end<-
#' @importFrom tximport tximport summarizeToGene
#' @importFrom jsonlite fromJSON toJSON
#' @importFrom AnnotationDbi loadDb saveDb select keys mapIds dbconn
#' @importFrom DBI dbDisconnect dbIsValid
#' @importFrom GenomicFeatures transcripts genes exonsBy cdsBy
#' @importFrom txdbmaker makeTxDbFromGFF makeTxDbFromGRanges
#' @importFrom ensembldb ensDbFromGtf EnsDb
#' @importFrom BiocFileCache BiocFileCache bfcquery bfcnew bfcadd bfccount bfcrpath
#' @importFrom AnnotationHub AnnotationHub query dbconn dbfile
#' @importFrom Biostrings readDNAStringSet %in%
#' @importFrom tibble tibble
#' @importFrom Seqinfo Seqinfo genome<- seqlengths seqinfo seqinfo<- seqlevels
#' @importFrom tools R_user_dir file_ext
#' @importFrom utils menu packageVersion read.csv read.delim head
#' @importFrom methods is as
#'
#' @export
tximeta <- function(coldata,
                    type=NULL,
                    txOut=TRUE,
                    skipMeta=FALSE,
                    skipSeqinfo=FALSE,
                    useHub=TRUE,
                    markDuplicateTxps=FALSE,
                    cleanDuplicateTxps=FALSE,
                    customMetaInfo=NULL,
                    skipFtp=FALSE,
                    gencode_gtf_prefix=NULL,
                    ...) {

  if (is(coldata, "vector")) {
    coldata <- data.frame(files=coldata, names=seq_along(coldata))
  }
  
  stopifnot(all(c("files","names") %in% names(coldata)))
  
  files <- as.character(coldata$files)
  names(files) <- coldata$names

  if (!all(file.exists(files))) {
    stop("the files do not exist at the location specified by 'coldata$files'")
  }

# default to salmon but print an error if files look non-salmon
  if (is.null(type)) {
    if (grepl(".quant(\\.gz)?$",coldata$files[1])) {
      stop("specify the 'type' of file to import if not salmon")
    } else {    
      type <- "salmon" # default
    }
  }

  # split out all alevin code to R/alevin.R
  # tests are in tests/testthat/test_alevin.R
  if (type == "alevin") {
    # note that `txOut` is ignored, alevin produces gene-level quantification only
    se <- tximetaAlevin(coldata = coldata, type = type, txOut = txOut,
      skipMeta = skipMeta, skipSeqinfo = skipSeqinfo, useHub = useHub, 
      markDuplicateTxps = markDuplicateTxps, cleanDuplicateTxps = cleanDuplicateTxps,
      customMetaInfo = customMetaInfo, skipFtp = skipFtp, ...)
    return(se)
  }

  message(paste("importing",type,"quantification files"))
  
  # remove the files column from colData
  coldata <- subset(coldata, select=-files)

  # metadata list with the tximeta package version, import type, and timestamp
  metadata <- makeMetadata(type)

  # when to skip attempting to load metadata
  # - skipMeta = TRUE OR 
  # - type is not a fish-method AND
  # - custom metadata file info not provided
  skipMetaLogic <- skipMeta |
    ( !type %in% c("salmon","sailfish","piscem","oarfish") &
      is.null(customMetaInfo) )
  
  if (skipMetaLogic) {
    txi <- tximport(files, type=type, txOut=txOut, ...)
    metadata$countsFromAbundance <- txi$countsFromAbundance
    se <- makeUnrangedSE(txi, coldata, metadata)
    return(se)
  } else {
    if (!txOut) stop("tximeta is designed to have transcript-level output for salmon and piscem.
  set txOut=TRUE and use summarizeToGene for gene-level summarization")
  }

  # `metaInfo` = list with quantification tool metadata from JSON files
  # either in specific directories (salmon) or alongside quantification files (newer tools)
  metaInfo <- lapply(
    files,
    getMetaInfo,
    type = type,
    customMetaInfo = customMetaInfo
  )
  
  # different styles of storing hash value by method
  hashType <- type2hashType(type)

  # check the sequence digest (hash) of the transcriptome index with 1st sample
  # readIndexSeqHash() returns a list of functions.
  # note that for oarfish, we are only looking at the `annotated_transcripts_digest`
  # for annotated + novel, use importData...
  indexSeqHash <- readIndexSeqHash()[[hashType]](metaInfo[[1]])
  if (length(files) > 1) {
    hashes <- sapply(metaInfo, readIndexSeqHash()[[hashType]])
    if (!all(hashes == indexSeqHash)) {
      stop("the samples do not share the same index, and cannot be imported")
    }
    if (hashType == "oarfish") { 
      message("\nNote: tximeta() uses the `annotated` index digest to attach metadata,\n",
      "discarding transcripts not associated with the `annotated` index.")
      # custom check: if user is importing oarfish data and using the 'novel' flag... prompt about importData()
      if ("novel_transcripts_digest" %in% names(metaInfo[[1]]$digest)) {
        message("\nNote: `novel` digest detected in quantification files.\n",
        "Use instead importData(), which imports data and metadata from multiple indices.\n")
      }
    }
    checkInfReps(metaInfo)
  }

  # reshape this list object, invert the JSON hierarchy 
  # and examine consistency of the digest 'index_seq_hash'
  metaInfo <- reshapeMetaInfo(metaInfo, hashType)

  # add the per-sample metadata from quantification JSON files to the metadata list object
  metadata$quantInfo <- metaInfo
  
  # try to import files early to expose and tximport() related erreors
  txi <- tximport(files, type=type, txOut=TRUE, ...)
  metadata$countsFromAbundance <- txi$countsFromAbundance

  # use the reference seqeuence digest (hash) to try to find a match 
  # in the hash table of known and linked transcriptomes
  txomeInfo <- getTxomeInfo(digest = indexSeqHash, prefer=c("txome","precomputed"))
  if (is.null(txomeInfo)) {
    message("couldn't find matching transcriptome, returning non-ranged SummarizedExperiment")
    se <- makeUnrangedSE(txi, coldata, metadata)
    return(se)
  }

  # optionally swap in a non-default GENCODE GTF (e.g. primary_assembly.annotation)
  if (!is.null(gencode_gtf_prefix) && txomeInfo$source == "GENCODE") {
    txomeInfo$gtf <- sub(
      "(gencode\\.v[^.]+\\.).*\\.gtf\\.gz$",
      paste0("\\1", gencode_gtf_prefix, ".annotation.gtf.gz"),
      txomeInfo$gtf
    )
    message("using GENCODE GTF: ", basename(txomeInfo$gtf))
  }

  # build or load a TxDb using the GTF filename as the identifier
  txdb <- getTxDb(txomeInfo, useHub=useHub, skipFtp=skipFtp)

  # disconnect on exit
  on.exit({
    con <- AnnotationDbi::dbconn(txdb)
    if (DBI::dbIsValid(con)) DBI::dbDisconnect(con)
  }, add = TRUE)

  # build or load transcript ranges
  txps <- getRanges(txdb=txdb, txomeInfo=txomeInfo, type="txp")

  metadata$level <- "txp" # this marks the level of summarization of the SE: txp / gene

  # package up the assays from the list `txi`
  # put 'counts' in front to facilitate DESeqDataSet construction
  # and remove countsFromAbundance and infReps from assay list
  txi.nms <- c(
    "counts",
    c(setdiff(names(txi), c("counts", "countsFromAbundance", "infReps")))
  )
  assays <- txi[txi.nms]

  # if there are inferential replicates, add using rearrangeInfReps()
  if ("infReps" %in% names(txi)) {
    infReps <- rearrangeInfReps(txi$infReps)
    infReps <- addInfRepDimnames(infReps, assays)
    assays <- c(assays, infReps)
  }
  
  # Ensembl FASTA has txp version numbers,
  # but in the Ensembl GTF it is not in the txname,
  # so here we have to remove the version number to build the SummarizedExperiment
  if (txomeInfo$source %in% c("Ensembl","LocalEnsembl")) {
    txId <- sub("\\..*", "", rownames(assays[["counts"]]))
    for (nm in names(assays)) {
      rownames(assays[[nm]]) <- txId
    }
  }

  # the following function modifies assays and txps to clean duplicate txps 
  # (this occurs when salmon collapses identical transcripts during indexing)
  # cleaning means swapping one transcript name for another, if it is in the GTF
  if (cleanDuplicateTxps) {
    dup.output.list <- duplicateTxpsClean(
      assays, txps, txomeInfo,
      markDuplicateTxps, cleanDuplicateTxps
    )
    assays <- dup.output.list$assays
    txps <- dup.output.list$txps
  }

  # special edits to rownames for GENCODE to remove chars after `|`
  # (and user didn't use --gencode when building salmon index)
  assays <- stripAllCharsAfterBar(assays)
  
  # check concordance
  assays <- checkAssays2Txps(assays, txps)
  
  # put transcripts in order of the assay matrices
  txps <- txps[rownames(assays[["counts"]])]

  # another pass to mark duplicate transcripts
  if (markDuplicateTxps) {
    dup.output.list <- duplicateTxpsMark(
      assays, txps, txomeInfo,
      markDuplicateTxps, cleanDuplicateTxps
    )
    assays <- dup.output.list$assays
    txps <- dup.output.list$txps
  }
  
  # GENCODE and RefSeq needed Seqinfo added to seqinfo(txps)
  # function defined in `metadata_helpers.R`
  txps <- updateTxpsSeqinfo(txps, txomeInfo, skipSeqinfo)
  
  # add the txome information and TxDb information to the metadata list
  txdbInfo <- metadata(txdb)$value
  names(txdbInfo) <- metadata(txdb)$name
  metadata$txomeInfo <- txomeInfo
  metadata$txdbInfo <- txdbInfo

  se <- SummarizedExperiment(assays=assays,
                             rowRanges=txps,
                             colData=coldata,
                             metadata=metadata)
  se  
}

### un-exported functions to help tximeta() ###

# quantifiers have different location of storing index digest (hash)
type2hashType <- function(type) if (!type %in% c("piscem","oarfish")) "salmon" else type

# helper to swap across quantifiers that vary in location of the index sequence digest (hash)
readIndexSeqHash <- function() {
  list(
    salmon = function(m) m$index_seq_hash,
    piscem = function(m) m$signatures$sha256_seqs,
    oarfish = function(m) m$digest$annotated_transcripts_digest$sha256_digests$sha256_seqs
  )
}

# temporary function to map from GRCh38 to hg38 to allow easy
# comparison with UCSC objects from AnnotationHub...
# TODO we need a better solution for obtaining seqinfo for GENCODE
genome2UCSC <- function(x) {
  if (x == "GRCh38") {
    "hg38"
  } else if (x == "GRCm38") {
    "mm10"
  } else if (x == "GRCm39") {
    "mm39"
  } else {
    x
  }
}

gtf2RefSeq <- function(gtf, genome) {
  report <- sub("genomic.gff.gz","assembly_report.txt",basename(gtf))
  dir <- dirname(gtf)
  reportFtp <- paste0(dir, "/", report)
  tab <- read.delim(reportFtp, comment.char="#", header=FALSE, sep="\t", stringsAsFactors=FALSE)
  # TODO - need to figure out what to do about these un-parser friendly files
  tab <- tab[,c(7,9,10)]
  names(tab) <- c("refseqAccn","length","ucscName")
  Seqinfo(seqnames=tab$refseqAccn,
          seqlengths=tab$length,
          isCircular=NA,
          genome=genome)
}

stripAllCharsAfterBar <- function(assays) {
  testTxp <- rownames(assays[[1]])[1]
  if (grepl("ENST|ENSMUST", testTxp) & grepl("\\|", testTxp)) {
    for (i in names(assays)) {
      rownames(assays[[i]]) <- sub("\\|.*","",rownames(assays[[i]]))
    }
  }
  assays
}

# check to see if there are any missing transcripts not available
# for the rows of the tximport assay matrices. if so, give warning and subset
# (or error if all are missing)
checkAssays2Txps <- function(assays, txps) {
  assay.nms <- rownames(assays[["counts"]])
  txps.missing <- !assay.nms %in% names(txps)
  if (!all(assay.nms %in% names(txps))) {

    # it's probably ok that the messaging here uses the term 'txps',
    # because it's unlikely that we'd have genes not present in the GTF
    # which nevertheless had txps in the GTF...
    
    if (all(!assay.nms %in% names(txps))) {
      stop("none of the transcripts in the quantification files are in the GTF")
    } else {

      if (sum(txps.missing) > 3) {
        example.missing <- paste0("Example missing txps: [",
                                  paste(head(assay.nms[txps.missing],3),collapse=", "),
                                  ", ...]")
      } else {
        example.missing <- paste0("Missing txps: [",
                                  paste(assay.nms[txps.missing],collapse=", "), "]")
      }
      
      # TODO what to do here, GTF is missing some txps in FASTA for Ensembl
      warning(paste0("

Warning: the annotation is missing some transcripts that were quantified.
", sum(txps.missing), " out of ", nrow(assays[["counts"]]),
" txps were missing from GTF/GFF but were in the indexed FASTA
(e.g. this can occur with transcripts located on haplotype chromosomes).
In order to build a ranged SummarizedExperiment, these txps were removed.
To keep these txps, and to skip adding ranges, use skipMeta=TRUE

", example.missing, "
"))

      # after warning, then subset
      for (nm in names(assays)) {
        assays[[nm]] <- assays[[nm]][!txps.missing,,drop=FALSE]
      }
      
    }
  }
  assays
}

makeUnrangedSE <- function(txi, coldata, metadata) {
  assays <- txi[c("counts","abundance","length")]
  # if there are inferential replicates
  if ("infReps" %in% names(txi)) {
    infReps <- rearrangeInfReps(txi$infReps)
    assays <- c(assays, infReps)
  } else if ("variance" %in% names(txi)) {
    assays <- c(assays, txi["variance"])
  }
  if ("mean" %in% names(txi)) {
    assays <- c(assays, txi["mean"])
  }
  if ("tier" %in% names(txi)) {
    assays <- c(assays, txi["tier"])
  }
  assays <- assays[!sapply(assays, is.null)]
  SummarizedExperiment(assays=assays,
                       colData=coldata,
                       metadata=metadata)
}

# un-exported inf rep functions:

checkInfReps <- function(metaInfo) {
  if ("num_bootstraps" %in% names(metaInfo[[1]])) {
    nboot <- sapply(metaInfo, function(x) x$num_bootstraps)
    if (!all(nboot == nboot[1])) {
      message("\nNOTE: inferential replicate number not equal across files,
  may lead to errors in object construction, unless 'dropInfReps=TRUE'")
      if (any(nboot == 0)) {
        message(paste("\nNOTE: the following files (by #) have 0 inferential replicates:
  ",paste(which(nboot == 0),collapse=",")),"\n")
      }
    }
  }
}

# arrange list of inferential replicate matrices (per sample)
# into per replicate (infRep1, infRep2, ...)
rearrangeInfReps <- function(infReps) {
  nreps <- ncol(infReps[[1]])
  stopifnot(all(sapply(infReps, ncol) == nreps))
  getCols <- function(j,l) do.call(cbind, lapply(seq_along(l), function(k)  l[[k]][,j]))
  infReps <- lapply(seq_len(nreps), getCols, infReps)
  names(infReps) <- paste0("infRep",seq_len(nreps))
  infReps
}

# add dimnames from "counts" assay to list of infRep matrices
addInfRepDimnames <- function(infReps, assays) {
  lapply(infReps, function(mat) {
      rownames(mat) <- rownames(assays[["counts"]])
      colnames(mat) <- colnames(assays[["counts"]])
      mat
  })
}

# split list of inferential replicate matrices (per replicate)
# into per sample (sample1, sample2, ...)
splitInfReps <- function(infReps) {
  nsamps <- ncol(infReps[[1]])
  sample.names <- colnames(infReps[[1]])
  getCols <- function(j,l) do.call(cbind, lapply(seq_along(l), function(k)  l[[k]][,j]))
  infReps <- lapply(seq_len(nsamps), getCols, infReps)
  names(infReps) <- sample.names
  infReps
}

#' Make and load linked transcriptomes (linked GTF and FASTA)
#'
#' `makeLinkedTxome()` reads the digest associated with a salmon
#' index at `indexDir`, and persistently links it to metadata
#' (alternatively the `digest` string itself and an
#' `indexName` can be provided).
#' Linked metadata includes key information
#' about the transcriptome, including the `source`, `organism`,
#' `release`, and `genome` (these are custom character strings),
#' as well as the locations (e.g. local, HTTP, or FTP) for one or more `fasta`
#' files and one `gtf` file. `loadLinkedTxome()` loads this
#' information from a JSON file. See _Details_.
#'
#' `makeLinkedTxome()` links the information about the transcriptome
#' used for quantification in two ways:
#' 1) the function will store a record in tximeta's cache such that
#' future import of quantification data will automatically access and
#' parse the GTF as if the transcriptome were one of those automatically
#' detected by tximeta. Then all features of tximeta (e.g. summarization
#' to gene, programmatic adding of IDs or metadata) will be available;
#' 2) it will by default write out a JSON file
#' that can be shared, or posted online, and which can be read by
#' `loadLinkedTxome()` which will store the information in tximeta's
#' cache. This should make the full quantification-import pipeline
#' computationally reproducible / auditable even for transcriptomes
#' which differ from those provided by references (GENCODE, Ensembl,
#' RefSeq).
#'
#' For further details please see the "Linked transcriptomes"
#' section of the tximeta vignette.
#'
#' This function can be used in combination with `inspectDigests()`
#' and oarfish data from `importData()`, when multiple
#' reference transcript sets have been indexed. See also
#' `makeLinkedTxpData()`.
#'
#' @param digest the full digest as character string,
#' (this or `indexDir` is required, only one should be specified)
#' @param indexName a name for the `index` when storing the linkedTxome,
#' required if providing the `digest` string, suggest using the
#' basename of the FASTA file and the software used,
#' e.g. "gencode.vXX_salmon-0.XX.Y"
#' @param indexDir the local path to the salmon index
#' (this or `digest` is required, only one should be specified)
#' @param source the source of transcriptome (e.g. "de-novo").
#' Note: if you specify "GENCODE" or "Ensembl", this will trigger
#' behavior by tximeta that may not be desired: e.g. attempts to
#' download canonical transcriptome data from AnnotationHub
#' (unless useHub=FALSE when running tximeta) and parsing of
#' Ensembl GTF using ensembldb (which may fail if the GTF file
#' has been modified). For transcriptomes that are defined by
#' local GTF files, it is recommended to use the terms "LocalGENCODE"
#' or "LocalEnsembl". Setting "LocalEnsembl" will also strip
#' version numbers from the FASTA transcript IDs to enable matching
#' with the Ensembl GTF.
#' @param organism organism (e.g. "Homo sapiens")
#' @param release release number (e.g. "27")
#' @param genome genome (e.g. "GRCh38", or "none")
#' @param fasta location(s) for the FASTA transcript sequences
#' (of which the transcripts used to build the index is equal or a subset).
#' This can be a local path, or an HTTP or FTP URL
#' @param gtf location for the GTF/GFF file
#' (of which the transcripts used to build the index is equal or a subset).
#' This can be a local path, or an HTTP or FTP URL
#' While the `fasta` argument can take a vector of length greater than one
#' (more than one FASTA file containing transcripts used in indexing),
#' the `gtf` argument has to be a single GTF/GFF file.
#' This can also be a serialized GRanges object (location of a .rds file)
#' imported with rtracklayer.
#' If transcripts were added to a standard set of reference transcripts (e.g. fusion genes,
#' or pathogen transcripts), it is recommended that the tximeta user would manually
#' add these to the GTF/GFF file, and post the modified GTF/GFF publicly, such as
#' on Zenodo. This enables consistent annotation and downstream annotation
#' tasks, such as by
#' [`summarizeToGene()`][summarizeToGene,SummarizedExperiment-method].
#' @param write logical, should a JSON file be written out
#' which documents the transcriptome digest and metadata? (default is TRUE)
#' @param jsonFile the path to the json file for the linkedTxome
#'
#' @return nothing, the function is run for its side effects
#'
#' @name linkedTxome
#' @rdname linkedTxome
#'
#' @examples
#'
#' # point to a salmon quantification file with an additional artificial transcript
#' dir <- system.file("extdata/salmon_dm", package="tximportData")
#' file <- file.path(dir, "SRR1197474.plus", "quant.sf")
#' coldata <- data.frame(files=file, names="SRR1197474", sample="1",
#'                       stringsAsFactors=FALSE)
#'
#' # now point to the salmon index itself to create a linkedTxome
#' # as the index will not match a known txome
#' indexDir <- file.path(dir, "Dm.BDGP6.22.98.plus_salmon-0.14.1")
#'
#' # point to the source FASTA and GTF:
#' baseFTP <- "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/"
#' fastaFTP <- c(
#'   paste0(baseFTP,
#'     c("cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
#'       "ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")),
#'   "extra_transcript.fa.gz"
#' )
#' gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz")
#'
#' # now create a linkedTxome, linking the salmon index to its FASTA and GTF sources
#' makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
#'                 release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)
#'
#' # to clear the entire linkedTxome table
#' # (don't run unless you want to clear this table!)
#' # bfcloc <- getTximetaBFC()
#' # bfc <- BiocFileCache(bfcloc)
#' # bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
#'
#' @export
makeLinkedTxome <- function(
  digest = NULL,
  indexName,
  indexDir = NULL,
  source,
  organism,
  release,
  genome,
  fasta,
  gtf,
  write = TRUE,
  jsonFile
) {
  # only one or the other is specified
  stopifnot(xor(is.null(digest), is.null(indexDir)))

  if (!is.null(indexDir)) {
    # `indexDir` was specified
    message(paste0("reading digest from indexDir: .../", basename(indexDir)))
    indexJson <- file.path(indexDir, "info.json")
    # backup spot for information...
    if (!file.exists(indexJson)) {
      indexJson <- file.path(indexDir, "header.json")
    }
    indexList <- fromJSON(indexJson)
    # salmon's SHA-256 hash of the index is called "SeqHash" in the index JSON
    # Pre-salmon 1.0.0 the header.json file has a "value0" sublist,
    # from salmon 1.0.0 the info.json file doesn't
    if ("value0" %in% names(indexList)) {
      digest <- indexList$value0$SeqHash
    } else {
      digest <- indexList$SeqHash
    }
    # here and in the data frame where we record linkedTxome's,
    # 'index' is just the basename of the salmon index
    index <- basename(indexDir)
  } else {
    # `digest` was specified, so use the indexName provided
    stopifnot(!missing(indexName))
    message(paste0(
      "linking file-based metadata to digest: ",
      substr(digest, 1, 6),
      "..."
    ))
    index <- indexName
  }

  checkPrecomputedMatch <- findDigestMatchPrecomputed(digest, quiet=TRUE)
  if (!is.null(checkPrecomputedMatch)) {
    message("NOTE: this digest matches one in the pre-computed digest table")
  }

  std_sources <- c("GENCODE", "Ensembl")
  source <- standardizeCapitalization(source, std_sources)

  if (source %in% std_sources) {
    if (source == "Ensembl") {
      message(
        "NOTE: linkedTxome with source='Ensembl', ensembldb will be used to parse GTF.
this may produce errors if the GTF is not from Ensembl, or has been modified.
set useHub=FALSE in tximeta to avoid download of reference txome from AnnotationHub.
alternatively use a different string for source argument, e.g. LocalEnsembl"
      )
    } else {
      message(
        "NOTE: linkedTxome with source='GENCODE', set useHub=FALSE in tximeta
to avoid download of reference txome from AnnotationHub.
alternatively use a different string for source argument, e.g. LocalGENCODE"
      )
    }
  }
  # a single-row tibble for the linkedTxomeTbl
  lt <- tibble(
    index = index,
    source = source,
    organism = organism,
    release = release,
    genome = genome,
    fasta = list(fasta),
    gtf = gtf,
    sha256 = digest
  )
  stopifnot(nrow(lt) == 1)
  if (write) {
    if (missing(jsonFile)) {
      jsonFile <- paste0(indexDir, ".json")
    }
    message(paste("writing linkedTxome to", jsonFile))
    # TODO be more careful about writing to a file (ask)
    write(toJSON(lt, pretty = TRUE), file = jsonFile)
  }
  stashLinkedThing(lt, type = "Txome")
}

#' @name linkedTxome
#' @rdname linkedTxome
#' 
#' @export
loadLinkedTxome <- function(jsonFile) {
  stashLinkedThing(do.call(tibble, fromJSON(jsonFile)), type="Txome")
}

### linkedTxpData -- a lightweight alternative ###

#' Make linked transcript data (linked GRanges)
#' 
#' `linkedTxpData` allows the user to save relevant _GRanges_ transcript data
#' for identifying and updating transcript metadata in a persistent manner
#' across R sessions. It can be used in combination with `inspectDigests()`
#' and `updateMetadata()`.
#' This is a lightweight version of `linkedTxome` (see
#' `makeLinkedTxome()`), which requires specifying a GTF file for building a
#' _TxDb_ and optionally a FASTA file for sequence retrieval.)
#' 
#' The `txpData` object is saved in the `getTximetaBFC()` location,
#' appended with a 32-character substring of `digest`.
#' The tibble listing all `linkedTxpData` is named
#' `linkedTxpDataTbl` and is listed in the same location.
#' 
#' @param digest character string of the full digest of the 
#' reference transcripts, see `inspectDigests()` with `fullDigest=TRUE`
#' @param digestType character string of the digest, default `"sha256"`
#' @param indexName a name for the `index` when storing the linkedTxpData,
#' @param txpData _GRanges_ providing information about ranges 
#' representing the transcript sequences linked to `digest`
#' @param source the source of transcriptome, e.g. `denovo`. 
#' See `makeLinkedTxome()` for more information on specifying source
#' @param organism organism (e.g. "Homo sapiens")
#' @param release release number (e.g. "27")
#' @param genome genome (e.g. "GRCh38", or "none")
#' 
#' @return nothing, the function is run for its side effects
#' 
#' @name linkedTxpData
#' @rdname linkedTxpData
#' 
#' @examples
#' 
#' novel <- data.frame(seqnames = paste0("chr", rep(1:22, each=500)),
#'   start = 1e6 + 1 + 0:499 * 1000, end = 1e6 + 1 + 0:499 * 1000 + 1000 - 1,
#'   strand = "+", tx_name = paste0("novel", 1:(22*500)), 
#'   gene_id = paste0("novel_gene", rep(1:(22*10), each=50)), 
#' type = "protein_coding")
#' novel_gr <- as(novel, "GRanges")
#' names(novel_gr) <- novel$tx_name
#' 
#' makeLinkedTxpData(
#'  digest = "43158f2c8e88e3acd77c22aee557625a6f1b6a5038cfc7deb5e64903892d8070",
#'  digestType = "sha256",
#'  indexName = "my_novel_txps",
#'  txpData = novel_gr,
#'  source = "novel", organism="Homo sapiens", 
#'  release="v1", genome="GRCh38"
#' )
#' 
#' # to clear the entire linkedTxome table
#' # (don't run unless you want to clear this table!)
#' # bfcloc <- getTximetaBFC()
#' # bfc <- BiocFileCache(bfcloc)
#' # bfcremove(bfc, bfcquery(bfc, "linkedTxpDataTbl")$rid)
#' 
#' @export
makeLinkedTxpData <- function(
  digest, 
  digestType="sha256",
  indexName,
  txpData,
  source,
  organism,
  release,
  genome
) {

  message(paste0("linking user-provided metadata to digest: ",substr(digest,1,6),"..."))

  stopifnot(is(txpData, "GRanges"))

  checkPrecomputedMatch <- findDigestMatchPrecomputed(digest, quiet=TRUE)
  if (!is.null(checkPrecomputedMatch)) {
    message("NOTE: this digest matches one in the pre-computed digest table")
  }

  std_sources <- c("GENCODE","Ensembl")
  source <- standardizeCapitalization(source, std_sources)
  index <- indexName

  digest32 <- substr(digest,1,32)
  # a single-row tibble for the linkedTxpDataTbl
  lt <- tibble(
    index = index,
    source = source,
    organism = organism,
    release = release,
    genome = genome,
    digest = digest,
    digestType = digestType
  )
  
  stopifnot(nrow(lt) == 1)

  # need to save txpData in the BFC, then update the tibble
  # the name to use when saving txpData in the BFC
  # use the first 32 chars of the digest
  txpDataName <- paste0("txpdata-",digest32)
  bfc <- BiocFileCache(getBFCLoc())
  bfc_has <- existsInBFC(txpDataName, bfc)
  if (bfc_has) {
    message("a txpData GRanges object for this digest was already saved in bfc, replacing")
    savepath <- bfcrpath(bfc, rnames=txpDataName)
  } else {
    message("saving txpData object in bfc")
    savepath <- bfcnew(bfc, txpDataName, ext=".rds")  
  }
  saveRDS(txpData, file=savepath)

  # now update the tibble to record that this exists
  stashLinkedThing(lt, type="TxpData")

}

### un-exported helper functions ###

# given a single-row tibble `lt` ("linked thing"), 
# either save this into the linkedTxomeTbl 
# or linkedTxpDataTbl, based on `type`
# (the linkedTxome/linkedTxpData tibbles lives in the tximeta BiocFileCache)
# (`type` will be used directly in message() so we use camelcase here)
stashLinkedThing <- function(lt, type=c("Txome","TxpData")) {
  type <- match.arg(type)
  tbl_name <- paste0("linked",type,"Tbl")
  stopifnot(is(lt, "tbl"))
  bfc <- BiocFileCache(getBFCLoc())
  bfc_has_tbl <- existsInBFC(tbl_name, bfc)
  if (!bfc_has_tbl) {
    message(paste0("saving linked",type," in bfc (first time)"))
    savepath <- bfcnew(bfc, tbl_name, ext=".rds")
    linkedThingTbl <- lt
    saveRDS(linkedThingTbl, file=savepath)
  } else {
    loadpath <- bfcrpath(bfc, rnames=tbl_name)
    stopifnot(length(loadpath) == 1) # only one linkedThingTbl in BFC
    linkedThingTbl <- readRDS(loadpath)
    if (lt$index %in% linkedThingTbl$index) {
      m <- match(lt$index, linkedThingTbl$index)
      stopifnot(length(m) == 1)
      # check if all the terms are the same, and message about that
      if (all(mapply(identical, lt, linkedThingTbl[m,]))) {
        message(paste0("linked",type," metadata was same as already in bfc"))
      } else {
        message(paste0("linked",type," metadata was different than that in bfc, replacing"))
        linkedThingTbl[m,] <- lt
      }
    } else {
      message(paste0("saving linked",type," in bfc"))
      linkedThingTbl <- rbind(linkedThingTbl, lt)
    }
    saveRDS(linkedThingTbl, file=loadpath)
  }
  invisible()
}

standardizeCapitalization <- function(source, std_sources) {
  for (src in std_sources) {
    if (tolower(source) == tolower(src)) {
      source <- src
    }
  }
  source
}

ensureColumns <- function(tbl, col_names) {
  missing_cols <- setdiff(col_names, names(tbl))
  for (m in missing_cols) {
    tbl[[m]] <- NA
  }
  tbl[col_names]
}

existsInBFC <- function(query, bfc) {
  q <- bfcquery(bfc, query)
  bfccount(q) > 0
}

# this initializes the metadata list with basic info
makeMetadata <- function(type) {
  tximetaInfo <- list(version=packageVersion("tximeta"),
                      type=type,
                      importTime=Sys.time())
  list(tximetaInfo=tximetaInfo)
}

# read metadata files from Salmon/piscem/oarfish output
# customMetaInfo = path of the custom metadata info file
getMetaInfo <- function(file, type, customMetaInfo=NULL, mixedDigest=NULL) {
  dir <- dirname(file)

  # users can specify any arbitrary location for the metadata,
  # allowing for any quantification tool to be paired with tximeta.
  # we first deal with this case, then move to Salmon and piscem
  if (!is.null(customMetaInfo)) {
    jsonPath <- file.path(dir, customMetaInfo)

    # salmon or piscem have different metadata locations,
    # so we handle these separately...
  } else {

    # salmon:
    if (type == "salmon") {
      # the default Salmon auxiliary information location
      auxDir <- "aux_info" 
      if (!file.exists(file.path(dir, auxDir))) {
        auxDir <- customAuxDir(dir, auxDir)
      }
      # read in the metadata
      jsonPath <- file.path(dir, auxDir, "meta_info.json")

      # piscem / oarfish:
    } else if (type %in% c("piscem","oarfish")) {

      # read in the metadata
      quantFile <- basename(file)
      metadataFile <- sub(".quant(\\.gz)?$", ".meta_info.json", quantFile)
      jsonPath <- file.path(dir, metadataFile)
      
    } else {
      stop("expected type = 'salmon', 'piscem', 'oarfish'")
    }
  }
  if (!file.exists(jsonPath)) {
    stop("\n\n  the quantification files exist, but the metadata files are missing.
  tximeta (and other downstream software) require the entire output directory
  of Salmon/alevin, or for piscem/oarfish the metadata files to be colocated with the
  quant files. The total output of Salmon/alevin/piscem/oarfish includes files with
  critical metadata for tximeta to work. Alternatively, you can set
  skipMeta=TRUE or use tximport \n\n") 
  }
  result <- fromJSON(jsonPath)

  if (!is.null(mixedDigest)) {
    digestPath <- file.path(dir, mixedDigest)
    if (!file.exists(digestPath)) {
      stop("mixed digest file not found: ", digestPath)
    }
    result$digest <- fromJSON(digestPath)
  }

  result
}

# Salmon allows users to change the name of the auxiliary directory
# just in case this was changed by the user...
customAuxDir <- function(dir, auxDir) {
  jsonPath <- file.path(dir, "cmd_info.json")
  if (!file.exists(jsonPath)) {
    stop("metadata files are missing, tximeta requires the full Salmon/piscem output files")
  }
  cmd_info <- jsonlite::fromJSON(jsonPath)
  if ("auxDir" %in% names(cmd_info)) {
    auxDir <- cmd_info$auxDir
  }
  auxDir
}

# reshape metadata info from salmon or other quantifiers
reshapeMetaInfo <- function(metaInfo, hashType) {
  unionTags <- unique(unlist(lapply(metaInfo, names)))
  # re-order by tag t, then sample i
  out <- lapply(unionTags, function(t) {
    sapply(seq_along(metaInfo), function(i) {
      metaInfo[[i]][[t]]
    })
  })
  names(out) <- unionTags
  if (all(out$eq_class_properties == list())) {
    out$eq_class_properties <- NULL
  }
  # TODO have alternate testing for piscem or oarfish?
  if (hashType == "salmon") {
    stopifnot(all(out$index_seq_hash == out$index_seq_hash[1]))
    stopifnot(all(out$index_name_hash == out$index_name_hash[1]))
    out$index_seq_hash <- out$index_seq_hash[1]
    out$index_name_hash <- out$index_name_hash[1]
  }
  out
}

updateTxpsSeqinfo <- function(txps, txomeInfo, skipSeqinfo) {
  # Ensembl already has nice seqinfo attached, nothing needed

  missingSeqinfo <- any(is.na(seqlengths(txps)))

  # if GENCODE, and not from AHub (which have seqinfo)...
  if (txomeInfo$source == "GENCODE" & !skipSeqinfo & missingSeqinfo) {
    message("fetching genome info for GENCODE")
    ucsc.genome <- genome2UCSC(txomeInfo$genome)
    try(seqinfo(txps) <- Seqinfo(genome=ucsc.genome)[seqlevels(txps)])
  } else if (txomeInfo$source == "RefSeq" & !skipSeqinfo & missingSeqinfo) {
    
    # if RefSeq...
    message("fetching genome info for RefSeq")
    refseq.genome <- gtf2RefSeq(txomeInfo$gtf, txomeInfo$genome)
    stopifnot(all(seqlevels(txps) %in% seqnames(refseq.genome)))
    try(seqinfo(txps) <- refseq.genome[seqlevels(txps)])
  }

  txps
}

missingMetadata <- function(se, summarize=FALSE) {
  msg <- "transcriptome metadata is missing: `metadata(se)$txomeInfo`
  either: 
    
  (1) the object was not produced by tximeta.
      Note that importData() is not supported yet, 
      see updateMetadata() instead, or
  (2) tximeta could not recognize the digest of the transcriptome.
  
  If (2), use a linkedTxome to provide the missing metadata and re-run tximeta()"

  if (summarize) {
    msg <- paste0(msg, "
  or provide a `tx2gene` data.frame and set `skipRanges=TRUE`")
  }

  if (is.null(metadata(se)$txomeInfo)) stop(msg)
  
}

#' Split SummarizedExperiment by gene categories
#' 
#' Construct a new SummarizedExperiment by splitting one of the assays 
#' into a list of assays, each of which contains features of a given 
#' 'type'. It is assumed that there is a one-to-one correspondence 
#' between feature sets of different types; for example, these can be 
#' spliced and unspliced variants of the same transcripts. The type of
#' each feature in the original SummarizedExperiment, and the correspondence
#' between the features of different types, are given in a \code{data.frame}.
#' 
#' @param se A \code{SummarizedExperiment} object.
#' @param splitDf A \code{data.frame} with feature IDs. Each column 
#'   represents a separate feature type, and the features in a given 
#'   row are considered representatives of the same feature (and will 
#'   be represented as one feature in the output object).
#' @param assayName A character scalar, indicating the assay of \code{se}
#'   that will be split. Must be one of \code{assayNames(se)}.
#' 
#' @export
#' 
#' @return A \code{SummarizedExperiment} object with the same columns 
#'   as the input object, and the same number of assays as the number 
#'   of columns in \code{splitDf}. The assays will be named by the 
#'   column names of \code{splitDf}. The \code{colData} and \code{metadata}
#'   of the input \code{SummarizedExperiment} object are copied to the 
#'   output object. The row names are set to the feature IDs in the 
#'   first column of \code{splitDf}. 
#' 
#' @importFrom SummarizedExperiment assayNames assay SummarizedExperiment colData
#' @importFrom Matrix sparseMatrix
#' @importFrom S4Vectors SimpleList metadata
#'   
#' @examples
#' se <- SummarizedExperiment::SummarizedExperiment(
#'   assays = S4Vectors::SimpleList(
#'     counts = as(matrix(1:15, nrow = 5), "sparseMatrix"),
#'     logcounts = log2(matrix(1:15, nrow = 5))
#'   ), 
#'   colData = S4Vectors::DataFrame(sID = paste0("S", 1:3),
#'                                  condition = c("A", "A", "B")),
#'   metadata = list(md1 = "annotation")
#' )
#' rownames(se) <- paste0("G", 1:5)
#' colnames(se) <- paste0("P", 1:3)
#' splitDf <- data.frame(spliced = c("G1", "G2", "G6"), 
#'                       unspliced = c("G3", "G5", "G4"),
#'                       stringsAsFactors = FALSE)
#'                       
#' splse <- splitSE(se = se, splitDf = splitDf, assayName = "counts")
#' 
splitSE <- function(se, splitDf, assayName) {
    if (!(assayName %in% SummarizedExperiment::assayNames(se))) {
        stop("'assayName' must be one of assayNames(se)")
    }
    if (!is(se, "SummarizedExperiment")) {
        stop("'se' must be a SummarizedExperiment object")
    }
    if (!is(splitDf, "data.frame")) {
        stop("'splitDf' must be a data.frame")
    }
    for (cn in colnames(splitDf)) {
        if (is(splitDf[[cn]], "factor")) {
            warning("Converting the '", cn, "' column to character")
            splitDf[[cn]] <- as.character(splitDf[[cn]])
        }
    }
    
    ## Subset splitDf to rows where at least one of the features 
    ## are in the SE.
    l <- vapply(splitDf, function(i) any(i %in% rownames(se)), FALSE)
    l <- names(l[!l])
    if (length(l) > 0) {
        stop("None of the IDs in the ", 
             paste(l, collapse = ", "), " column", ifelse(length(l) > 1, "s", ""), 
             " are present in rownames(se)")
    }
    splitDf <- splitDf[
        rowSums(sapply(splitDf, function(i) i %in% rownames(se))) > 0, 
        , drop = FALSE]
    
    ## Create new assays from the 'assayName' assay, 
    ## named by the columns of 'splitDf'.
    ## All assays will have rownames from the first 
    ## column in 'splitDf'.
    assays <- lapply(splitDf, function(i) {
        if (is(SummarizedExperiment::assay(se, assayName), "sparseMatrix")) {
            tmp <- Matrix::sparseMatrix(
                i = integer(0), j = integer(0), x = numeric(0),
                dims = c(length(i), ncol(se)),
                dimnames = list(i, colnames(se))
            )
        } else {
            tmp <- matrix(0, nrow = length(i), ncol = ncol(se),
                          dimnames = list(i, colnames(se)))
        }
        idx <- intersect(i, rownames(se))
        tmp[idx, ] <- SummarizedExperiment::assay(se, assayName)[idx, ]
        rownames(tmp) <- splitDf[, 1]
        tmp
    })
    
    SummarizedExperiment::SummarizedExperiment(
        assays = S4Vectors::SimpleList(assays), 
        colData = SummarizedExperiment::colData(se),
        metadata = S4Vectors::metadata(se)
    )
}

---
title: "Tximeta: transcript quantification import with automatic metadata"
author: "Michael I. Love, Charlotte Soneson, Peter F. Hickey, Rob Patro"
date: "`r format(Sys.time(), '%m/%d/%Y')`"
output: 
  rmarkdown::html_document:
    highlight: tango
    toc: true
    toc_float: true
abstract: >
  Tximeta performs numerous annotation and metadata gathering tasks on
  behalf of users during the import of transcript quantifications from
  *Salmon* or *alevin* into R/Bioconductor. Metadata and transcript
  ranges are added automatically, facilitating genomic analyses and
  assisting in computational reproducibility.
bibliography: library.bib
vignette: |
  %\VignetteIndexEntry{Transcript quantification import with automatic metadata}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# Introduction

The `tximeta` package [@Love2020] extends the `tximport` package
[@Soneson2015] for import of transcript-level quantification data into
R/Bioconductor. It automatically adds annotation metadata when the
RNA-seq data has been quantified with *Salmon* [@Patro2017] or for
scRNA-seq data quantified with *alevin* [@Srivastava2019]. To our
knowledge, `tximeta` is the only package for RNA-seq data import that
can automatically identify and attach transcriptome metadata based on
the unique sequence of the reference transcripts.
For more details on these packages -- including the motivation for
`tximeta` and description of similar work -- consult the
**References** below.

**Note:** `tximeta` requires that the **entire output directory** of
*Salmon* / *alevin* is present and unmodified in order to identify the
provenance of the reference transcripts. In general, it's a good idea
to not modify or re-arrange the output directory of bioinformatic
software as other downstream software rely on and assume a consistent
directory structure. For sharing multiple samples, one can use, for
example, `tar -czf` to bundle up a set of Salmon output directories,
or to bundle one alevin output directory. For tips on using `tximeta`
with other quantifiers see the 
[other quantifiers](#other_quantifiers) section below.

<center>
<img width=600 src="diagram.png"/>
</center>

# Tximeta import starts with sample table

The first step using `tximeta` is to read in the sample table, which
will become the *column data*, `colData`, of the final object,
a *SummarizedExperiment*. The sample table should contain all the
information we need to identify the *Salmon* quantification
directories. 
For *alevin* quantification, one should point to the `quants_mat.gz`
file that contains the counts for all of the cells (also, in order to
`tximeta` to work with *alevin* quantification, it requires that
*alevin* was run using gene IDs in the `tgMap` step and not gene
symbols).

Here we will use a *Salmon* quantification file in the
*tximportData* package to demonstrate the usage of `tximeta`. We do
not have a sample table, so we construct one in R. It is recommended
to keep a sample table as a CSV or TSV file while working on an
RNA-seq project with multiple samples.

```{r}
dir <- system.file("extdata/salmon_dm", package="tximportData")
files <- file.path(dir, "SRR1197474", "quant.sf") 
file.exists(files)
coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)
coldata
```

`tximeta` expects at least two columns in `coldata`: 

1. `files` - a pointer to the `quant.sf` files
2. `names` - the unique names that should be used to identify samples

# Running tximeta

Normally, we would just run `tximeta` like so:

```{r eval=FALSE}
library(tximeta)
se <- tximeta(coldata)
```

However, to avoid downloading remote GTF files during this vignette,
we will point to a GTF file saved locally (in the *tximportData*
package). We link the transcriptome of the *Salmon* index to its
locally saved GTF. The standard recommended usage of `tximeta` would
be the code chunk above, or to specify a remote GTF source, not a
local one. **This following code is therefore not recommended for a
typically workflow, but is particular to the vignette code.**

```{r}
indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
suppressPackageStartupMessages(library(tximeta))
makeLinkedTxome(indexDir=indexDir,
                source="LocalEnsembl",
                organism="Drosophila melanogaster",
                release="98",
                genome="BDGP6.22",
                fasta=fastaFTP,
                gtf=gtfPath,
                write=FALSE)
```

```{r message=FALSE}
library(tximeta)
```

```{r}
se <- tximeta(coldata)
```

# What happened? 

`tximeta` recognized the hashed checksum of the transcriptome that the files
were quantified against, it accessed the GTF file of the transcriptome
source, found and attached the transcript ranges, and added the
appropriate transcriptome and genome metadata.  A remote GTF is only
downloaded once, and a local or remote GTF is only parsed to build a
*TxDb* or *EnsDb* once: if `tximeta` recognizes that it has seen this *Salmon*
index before, it will use a cached version of the metadata and
transcript ranges.

Note the warning above that 5 of the transcripts are missing from the
GTF file and so are dropped from the final output. This is a problem
coming from the annotation source, and not easily avoided by
`tximeta`. 

# TxDb, EnsDb, and AnnotationHub

`tximeta` makes use of Bioconductor packages for storing
transcript databases as *TxDb* or *EnsDb* objects, which both are 
connected by default to `sqlite` backends.
For GENCODE and RefSeq GTF files, `tximeta` uses the *GenomicFeatures*
package [@granges] to parse the GTF and build a *TxDb*. For Ensembl
GTF files, `tximeta` will first attempt to obtain the correct *EnsDb*
object using *AnnotationHub*. The *ensembldb* package [@ensembldb]
contains classes and methods for extracting relevant data from Ensembl
files. If the *EnsDb* has already been made available on
AnnotationHub, `tximeta` will download the database directly, which
saves the user time parsing the GTF into a database (to avoid this,
set `useHub=FALSE`). If the relevant *EnsDb* is not available on
AnnotationHub, `tximeta` will build an *EnsDb* using *ensembldb* after
downloading the GTF file. Again, the download/construction of a
transcript database occurs only once, and upon subsequent usage of
*tximeta* functions, the cached version will be used.

# Pre-computed checksums

We plan to support a wide variety of sources and organisms for
transcriptomes with pre-computed checksums, though for now the
software focuses on predominantly human and mouse transcriptomes 
(see **Next steps** below for details). 
The following checksums are supported in this version of `tximeta`:

```{r echo=FALSE}
dir2 <- system.file("extdata", package="tximeta")
tab <- read.csv(file.path(dir2, "hashtable.csv"),
                stringsAsFactors=FALSE)
release.range <- function(tab, source, organism) {
  tab.idx <- tab$organism == organism & tab$source == source
  rels <- tab$release[tab.idx]
  if (organism == "Mus musculus" & source == "GENCODE") {
    paste0("M", range(as.numeric(sub("M","",rels))))
  } else if (source == "RefSeq") {
    paste0("p", range(as.numeric(sub(".*p","",rels))))
  } else {
    range(as.numeric(rels))
  }
}
dat <- data.frame(
  source=rep(c("GENCODE","Ensembl","RefSeq"),c(2,3,2)),
  organism=c("Homo sapiens","Mus musculus",
             "Drosophila melanogaster")[c(1:2,1:3,1:2)]
)
rng <- t(sapply(seq_len(nrow(dat)), function(i)
  release.range(tab, dat[i,1], dat[i,2])))
dat$releases <- paste0(rng[,1], "-", rng[,2])
knitr::kable(dat)
```

For Ensembl transcriptomes, we support the combined protein coding
(cDNA) and non-coding (ncRNA) sequences, as well as the protein coding
alone (although the former approach combining coding and non-coding
transcripts is recommended for more accurate quantification).

`tximeta` also has functions to support *linked transcriptomes*,
where one or more sources for transcript sequences have been combined
or filtered. See the **Linked transcriptome** section below for a
demonstration. (The *makeLinkedTxome* function was used above to avoid
downloading the GTF during the vignette building process.)

# SummarizedExperiment output

We have our coldata from before. Note that we've removed `files`.

```{r}
suppressPackageStartupMessages(library(SummarizedExperiment))
colData(se)
```

Here we show the three matrices that were imported. 

```{r}
assayNames(se)
```

If there were inferential replicates (Gibbs samples or
bootstrap samples), these would be imported as additional assays named
`"infRep1"`, `"infRep2"`, ...

`tximeta` has imported the correct ranges for the transcripts:

```{r}
rowRanges(se)
```

We have appropriate genome information, which prevents us from making 
bioinformatic mistakes:

```{r}
seqinfo(se)
```

# Retrieve the transcript database

The `se` object has associated metadata that allows `tximeta` to link
to locally stored cached databases and other Bioconductor objects. In
further sections, we will show examples functions that leverage this
databases for adding exon information, summarize transcript-level data
to the gene level, or add identifiers. However, first we mention that
the user can easily access the cached database with the following
helper function. In this case, `tximeta` has an associated *EnsDb*
object that we can retrieve and use in our R session:

```{r}
edb <- retrieveDb(se)
class(edb)
```

The database returned by `retrieveDb` is either a *TxDb* in the case
of GENCODE or RefSeq GTF annotation file, or an *EnsDb* in the case of
an Ensembl GTF annotation file. For further use of these two database
objects, consult the *GenomicFeatures* vignettes and the *ensembldb*
vignettes, respectively (both Bioconductor packages).

# Add exons per transcript

Because the SummarizedExperiment maintains all the metadata of its
creation, it also keeps a pointer to the necessary database for
pulling out additional information, as demonstrated in the following
sections. 

If necessary, the *tximeta* package can pull down the remote source to
build a TxDb, but given that we've already built a TxDb once, it
simply loads the cached version. In order to remove the cached TxDb
and regenerate, one can remove the relevant entry from the `tximeta`
file cache that resides at the location given by `getTximetaBFC()`.

The `se` object created by `tximeta`, has the start, end, and strand
information for each transcript. Here, we swap out the transcript
*GRanges* for exons-by-transcript *GRangesList* (it is a list of
*GRanges*, where each element of the list gives the exons for a
particular transcript).

```{r}
se.exons <- addExons(se)
rowRanges(se.exons)[[1]]
```

As with the transcript ranges, the exon ranges will be generated once
and cached locally. As it takes a non-negligible amount of time to
generate the exon-by-transcript *GRangesList*, this local caching
offers substantial time savings for repeated usage of `addExons` with
the same transcriptome.

We have implemented `addExons` to work only on the transcript-level
*SummarizedExperiment* object. We provide some motivation for this
choice in `?addExons`. Briefly, if it is desired to know the exons
associated with a particular gene, we feel that it makes more sense to
pull out the relevant set of exons-by-transcript for the transcripts
for this gene, rather than losing the hierarchical structure (exons to
transcripts to genes) that would occur with a *GRangesList* of exons
grouped per gene.

# Easy summarization to gene-level

Likewise, the *tximeta* package can make use of the cached TxDb
database for the purpose of summarizing transcript-level
quantifications and bias corrections to the gene-level. After
summarization, the `rowRanges` reflect the start and end position of
the gene, which in Bioconductor are defined by the left-most and
right-most genomic coordinates of all the transcripts. As with the
transcript and exons, the gene ranges are cached locally for repeated
usage. The transcript IDs are stored as a *CharacterList* column
`tx_ids`.

```{r}
gse <- summarizeToGene(se)
rowRanges(gse)
```

# Add different identifiers

We would like to add support to easily map transcript or gene
identifiers from one annotation to another. This is just a prototype
function, but we show how we can easily add alternate IDs given that we
know the organism and the source of the transcriptome. (This function
currently only works for GENCODE and Ensembl gene or transcript IDs
but could be extended to work for arbitrary sources.)

```{r}
library(org.Dm.eg.db)
gse <- addIds(gse, "REFSEQ", gene=TRUE)
mcols(gse)
```

# Differential expression analysis

The following code chunk demonstrates how to build a *DESeqDataSet*
and begin a differential expression analysis. 

```{r}
suppressPackageStartupMessages(library(DESeq2))
# here there is a single sample so we use ~1.
# expect a warning that there is only a single sample...
suppressWarnings({dds <- DESeqDataSet(gse, ~1)})
# ... see DESeq2 vignette
```

The *Swish* method in the *fishpond* package directly works with the
*SummarizedExperiment* output from *tximeta*, and can perform
differential analysis on transcript expression taking into account
inferential replicates, e.g. bootstrap or Gibbs samples, which are
imported and arranged by `tximeta` if these were generated during
quantification.

```{r}
library(fishpond)
y <- se
# y <- scaleInfReps(y)
# y <- labelKeep(y)
# y <- swish(y, x="condition")
# ... see Swish vignette in fishpond package
```

We have a convenient wrapper function that will build a *DGEList*
object for use with *edgeR*.

```{r}
suppressPackageStartupMessages(library(edgeR))
y <- makeDGEList(gse)
# ... see edgeR User's Guide for further steps
```

The following code chunk demonstrates the code inside of the above
wrapper function, and produces the same output.

```{r}
cts <- assays(gse)[["counts"]]
normMat <- assays(gse)[["length"]]
normMat <- normMat / exp(rowMeans(log(normMat)))
o <- log(calcNormFactors(cts/normMat)) + log(colSums(cts/normMat))
y <- DGEList(cts)
y <- scaleOffset(y, t(t(log(normMat)) + o))
# ... see edgeR User's Guide for further steps
```

The following code chunk demonstrates how one could use the *Swish*
method in the fishpond Bioconductor package. Here we use the
transcript-level object `se`. This dataset only has a single sample
and no inferential replicates, but the analysis would begin with such
code. See the Swish vignette in the fishpond package for a complete
example: 

```{r eval=FALSE}
y <- se # rename the object to 'y'
library(fishpond)
# if inferential replicates existed in the data,
# analysis would begin with:
#
# y <- scaleInfReps(y)
# ... see Swish vignette in the fishpond package
```

For *limma* with *voom* transformation we recommend, as in the
*tximport* vignette to generate counts-from-abundance instead of
providing an offset for average transcript length.

```{r}
gse <- summarizeToGene(se, countsFromAbundance="lengthScaledTPM")
library(limma)
y <- DGEList(assays(gse)[["counts"]])
# see limma User's Guide for further steps
```

Above we generated counts-from-abundance when calling
`summarizeToGene`. The counts-from-abundance status is then stored in
the metadata:

```{r}
metadata(gse)$countsFromAbundance 
```

# Additional metadata

The following information is attached to the *SummarizedExperiment* by
`tximeta`: 

```{r}
names(metadata(se))
str(metadata(se)[["quantInfo"]])
str(metadata(se)[["txomeInfo"]])
str(metadata(se)[["tximetaInfo"]])
str(metadata(se)[["txdbInfo"]])
```

# Errors connecting to a database

`tximeta` makes use of *BiocFileCache* to store transcript and other
databases, so saving the relevant databases in a centralized location
used by other Bioconductor packages as well. It is possible that an
error can occur in connecting to these databases, either if the files
were accidentally removed from the file system, or if there was an
error generating or writing the database to the cache location. In
each of these cases, it is easy to remove the entry in the
*BiocFileCache* so that `tximeta` will know to regenerate the
transcript database or any other missing database.

If you have used the default cache location, then you can obtain
access to your BiocFileCache with:

```{r}
library(BiocFileCache)
bfc <- BiocFileCache()
```

Otherwise, you can recall your particular `tximeta` cache location
with `getTximetaBFC()`.

You can then inspect the entries in your BiocFileCache using `bfcinfo`
and remove the entry associated with the missing database with `bfcremove`. 
See the BiocFileCache vignette for more details on finding and
removing entries from a BiocFileCache.

Note that there may be many entries in the BiocFileCache location,
including `.sqlite` database files and serialized `.rds` files. You
should only remove the entry associated with the missing database,
e.g. if R gave an error when trying to connect to the TxDb associated
with GENCODE v99 human transcripts, you should look for the `rid` of
the entry associated with the human v99 GTF from GENCODE.

# What if checksum isn't known?

`tximeta` automatically imports relevant metadata when the
transcriptome matches a known source -- *known* in the sense that it
is in the set of pre-computed hashed checksums in `tximeta` (GENCODE,
Ensembl, and RefSeq for human and mouse). `tximeta` also facilitates the
linking of transcriptomes used in building the *Salmon* index with
relevant public sources, in the case that these are not part of this
pre-computed set known to `tximeta`.
The linking of the transcriptome source with the quantification files is
important in the case that the transcript sequence no longer matches a
known source (uniquely combined or filtered FASTA files), or if the
source is not known to `tximeta`. Combinations of coding and
non-coding human, mouse, and fruit fly *Ensembl* transcripts should be
automatically recognized by `tximeta` and does not require making a
*linkedTxome*. As the package is further developed, we plan to roll
out support for all common transcriptomes, from all sources.

**Note:** if you are using Salmon in alignment mode, then there is no
Salmon index, and without the Salmon index, there is no checksum. We
don't have a perfect solution for this yet, but you can still
summarize transcript counts to gene with a `tx2gene` table that you
construct manually (see `tximport` vignette for example code). 
Just specify the arguments,
`skipMeta=TRUE, txOut=FALSE, tx2gene=tx2gene`, 
when calling `tximeta` and it will perform summarization to gene level
as in `tximport`.

We now demonstrate how to make a *linkedTxome* and how to share and
load a *linkedTxome*.
We point to a *Salmon* quantification file which was quantified
against a transcriptome that included the coding and non-coding
*Drosophila melanogaster* transcripts, as well as an artificial
transcript of 960 bp (for demonstration purposes only).

```{r}
file <- file.path(dir, "SRR1197474.plus", "quant.sf")
file.exists(file)
coldata <- data.frame(files=file, names="SRR1197474", sample="1",
                      stringsAsFactors=FALSE)
```

Trying to import the files gives a message that `tximeta` couldn't find
a matching transcriptome, so it returns an non-ranged
*SummarizedExperiment*. 

```{r}
se <- tximeta(coldata)
```

# Linked transcriptomes

If the transcriptome used to generate the *Salmon* index does not
match any transcriptomes from known sources (e.g. from combining or
filtering known transcriptome files), there is not much that can be
done to automatically populate the metadata during quantification
import. However, we can facilitate the following two cases:

1) the transcriptome was created locally and has been linked to its
public source(s) 
2) the transcriptome was produced by another group, and
they have produced and shared a file that links the transcriptome to
public source(s)

`tximeta` offers functionality to assist reproducible analysis in both
of these cases.

To make this quantification reproducible, we make a `linkedTxome`
which records key information about the sources of the transcript
FASTA files, and the location of the relevant GTF file. It also
records the checksum of the transcriptome that was computed by
*Salmon* during the `index` step.

**Source:** when creating the `linkedTxome` one must specify the 
`source` of the transcriptome. See `?linkedTxome` for a note on 
the implications of this text string. For canonical GENCODE or
Ensembl transcriptomes, one can use `"GENCODE"` or `"Ensembl"`,
but for modified or otherwise any transcriptomes defined by a local
database, it is recommended to use a different string,
`"LocalGENCODE"` or `"LocalEnsembl", which will avoid *tximeta*
pulling canonical GENCODE or Ensembl resources from AnnotationHub.

**Multiple GTF/GFF files:** `linkedTxome` and `tximeta` do not
currently support multiple GTF/GFF files, which is a more complicated
case than multiple FASTA, which is supported. Currently, we recommend
that users should add or combine GTF/GFF files themselves to create
a single GTF/GFF file that contains all features used in
quantification, and then upload such a file to *Zenodo*, which can
then be linked as shown below. Feel free to contact the developers on
the Bioconductor support site or GitHub Issue page for further details
or feature requests.

By default, `linkedTxome` will write out a JSON file which can be
shared with others, linking the checksum of the index with the other
metadata, including FASTA and GTF sources. By default, it will write
out to a file with the same name as the `indexDir`, but with a `.json`
extension added. This can be prevented with `write=FALSE`, and the
file location can be changed with `jsonFile`.

First we specify the path where the *Salmon* index is located. 

Typically you would not use `system.file` and `file.path` to locate
this directory, but simply define `indexDir` to be the path of the
*Salmon* directory on your machine. Here we use `system.file` and
`file.path` because we have included parts of a *Salmon* index
directory in the *tximeta* package itself for demonstration of
functionality in this vignette.

```{r}
indexDir <- file.path(dir, "Dm.BDGP6.22.98.plus_salmon-0.14.1")
```

Now we provide the location of the FASTA files and the GTF file for
this transcriptome. 

**Note:** the basename for the GTF file is used as a unique identifier
for the cached versions of the *TxDb* and the transcript ranges, which
are stored on the user's behalf via *BiocFileCache*. This is not an
issue, as GENCODE, Ensembl, and RefSeq all provide GTF files which are
uniquely identified by their filename,
e.g. `Drosophila_melanogaster.BDGP6.22.98.gtf.gz`.

The recommended usage of `tximeta` would be to specify a remote GTF
source, as seen in the commented-out line below: 

```{r}
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz",
              "extra_transcript.fa.gz")
#gtfFTP <- "ftp://path/to/custom/Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz"
```

Instead of the above commented-out FTP location for the GTF file, we
specify a location within an R package. This step is just to avoid
downloading from a remote FTP during vignette building. This use of
`file.path` to point to a file in an R package is specific to this
vignette and should not be used in a typical workflow. The following
GTF file is a modified version of the release 98 from Ensembl, which
includes description of a one transcript, one exon artificial gene
which was inserted into the transcriptome (for demonstration purposes
only). 

```{r}
gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz")
```

Finally, we create a *linkedTxome*.  In this vignette, we point to a
temporary directory for the JSON file, but a more typical workflow
would write the JSON file to the same location as the *Salmon* index
by not specifying `jsonFile`.

`makeLinkedTxome` performs two operation: (1) it creates a new entry in
an internal table that links the transcriptome used in the *Salmon*
index to its sources, and (2) it creates a JSON file such that this
*linkedTxome* can be shared.

```{r}
tmp <- tempdir()
jsonFile <- file.path(tmp, paste0(basename(indexDir), ".json"))
makeLinkedTxome(indexDir=indexDir,
                source="LocalEnsembl", organism="Drosophila melanogaster",
                release="98", genome="BDGP6.22",
                fasta=fastaFTP, gtf=gtfPath,
                jsonFile=jsonFile)
```

After running `makeLinkedTxome`, the connection between this *Salmon*
index (and its checksum) with the sources is saved for persistent
usage. Note that because we added a single transcript of 960bp to the
FASTA file used for quantification, `tximeta` could tell that this was
not quantified against release 98 of the Ensembl transcripts for
*Drosophila melanogaster*. Only when the correct set of transcripts
were specified does `tximeta` recognize and import the correct
metadata.

With use of `tximeta` and a *linkedTxome*, the software
figures out if the remote GTF has been accessed and compiled into a
*TxDb* before, and on future calls, it will simply load the
pre-computed metadata and transcript ranges.

Note the warning that 5 of the transcripts are missing from the GTF
file and so are dropped from the final output. This is a problem
coming from the annotation source, and not easily avoided by
`tximeta`. 

```{r}
se <- tximeta(coldata)
```

We can see that the appropriate metadata and transcript ranges are
attached.

```{r}
rowRanges(se)
seqinfo(se)
```

# Clear *linkedTxomes*

The following code removes the entire table with information about the
*linkedTxomes*. This is just for demonstration, so that we can show
how to load a JSON file below.

**Note:** Running this code will clear any information about
*linkedTxomes*. Don't run this unless you really want to clear this
table!

```{r}
library(BiocFileCache)
if (interactive()) {
  bfcloc <- getTximetaBFC()
} else {
  bfcloc <- tempdir()
}
bfc <- BiocFileCache(bfcloc)
bfcinfo(bfc)
bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
bfcinfo(bfc)
```

# Loading *linkedTxome* JSON files

If a collaborator or the Suppmentary Files for a publication shares a
`linkedTxome` JSON file, we can likewise use `tximeta` to
automatically assemble the relevant metadata and transcript
ranges. This implies that the other person has used `tximeta` with the
function `makeLinkedTxome` demonstrated above, pointing to their
*Salmon* index and to the FASTA and GTF source(s).

We point to the JSON file and use `loadLinkedTxome` and then the
relevant metadata is saved for persistent usage. In this case, we
saved the JSON file in a temporary directory.

```{r}
jsonFile <- file.path(tmp, paste0(basename(indexDir), ".json"))
loadLinkedTxome(jsonFile)
```

Again, using `tximeta` figures out whether it needs to access the
remote GTF or not, and assembles the appropriate object on the user's
behalf.

```{r}
se <- tximeta(coldata)
```

# Clear *linkedTxomes* again

Finally, we clear the *linkedTxomes* table again so that the above
examples will work. This is just for the vignette code and not part of
a typical workflow.

**Note:** Running this code will clear any information about
*linkedTxomes*. Don't run this unless you really want to clear this
table!

```{r}
if (interactive()) {
  bfcloc <- getTximetaBFC()
} else {
  bfcloc <- tempdir()
}
bfc <- BiocFileCache(bfcloc)
bfcinfo(bfc)
bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
bfcinfo(bfc)
```

# Other quantifiers

`tximeta` can import the output from any quantifiers that are
supported by `tximport`, and if these are not *Salmon*, *alevin*, or
*Sailfish* output, it will simply return a non-ranged
*SummarizedExperiment* by default.

An alternative solution is to wrap other quantifiers in workflows
that include metadata information JSON files along with each
quantification file. One can place these files in
`aux_info/meta_info.json` or any relative location specified by
`customMetaInfo`, for example `customMetaInfo="meta_info.json"`. This
JSON file is located relative to the quantification file and should
contain a tag `index_seq_hash` with an associated value of the SHA-256
hash of the reference transcripts. For computing the hash value of the
reference transcripts, see the
[FastaDigest](https://github.com/COMBINE-lab/FastaDigest) python
package. The hash value used by *Salmon* is the SHA-256 hash value
of the reference sequences stripped of the header lines, and
concatenated together with the empty string (so only cDNA sequences
combined without any new line characters). *FastaDigest* can be
installed with `pip install fasta_digest`.

# Automated analysis with ARMOR

This vignette described the use of `tximeta` to import quantification
data into R/Bioconductor with automatic detection and addition of
metadata. The *SummarizedExperiment* produced by `tximeta` can then be
provided to downstream statistical analysis packages as described
above. The *tximeta* package does not contain any functionality for
automated differential analysis. 

The [ARMOR](https://github.com/csoneson/ARMOR) workflow does automate 
a variety of differential analyses, and make use of `tximeta` for
creation of a *SummarizedExperiment* with attached annotation
metadata. ARMOR stands for 
``An Automated Reproducible MOdular Workflow for Preprocessing
and Differential Analysis of RNA-seq Data'' and is described in more
detail in the article by @Orjuelag2019.

# Default BiocFileCahce Caching Location Update

*tximeta* makes use of the default BiocFileCache location, unless
otherwise specified by the user. As of BiocFileCache version > 1.15.1,
the default caching location used by BiocFileCache has changed. In
order to continue to use the same cache (without re-downloading
files), please follow the steps in the BiocFileCache vignette, under
the heading **Default Caching Location Update**.

# Acknowledgments

The development of *tximeta* has benefited from suggestions from these
and other individuals in the community:

* Vincent Carey
* Lori Shepherd
* Martin Morgan
* Koen Van den Berge
* Johannes Rainer
* James Ashmore
* Ben Johnson
* Tim Triche
* Kristoffer Vitting-Seerup

# Next steps

**Integration with GA4GH / refget API**

* We are collaborating and in communication with GA4GH working groups
  to build out functionality to perform lookup on collections of
  transcripts, i.e. transcriptomes, provided by Ensembl. This will
  greatly expand the applicability of `tximeta`. The current version
  of `tximeta` relies on hashing of common transcriptomes, which are
  stored within the package's `extdata` directory in a CSV file, or
  on the use of *linkedTxome* for any additional transcriptomes. 
  However, with the GA4GH / `refget` API in place, `tximeta` will
  be able to identify and access transcriptome metadata for vastly
  more reference transcriptomes (collections of transcripts).

**Facilitate plots and summaries**
    
* Basic plots across samples: abundances, mapping rates, rich bias model parameters
* Time summaries: when quantified? when imported?

**Extended functionality**

* Facilitate functional annotation, either with vignettes/workflow or
  with additional functionality. E.g.: 
  housekeeping genes, arbitrary gene sets, genes expressed in GTEx tissues
* `liftOver` is clunky and doesn't integrate with
  *GenomeInfoDb*. It requires user input and there's a chance to
  mis-annotate. Ideally this should all be automated.

# Session info

```{r}
library(devtools)
session_info()
```

# References

---
title: "tximeta: transcript quantification import with automatic metadata"
author: "Michael I. Love, Charlotte Soneson, Peter F. Hickey, Rob Patro"
date: "`r format(Sys.time(), '%m/%d/%Y')`"
output: 
  rmarkdown::html_vignette:
    highlight: pygments
abstract: >
  _tximeta_ performs numerous annotation and metadata gathering tasks on
  behalf of users during the import of transcript counts and abundance
  from quantification tools such as salmon. Data are imported as
  SummarizedExperiment objects with associated GenomicRanges metadata.
  Correct metadata is added automatically via reference sequence digests, 
  facilitating genomic analyses and assisting in computational reproducibility.
  Addition functionality is now offered for quantification with mixed reference
  transcripts, e.g. GENCODE plus novel transcripts.
bibliography: library.bib
vignette: |
  %\VignetteIndexEntry{tximeta: transcript quantification import with automatic metadata}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
editor:
  markdown:
    wrap: 80
---

If viewing vignette on Bioconductor, see 
[here](https://thelovelab.github.io/tximeta/articles/tximeta.html)
for a nicely rendered version.

# Introduction

The *tximeta* package [@Love2020] extends the *tximport* package [@Soneson2015]
for import of transcript-level quantification data into R/Bioconductor. It
automatically adds annotation metadata when the RNA-seq data has been quantified
with *salmon* [@Patro2017] or related tools. To our knowledge, *tximeta* is the
only package for RNA-seq data import that can automatically identify and attach
transcriptome metadata based on the unique sequence collection of the reference
transcripts. For more details on these packages -- including the motivation for
*tximeta* and description of similar work -- consult the **References** below.

**Note:** For details of using _tximeta_ functions with 
[oarfish](https://github.com/COMBINE-lab/oarfish), 
in particular with separate `--annotated` and `--novel` reference transcripts, refer to 
[this section](#mixed-reference-transcripts) below.

**Note:** `tximeta()` requires that the **entire output** of the quantificaation
tool is present in the output directories and unmodified in order to identify
the provenance of the reference transcripts. In general, it's a good idea to not
modify or re-arrange the output directory of bioinformatic software as other
downstream software often rely on and assume a consistent directory structure.
For sharing multiple samples, one can use, for example, `tar -czf` to bundle up
a set of *salmon* output directories. For tips on using `tximeta()` with other
quantifiers see the [other quantifiers](#other-quantifiers) section below.

```{r echo=FALSE, fig.alt="How tximeta works"}
knitr::include_graphics("images/diagram.png")
```

# Preparing `tximeta` input

The first step using `tximeta()` is to read in the sample table, which will
become the *column data*, `colData`, of the final object, a
*SummarizedExperiment*. The sample table should contain all the information we
need to identify the *salmon* quantification directories.

Here we will use a *salmon* quantification file in the *tximportData* package to
demonstrate the usage of `tximeta`. We do not have a sample table, so we
construct one in R. It is recommended to keep a sample table as a CSV or TSV
file while working on an RNA-seq project with multiple samples.

```{r}
dir <- system.file("extdata/salmon_dm", package="tximportData")
files <- file.path(dir, "SRR1197474", "quant.sf") 
file.exists(files)
coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)
coldata
```

`tximeta()` expects at least two columns in `coldata`:

1.  `files` - a pointer to the `quant.sf` files
2.  `names` - the unique names that should be used to identify samples

Other columns will be propagated to `colData` of the *SummarizedExperiment*
output.

# Running `tximeta`

Normally, we would just run `tximeta` like so:

```{r eval=FALSE}
library(tximeta)
se <- tximeta(coldata)
```

However, to avoid downloading remote GTF files during this vignette, we will
point to a GTF file saved locally (in the *tximportData* package). We link the
transcriptome of the *salmon* index to its locally saved GTF. The standard
recommended usage of `tximeta()`,\
in particular for quantification with reference transcripts with a [pre-computed
digest](#pre-computed-digests), would be the code chunk above. If one were
adding another set of reference transcripts, one would normally specify a remote
GTF source, not a local one. **This following code is therefore not recommended
for a typical workflow, but is particular to the vignette code.**

```{r echo=FALSE}
suppressPackageStartupMessages({
  library(GenomicFeatures)
  })
```

```{r}
indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
suppressPackageStartupMessages(library(tximeta))
makeLinkedTxome(indexDir=indexDir,
                source="LocalEnsembl",
                organism="Drosophila melanogaster",
                release="98",
                genome="BDGP6.22",
                fasta=fastaFTP,
                gtf=gtfPath,
                write=FALSE)
```

```{r message=FALSE}
library(tximeta)
```

```{r}
se <- tximeta(coldata)
```

This warning, "*Warning: the annotation is missing some transcripts that were
quantified.*", is common and occurs when annotation sources provide transcripts
in the FASTA file that aren't annotated in the GTF file. This is upstream of
`tximeta()`, but this package will notify you the number of transcripts for
which this is the case.

# How does it work?

`tximeta()` recognized the computed *digest* of the transcriptome that the files
were quantified against, it accessed the GTF file of the transcriptome source,
found and attached the transcript ranges, and added the appropriate
transcriptome and genome metadata. A *digest* is a small string of alphanumeric
characters that uniquely identifies the collection of sequences that were used
for quantification (it is the hash value from applying the hash function to a
particular collection of nucleotide sequences). We sometimes also call this
value a "checksum" (in the tximeta paper), and we sometimes call the table of
pre-computed digests or linked digests a "hash table".

Note that a remote GTF is only downloaded once, and a local or remote GTF is
only parsed to build a *TxDb* or *EnsDb* once: if `tximeta()` recognizes that it
has seen this *salmon* index before, it will use a cached version of the
metadata and transcript ranges.

# Packages used for caching metadata

`tximeta()` makes use of Bioconductor packages for storing transcript databases
as *TxDb* or *EnsDb* objects, which both are connected by default to `sqlite`
backends. For GENCODE and RefSeq GTF files, `tximeta()` uses the *txdbmaker*
package to parse the GTF and build a *TxDb*. For Ensembl GTF files, `tximeta()`
will first attempt to obtain the correct *EnsDb* object using *AnnotationHub*.
The *ensembldb* package [@ensembldb] contains classes and methods for extracting
relevant data from Ensembl files. If the *EnsDb* has already been made available
on AnnotationHub, `tximeta()` will download the database directly, which saves
the user time parsing the GTF into a database (to avoid this, set
`useHub=FALSE`). If the relevant *EnsDb* is not available on AnnotationHub,
`tximeta()` will build an *EnsDb* using *ensembldb* after downloading the GTF
file. Again, the download/construction of a transcript database occurs only
once, and upon subsequent usage of *tximeta* functions, the cached version will
be used.

# Pre-computed digests

The following digests for human, mouse, and drosophila reference transcripts are
supported in this version of `tximeta()`:

```{r echo=FALSE}
dir2 <- system.file("extdata", package="tximeta")
tab <- read.csv(file.path(dir2, "hashtable.csv"),
                stringsAsFactors=FALSE)
release.range <- function(tab, source, organism) {
  tab.idx <- tab$organism == organism & tab$source == source
  rels <- tab$release[tab.idx]
  if (organism == "Mus musculus" & source == "GENCODE") {
    paste0("M", range(as.numeric(sub("M","",rels))))
  } else if (source == "RefSeq") {
    paste0("p", range(as.numeric(sub(".*p","",rels))))
  } else {
    range(as.numeric(rels))
  }
}
dat <- data.frame(
  source=rep(c("GENCODE","Ensembl","RefSeq"),c(2,3,2)),
  organism=c("Homo sapiens","Mus musculus",
             "Drosophila melanogaster")[c(1:2,1:3,1:2)]
)
rng <- t(sapply(seq_len(nrow(dat)), function(i)
  release.range(tab, dat[i,1], dat[i,2])))
dat$releases <- paste0(rng[,1], "-", rng[,2])
knitr::kable(dat)
```

For Ensembl transcriptomes, we support the combined protein coding (cDNA) and
non-coding (ncRNA) sequences, as well as the protein coding alone (although the
former approach combining coding and non-coding transcripts is recommended for
more accurate quantification).

`tximeta()` also supports *linked transcriptomes*, a mechanism to link
quantification data to key metadata. This can be used to resolve many potential
situations where one of the above pre-computed digests won't be a match (due to
modifying, re-ordering, adding, or removing transcripts, which changes the value
of the compute digest). See the [Linked transcriptomes](#linked-transcriptomes)
section below for a demonstration. (The *makeLinkedTxome* function was used
above to avoid downloading the GTF during the vignette building process.)

For *oarfish* quantification [@oarfish] using the `--annotated` and `--novel`
reference transcripts, use the functions described
[below](#mixed-reference-transcripts).

# SummarizedExperiment output

The `SummarizedExperiment` object resulting from the data import contains 
our coldata from before. Note that the `files` column was removed during the 
import.

```{r}
suppressPackageStartupMessages(library(SummarizedExperiment))
colData(se)
```

Here we show the three matrices that were imported.

```{r}
assayNames(se)
```

If there were inferential replicates (Gibbs samples or bootstrap samples), these
would be imported as additional assays named `"infRep1"`, `"infRep2"`, ...

`tximeta()` has imported the correct ranges for the transcripts:

```{r}
rowRanges(se)
```

We have appropriate genome information, which prevents us from making
bioinformatic mistakes:

```{r}
seqinfo(se)
```

# Retrieve the transcript database

The `se` object has associated metadata that allows `tximeta` to link to locally
stored cached databases and other Bioconductor objects. In further sections, we
will show examples of functions that leverage these databases to add exon
information, summarize transcript-level data to the gene level, or add
identifiers. However, first we mention that the user can easily access the
cached database with the following helper function. In this case, `tximeta` has
an associated *EnsDb* object that we can retrieve and use in our R session:

```{r}
edb <- retrieveDb(se)
class(edb)
```

The database returned by `retrieveDb` is either a *TxDb* in the case of GENCODE
or RefSeq GTF annotation file, or an *EnsDb* in the case of an Ensembl GTF
annotation file. For further use of these two database objects, consult the
*GenomicFeatures* vignettes and the *ensembldb* vignettes, respectively (both
Bioconductor packages).

# Add exons per transcript

Because the SummarizedExperiment maintains all the metadata of its creation, it
also keeps a pointer to the necessary database for pulling out additional
information, as demonstrated in the following sections.

If necessary, the *tximeta* package can pull down the remote source to build a
TxDb, but given that we've already built a TxDb once, it simply loads the cached
version. In order to remove the cached TxDb and regenerate, one can remove the
relevant entry from the `tximeta` file cache that resides at the location given
by `getTximetaBFC()`.

The `se` object created by `tximeta`, has the start, end, and strand information
for each transcript. Here, we swap out the transcript *GRanges* for
exons-by-transcript *GRangesList* (it is a list of *GRanges*, where each element
of the list gives the exons for a particular transcript).

```{r}
se.exons <- addExons(se)
rowRanges(se.exons)[[1]]
```

As with the transcript ranges, the exon ranges will be generated once and cached
locally. As it takes a non-negligible amount of time to generate the
exon-by-transcript *GRangesList*, this local caching offers substantial time
savings for repeated usage of `addExons` with the same transcriptome.

We have implemented `addExons` to work only on the transcript-level
*SummarizedExperiment* object. We provide some motivation for this choice in
`?addExons`. Briefly, if it is desired to know the exons associated with a
particular gene, we feel that it makes more sense to pull out the relevant set
of exons-by-transcript for the transcripts for this gene, rather than losing the
hierarchical structure (exons to transcripts to genes) that would occur with a
*GRangesList* of exons grouped per gene.

# Easy summarization to gene-level

Likewise, the *tximeta* package can make use of the cached TxDb database for the
purpose of summarizing transcript-level quantifications and bias corrections to
the gene-level. After summarization, the `rowRanges` reflect the start and end
position of the gene, which in Bioconductor are defined by the leftmost and
rightmost genomic coordinates of all the transcripts. As with the transcript and
exons, the gene ranges are cached locally for repeated usage. The transcript IDs
are stored as a *CharacterList* column `tx_ids`.

**Note:** you can also use `summarizeToGene` on an object created with
`skipMeta=TRUE` which therefore does not have ranges or an associated *TxDb* by
setting `skipRanges=TRUE` and providing your own `tx2gene` table which is passed
to `tximport`.

```{r}
gse <- summarizeToGene(se)
rowRanges(gse)
```

## Assign ranges by abundance

We also offer a new type of range assignment, based on the most abundant isoform
rather than the leftmost to rightmost coordinate. See the `assignRanges`
argument of `?summarizeToGene`. Using the most abundant isoform arguably will
reflect more accurate genomic distances than the default option.

```{r eval=FALSE}
# unevaluated code chunk
gse <- summarizeToGene(se, assignRanges="abundant")
```

For more explanation about why this may be a better choice, see the following
tutorial chapter:

<https://tidyomics.github.io/tidy-ranges-tutorial/gene-ranges-in-tximeta.html>

In the below diagram, the pink feature is the set of all exons belonging to any
isoform of the gene, such that the TSS is on the right side of this minus strand
feature. However, the blue feature is the most abundant isoform (the brown
features are the next most abundant isoforms). The pink feature is therefore not
a good representation for the locus.

```{r echo=FALSE, fig.alt="Transcripts compared to whole gene extent"}
knitr::include_graphics("images/assignRanges-abundant.png")
```

# Add different identifiers

We would like to add support to easily map transcript or gene identifiers from
one annotation to another. This is just a prototype function, but we show how we
can easily add alternate IDs given that we know the organism and the source of
the transcriptome. (This function currently only works for GENCODE and Ensembl
gene or transcript IDs but could be extended to work for arbitrary sources.)

```{r}
library(org.Dm.eg.db)
gse <- addIds(gse, "REFSEQ", gene=TRUE)
mcols(gse)
```

# Differential gene expression analysis

The following code chunk demonstrates how to build a *DESeqDataSet* and begin a
differential expression analysis with genewise counts.

```{r}
#| eval: false
suppressPackageStartupMessages(library(DESeq2))
# here there is a single sample so we use ~1.
# expect a warning that there is only a single sample...
suppressWarnings({dds <- DESeqDataSet(gse, ~1)})
# ... see DESeq2 vignette
```

The following code demonstrates how build a *DGEList* object for use
with *edgeR* or *limma-voom*.

```{r}
suppressPackageStartupMessages(library(edgeR))
y <- DGEListFromTximeta(gse)
# ... see edgeR or limma User's Guide for further steps
```

Above we generated counts-from-abundance when calling `summarizeToGene`. The
counts-from-abundance status is then stored in the metadata:

```{r}
metadata(gse)$countsFromAbundance 
```

# Differential transcript expression and usage analysis

The *Swish* method in the *fishpond* package directly works with the
*SummarizedExperiment* output from *tximeta*, and can perform differential
analysis on transcript expression taking into account inferential replicates,
e.g. bootstrap or Gibbs samples, which are imported and arranged by `tximeta` if
these were generated during quantification.

```{r}
#| eval: false
library(fishpond)
y <- se
y <- scaleInfReps(y)
y <- labelKeep(y)
y <- swish(y, x="condition")
# ... see Swish vignette in fishpond package
```

The `edgeR::DGEListFromTximeta` function uses the inferential replicates found in `se` or `gse`
to estimate the overdispersion for each transcript or gene arising from the fact that reads have
to be assigned probabilistically to transcripts by the quantification software (*salmon*
in this case).
The `DGEListFromTximeta` function is available in *edgeR* as of version 4.10.0 
(Bioconductor release 3.23, Spring 2026).
Differential analyses of transcript expression or usage can be conducted in *edgeR* or *limma*
using "divided counts", whereby the overdispersion is divided out of the counts [@baldoni2024dividing; @baldoni2025dtu].
The following code produces a *DGEList* object suitable for transcript-level analysis
in *edgeR* or *limma*.

```{r}
y <- DGEListFromTximeta(se, divide = TRUE)
# ... see edgeR or limma User's Guide for further steps
```

# Additional metadata slots

The following information is attached to the *SummarizedExperiment* by
`tximeta`:

```{r}
names(metadata(se))
str(metadata(se)[["quantInfo"]])
str(metadata(se)[["txomeInfo"]])
str(metadata(se)[["tximetaInfo"]])
str(metadata(se)[["txdbInfo"]])
```

# Mixed reference transcripts

The [oarfish](https://github.com/COMBINE-lab/oarfish) [@oarfish] quantification tool
allows specifying distinct *annotated* reference transcripts (e.g. GENCODE,
Ensembl) and *novel* reference transcripts (e.g. *de novo* assemblies) which are
combined together as the index for alignment and quantification. As with quantification
from _salmon_, _tximeta_ can now automatically recognize the provenance of 
reference transcripts even when sets from different sources are combined.

For example, _oarfish_ code for indexing and quantification follows the paradigm:

```
oarfish --only-index --annotated gencode.v48.transcripts.fa.gz \
  --novel my_novel_txps.fa.gz --seq-tech ont-cdna --threads 32 \
  --index-out gencode_plus_novel
oarfish --reads reads/experiment_rep1.fastq.gz --index gencode_plus_novel \
  --output quants/experiment_rep1 --seq-tech ont-cdna \
  --filter-group no-filters --threads 32
```

Here we introduce a new workflow for importing data and linking quantification data to metadata, 
designed for this mixed reference transcript situation, but which may be generalized
in the future for other transcript quantification settings.

  - `importData()` - imports data as an un-ranged _SummarizedExperiment_
  - `inspectDigests()` - inspects the digest status of the indices for imported data
  - `updateMetadata()` - assists in attaching metadata from matching reference transcriptomes
  - and _linkedTxpData_, a lightweight version of _linkedTxome_, described [below](#linked-transcriptomes)

Below is an un-evaluated code chunk with typical code you may use 
for an experiment called `experiment` with samples `rep1` to `rep4`:

```{r}
#| eval: false
# specify oarfish .quant files
# quantified against an index of two .fa files, e.g.:
# `--annotated gencode.v48.transcripts.fa.gz --novel my_novel_txps.fa.gz`
names <- paste0("rep", 1:4)
files <- file.path(dir, paste0("experiment_", names, ".quant.gz"))
coldata <- data.frame(files, names) # the sample info table
se <- importData(coldata, type="oarfish")
```

Below is an evaluated code chunk which first points to the location of 
the dataset used for the vignette. The above code chunk is more typical 
for a user however.

```{r}
dir <- system.file("extdata/oarfish", package="tximportData")
names <- paste0("rep", 2:4)
files <- file.path(dir, paste0("sgnex_h9_", names, ".quant.gz"))
coldata <- data.frame(files, names)
# read in the quantification data
se <- importData(coldata, type="oarfish")
```

The `importData()` function returns an un-ranged SummarizedExperiment, with no
metadata attached. This is similar to what `tximeta()` does with
`skipMeta=TRUE`.

```{r}
class(se)
rowData(se)
```

```{r echo=FALSE, message=FALSE}
# this chunk is required to avoiding downloading GTF file from FTP
gtf_dir <- system.file("extdata/gencode", package="tximportData")
gtf <- file.path(gtf_dir, "gencode.v48.annotation.gtf.gz")
makeLinkedTxome(
  digest = "6fc626c828b7a342ab0c6ff753055761989bf0e2306370e8766fedf45ad3adb3",
  indexName = "gencode.v48",
  source = "LocalGENCODE",
  organism = "Homo sapiens",
  release = "48",
  genome = "GRCh38",
  fasta = "/path/to/fasta.fa",
  gtf = gtf,
  write = FALSE
)
```

We can now inspect the digests of the two indices:

```{r}
# returns a 2-row tibble
# (here localGENCODE avoids downloading an ftp file)
inspectDigests(se)
```

We can see the `source` and other annotation details for
`annotated` and for `novel`.
If a match is found in the pre-computed digests, the
[linkedTxome](#linked-transcriptomes) digests,
or the `linkedTxpData` digests, it will populate the
`source` to `genome` columns and will indicate if it is a 
`linkedTxome` or `linkedTxpData` match. 

**Note**: `linkedTxpData` is a newly developed, lightweight
version of `linkedTxome`, which links quantification data
to metadata in the form of a _GRanges_ object for a set of 
transcripts. For more details see the man page for 
`makeLinkedTxpData()`.

If both `linkedTxome` and `linkedTxpData` are `FALSE`
and the metadata is populated, the digest was a match among the
[pre-computed digests](#pre-computed-digests).

A small 6-character version of the digest is printed. 
One can also obtain the full digest (shown below). 

```{r}
inspectDigests(se, fullDigest=TRUE)
```

One can also obtain the count (`count=TRUE`) of matching transcripts per index,
which involves loading transcript data from locally cached sources
(or generating these from local or remote GTF as needed).

Inspection can be run iteratively, in combination with `makeLinkedTxome()` 
described [below](#linked-transcriptomes) or
`makeLinkedTxpData()`, in order to match up missing digests with GTF files
and/or range-based metadata.

The next step is to run `updateMetadata()`. 
This function does what `tximeta()` does by default for a single index, by
adding available metadata and attaching to `rowData`. Thus `updateMetadata()`
overlaps with previous behavior by `addIds()`. Some options here are to add
`ranges=TRUE` which populates `rowRanges` but necessitates removing transcripts
(rows) without range information. Here, transcripts are preserved but `NA`
filled in for columns where we don't have metadata.

```{r}
se_update <- updateMetadata(se)
mcols(se_update)
```

`updateMetadata()` also allows adding metadata manually, either in the form 
of a _GRanges_ object or _data.frame_-like object. Note that `makeLinkedTxpData()`
can be used for persistent addition of _GRanges_ metadata across sessions.

```{r}
# define novel set so we can add metadata
novel <- data.frame(
  seqnames = paste0("chr", rep(1:22, each = 500)),
  start = 1e6 + 1 + 0:499 * 1000,
  end = 1e6 + 1 + 0:499 * 1000 + 1000 - 1,
  strand = "+",
  tx_name = paste0("novel", 1:(22 * 500)),
  gene_id = paste0("novel_gene", rep(1:(22 * 10), each = 50)),
  type = "protein_coding"
)
head(novel)
library(GenomicRanges)
novel_gr <- as(novel, "GRanges")
names(novel_gr) <- novel$tx_name
```

Metadata specified via the `txpData` argument will be added to transcript labelled
with `index="user"`.

```{r}
se_with_ranges <- updateMetadata(se, txpData=novel_gr, ranges=TRUE)
rowRanges(se_with_ranges)
```

Two additional details for `inspectDigests()` and `updateMetadata()`:

1. The argument `prefer` specifies the preferred order of digest match 
   across various _tximeta_ registries. Default is `txome`: linkedTxome, 
   then `txpdata`: linkedTxpData, finally `precomputed`.
2. One can specify per index, the `key`, _i.e._ the name of the column 
   used for matching metadata. By default `tx_name` is used.

This new workflow for data import is under active development, feel free to post an
[Issue](https://github.com/thelovelab/tximeta/issues/new) 
with any feedback.

# Errors connecting to a database

`tximeta` makes use of *BiocFileCache* to store transcript and other databases,
so saving the relevant databases in a centralized location used by other
Bioconductor packages as well. It is possible that an error can occur in
connecting to these databases, either if the files were accidentally removed
from the file system, or if there was an error generating or writing the
database to the cache location. In each of these cases, it is easy to remove the
entry in the *BiocFileCache* so that `tximeta` will know to regenerate the
transcript database or any other missing database.

If you have used the default cache location, then you can obtain access to your
BiocFileCache with:

```{r}
library(BiocFileCache)
bfc <- BiocFileCache()
```

Otherwise, you can recall your particular `tximeta` cache location with
`getTximetaBFC()`.

You can then inspect the entries in your BiocFileCache using `bfcinfo` and
remove the entry associated with the missing database with `bfcremove`. See the
BiocFileCache vignette for more details on finding and removing entries from a
BiocFileCache.

Note that there may be many entries in the BiocFileCache location, including
`.sqlite` database files and serialized `.rds` files. You should only remove the
entry associated with the missing database, e.g. if R gave an error when trying
to connect to the TxDb associated with GENCODE v99 human transcripts, you should
look for the `rid` of the entry associated with the human v99 GTF from GENCODE.

# What if digest isn't known?

`tximeta` automatically imports relevant metadata when the transcriptome matches
a known source -- *known* in the sense that it is in the set of pre-computed
digests in `tximeta` (GENCODE, Ensembl, and RefSeq for human and mouse).
`tximeta` also facilitates the linking of transcriptomes used in building the
*salmon* index with relevant public sources, in the case that these are not part
of this pre-computed set known to `tximeta`. The linking of the transcriptome
source with the quantification files is important in the case that the
transcript sequence no longer matches a known source (uniquely combined or
filtered FASTA files), or if the source is not known to `tximeta`. Combinations
of coding and non-coding human, mouse, and fruit fly *Ensembl* transcripts
should be automatically recognized by `tximeta` and does not require making a
*linkedTxome*. As the package is further developed, we plan to roll out support
for all common transcriptomes, from all sources.

**Note:** if you are using *salmon* in alignment mode, then there is no salmon
index, and without the salmon index, there is no digest. We don't have a perfect
solution for this yet, but you can still summarize transcript counts to gene
with a `tx2gene` table that you construct manually (see `tximport` vignette for
example code). Just specify the arguments,
`skipMeta=TRUE, txOut=FALSE, tx2gene=tx2gene`, when calling `tximeta` and it
will perform summarization to gene level as in `tximport`.

We now demonstrate how to make a *linkedTxome* and how to share and load a
*linkedTxome*. We point to a *salmon* quantification file which was quantified
against a transcriptome that included the coding and non-coding *Drosophila
melanogaster* transcripts, as well as an artificial transcript of 960 bp (for
demonstration purposes only).

```{r}
dir <- system.file("extdata/salmon_dm", package="tximportData")
file <- file.path(dir, "SRR1197474.plus", "quant.sf")
file.exists(file)
coldata <- data.frame(files=file, names="SRR1197474", sample="1",
                      stringsAsFactors=FALSE)
```

Trying to import the files gives a message that `tximeta` couldn't find a
matching transcriptome, so it returns an non-ranged *SummarizedExperiment*.

```{r}
se <- tximeta(coldata)
```

# Linked transcriptomes {#linked-transcriptomes}

If the transcriptome used to generate the *salmon* index does not match any
transcriptomes from known sources (e.g. from combining or filtering known
transcriptome files), there is not much that can be done to automatically
populate the metadata during quantification import. However, we can facilitate
the following two cases:

1)  the transcriptome was created locally and has been linked to its public
    source(s)
2)  the transcriptome was produced by another group, and they have produced and
    shared a file that links the transcriptome to public source(s)

`tximeta` offers functionality to assist reproducible analysis in both of these
cases.

To make this quantification reproducible, we make a `linkedTxome` which records
key information about the sources of the transcript FASTA files, and the
location of the relevant GTF file. It also records the digest of the
transcriptome that was computed by *salmon* during the `index` step.

**Source:** when creating the `linkedTxome` one must specify the `source` of the
transcriptome. See `?linkedTxome` for a note on the implications of this text
string. For canonical GENCODE or Ensembl transcriptomes, one can use `"GENCODE"`
or `"Ensembl"`, but for modified or otherwise any transcriptomes defined by a
local database, it is recommended to use a different string, `"LocalGENCODE"` or
\`"LocalEnsembl", which will avoid *tximeta* pulling canonical GENCODE or
Ensembl resources from AnnotationHub.

**Multiple GTF/GFF files:** `linkedTxome` and `tximeta` do not currently support
multiple GTF/GFF files, which is a more complicated case than multiple FASTA,
which is supported. Currently, we recommend that users should add or combine
GTF/GFF files themselves to create a single GTF/GFF file that contains all
features used in quantification, and then upload such a file to *Zenodo*, which
can then be linked as shown below. Feel free to contact the developers on the
Bioconductor support site or GitHub Issue page for further details or feature
requests.

**Stringtie:** A special note for building on top of Stringtie-generated
transcripts: it is a good idea to change gene identifiers, to *not* include a
period `.`, as the period will later be used to separate transcript versions
from gene identifiers. This can be done before building the salmon index, by
changing periods in the gene identifier to an underscore. See [this GitHub
issue](https://github.com/thelovelab/tximeta/issues/68) for details.

By default, `linkedTxome` will write out a JSON file which can be shared with
others, linking the digest of the index with the other metadata, including FASTA
and GTF sources. By default, it will write out to a file with the same name as
the `indexDir`, but with a `.json` extension added. This can be prevented with
`write=FALSE`, and the file location can be changed with `jsonFile`.

First we specify the path where *salmon* index directory with `indexDir`, 
which will be used to look up the digest and associate it with the index.
Alternatively one can specify the `digest` itself and an `indexName`.

Typically you would not use `system.file` and `file.path` to locate this
directory, but simply define `indexDir` to be the path of the *salmon* directory
on your machine. Here we use `system.file` and `file.path` because we have
included parts of a *salmon* index directory in the *tximeta* package itself for
demonstration of functionality in this vignette.

```{r}
indexDir <- file.path(dir, "Dm.BDGP6.22.98.plus_salmon-0.14.1")
```

Now we provide the location of the FASTA files and the GTF file for this
transcriptome.

**Note:** the basename for the GTF file is used as a unique identifier for the
cached versions of the *TxDb* and the transcript ranges, which are stored on the
user's behalf via *BiocFileCache*. This is not an issue, as GENCODE, Ensembl,
and RefSeq all provide GTF files which are uniquely identified by their
filename, e.g. `Drosophila_melanogaster.BDGP6.22.98.gtf.gz`.

The recommended usage of `tximeta` would be to specify a remote GTF source, as
seen in the commented-out line below:

```{r}
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz",
              "extra_transcript.fa.gz")
#gtfFTP <- "ftp://path/to/custom/Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz"
```

Instead of the above commented-out FTP location for the GTF file, we specify a
location within an R package. This step is just to avoid downloading from a
remote FTP during vignette building. This use of `file.path` to point to a file
in an R package is specific to this vignette and should not be used in a typical
workflow. The following GTF file is a modified version of the release 98 from
Ensembl, which includes description of a one transcript, one exon artificial
gene which was inserted into the transcriptome (for demonstration purposes
only).

```{r}
gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz")
```

Finally, we create a *linkedTxome*. In this vignette, we point to a temporary
directory for the JSON file, but a more typical workflow would write the JSON
file to the same location as the *salmon* index by not specifying `jsonFile`.

`makeLinkedTxome` performs two operation: (1) it creates a new entry in an
internal table that links the transcriptome used in the *salmon* index to its
sources, and (2) it creates a JSON file such that this *linkedTxome* can be
shared.

Here we can either specify `indexDir` or alternatively, the `digest` itself and
an `indexName`.

```{r}
tmp <- tempdir() # just for vignette demo, make temp directory
jsonFile <- file.path(tmp, paste0(basename(indexDir), ".json"))
makeLinkedTxome(indexDir=indexDir,
                source="LocalEnsembl", organism="Drosophila melanogaster",
                release="98", genome="BDGP6.22",
                fasta=fastaFTP, gtf=gtfPath,
                jsonFile=jsonFile)
```

After running `makeLinkedTxome`, the connection between this *salmon* index (and
its digest) with the sources is saved for persistent usage. Note that because we
added a single transcript of 960bp to the FASTA file used for quantification,
`tximeta` could tell that this was not quantified against release 98 of the
Ensembl transcripts for *Drosophila melanogaster*. Only when the correct set of
transcripts were specified does `tximeta` recognize and import the correct
metadata.

With use of `tximeta` and a *linkedTxome*, the software figures out if the
remote GTF has been accessed and compiled into a *TxDb* before, and on future
calls, it will simply load the pre-computed metadata and transcript ranges.

Note the warning that 5 of the transcripts are missing from the GTF file and so
are dropped from the final output. This is a problem coming from the annotation
source, and not easily avoided by `tximeta`.

```{r}
se <- tximeta(coldata)
```

We can see that the appropriate metadata and transcript ranges are attached.

```{r}
rowRanges(se)
seqinfo(se)
```

# Clear *linkedTxomes*

The following code removes the entire table with information about the
*linkedTxomes*. This is just for demonstration, so that we can show how to load
a JSON file below.

**Note:** Running this code will clear any information about *linkedTxomes*.
Don't run this unless you really want to clear this table!

```{r}
library(BiocFileCache)
if (interactive()) {
  bfcloc <- getTximetaBFC()
} else {
  bfcloc <- tempdir()
}
bfc <- BiocFileCache(bfcloc)
bfcinfo(bfc)
# only run the next line if you want to remove your linkedTxome table!
bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
bfcinfo(bfc)
```

# Loading *linkedTxome* JSON files

If a collaborator or the Suppmentary Files for a publication shares a
`linkedTxome` JSON file, we can likewise use `tximeta` to automatically assemble
the relevant metadata and transcript ranges. This implies that the other person
has used `tximeta` with the function `makeLinkedTxome` demonstrated above,
pointing to their *salmon* index and to the FASTA and GTF source(s).

We point to the JSON file and use `loadLinkedTxome` and then the relevant
metadata is saved for persistent usage. In this case, we saved the JSON file in
a temporary directory.

```{r}
jsonFile <- file.path(tmp, paste0(basename(indexDir), ".json"))
loadLinkedTxome(jsonFile)
```

Again, using `tximeta` figures out whether it needs to access the remote GTF or
not, and assembles the appropriate object on the user's behalf.

```{r}
se <- tximeta(coldata)
```

# Clear *linkedTxomes* again

Finally, we clear the *linkedTxomes* table again so that the above examples will
work. This is just for the vignette code and not part of a typical workflow.

**Note:** Running this code will clear any information about *linkedTxomes*.
Don't run this unless you really want to clear this table!

```{r}
if (interactive()) {
  bfcloc <- getTximetaBFC()
} else {
  bfcloc <- tempdir()
}
bfc <- BiocFileCache(bfcloc)
bfcinfo(bfc)
# only run the next line if you want to remove your linkedTxome table!
bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
bfcinfo(bfc)
```

# alevin details

For *alevin* quantification, one should point to the `quants_mat.gz` file that
contains the counts for all of the cells. In order to `tximeta()` to work with
*alevin* quantification, it requires that *alevin* was run using gene IDs in the
`tgMap` step and not gene symbols.

# Other quantifiers {#other-quantifiers}

`tximeta` can import the output from any quantifiers that are supported by
`tximport`, and if these are not *salmon*, *alevin*, or *Sailfish* output, it
will simply return a non-ranged *SummarizedExperiment* by default.

An alternative solution is to wrap other quantifiers in workflows that include
metadata information JSON files along with each quantification file. One can
place these files in `aux_info/meta_info.json` or any relative location
specified by `customMetaInfo`, for example `customMetaInfo="meta_info.json"`.
This JSON file is located relative to the quantification file and should contain
a tag `index_seq_hash` with an associated value of the SHA-256 hash (digest) of
the reference transcripts. For computing the hash value of the reference
transcripts, see the [FastaDigest](https://github.com/COMBINE-lab/FastaDigest)
python package. The hash value used by *salmon* is the SHA-256 hash value of the
reference sequences stripped of the header lines, and concatenated together with
the empty string (so only cDNA sequences combined without any new line
characters). *FastaDigest* can be installed with `pip install fasta_digest`.

# Acknowledgments

The development of *tximeta* has benefited from suggestions from these and other
individuals in the community:

-   Vincent Carey (hashing concept)
-   Lori Shepherd (package development, *BiocFileCache*)
-   Martin Morgan (package development)
-   Koen Van den Berge 
-   Johannes Rainer (integration with *ensembldb*)
-   James Ashmore
-   Ben Johnson
-   Tim Triche
-   Kristoffer Vitting-Seerup
-   Gordon Smyth and Pedro Baldoni (*edgeR* and *limma* functions and docs)

# Session info

```{r}
library(devtools)
session_info()
```

# References

---
title: "tximeta: transcript quantification import with automatic metadata"
author: "Michael I. Love, Charlotte Soneson, Peter F. Hickey, Rob Patro"
date: "`r format(Sys.time(), '%m/%d/%Y')`"
output: 
  rmarkdown::html_vignette:
    highlight: pygments
abstract: >
  _tximeta_ performs numerous annotation and metadata gathering tasks on
  behalf of users during the import of transcript counts and abundance
  from quantification tools such as salmon. Data are imported as
  SummarizedExperiment objects with associated GenomicRanges metadata.
  Correct metadata is added automatically via reference sequence digests, 
  facilitating genomic analyses and assisting in computational reproducibility.
  Addition functionality is now offered for quantification with mixed reference
  transcripts, e.g. GENCODE plus novel transcripts.
bibliography: library.bib
vignette: |
  %\VignetteIndexEntry{tximeta: transcript quantification import with automatic metadata}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
editor:
  markdown:
    wrap: 80
---

If viewing vignette on Bioconductor, see 
[here](https://thelovelab.github.io/tximeta/articles/tximeta.html)
for a nicely rendered version.

# Introduction

The *tximeta* package [@Love2020] extends the *tximport* package [@Soneson2015]
for import of transcript-level quantification data into R/Bioconductor. It
automatically adds annotation metadata when the RNA-seq data has been quantified
with *salmon* [@Patro2017] or related tools. To our knowledge, *tximeta* is the
only package for RNA-seq data import that can automatically identify and attach
transcriptome metadata based on the unique sequence collection of the reference
transcripts. For more details on these packages -- including the motivation for
*tximeta* and description of similar work -- consult the **References** below.

**Note:** For details of using _tximeta_ functions with 
[oarfish](https://github.com/COMBINE-lab/oarfish), 
in particular with separate `--annotated` and `--novel` reference transcripts, refer to 
[this section](#mixed-reference-transcripts) below.

**Note:** `tximeta()` requires that the **entire output** of the quantificaation
tool is present in the output directories and unmodified in order to identify
the provenance of the reference transcripts. In general, it's a good idea to not
modify or re-arrange the output directory of bioinformatic software as other
downstream software often rely on and assume a consistent directory structure.
For sharing multiple samples, one can use, for example, `tar -czf` to bundle up
a set of *salmon* output directories. For tips on using `tximeta()` with other
quantifiers see the [other quantifiers](#other-quantifiers) section below.

```{r echo=FALSE, fig.alt="How tximeta works"}
knitr::include_graphics("images/diagram.png")
```

# Preparing `tximeta` input

The first step using `tximeta()` is to read in the sample table, which will
become the *column data*, `colData`, of the final object, a
*SummarizedExperiment*. The sample table should contain all the information we
need to identify the *salmon* quantification directories.

Here we will use a *salmon* quantification file in the *tximportData* package to
demonstrate the usage of `tximeta`. We do not have a sample table, so we
construct one in R. It is recommended to keep a sample table as a CSV or TSV
file while working on an RNA-seq project with multiple samples.

```{r}
dir <- system.file("extdata/salmon_dm", package="tximportData")
files <- file.path(dir, "SRR1197474", "quant.sf") 
file.exists(files)
coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)
coldata
```

`tximeta()` expects at least two columns in `coldata`:

1.  `files` - a pointer to the `quant.sf` files
2.  `names` - the unique names that should be used to identify samples

Other columns will be propagated to `colData` of the *SummarizedExperiment*
output.

# Running `tximeta`

Normally, we would just run `tximeta` like so:

```{r eval=FALSE}
library(tximeta)
se <- tximeta(coldata)
```

However, to avoid downloading remote GTF files during this vignette, we will
point to a GTF file saved locally (in the *tximportData* package). We link the
transcriptome of the *salmon* index to its locally saved GTF. The standard
recommended usage of `tximeta()`,\
in particular for quantification with reference transcripts with a [pre-computed
digest](#pre-computed-digests), would be the code chunk above. If one were
adding another set of reference transcripts, one would normally specify a remote
GTF source, not a local one. **This following code is therefore not recommended
for a typical workflow, but is particular to the vignette code.**

```{r echo=FALSE}
suppressPackageStartupMessages({
  library(GenomicFeatures)
  })
```

```{r}
indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
suppressPackageStartupMessages(library(tximeta))
makeLinkedTxome(indexDir=indexDir,
                source="LocalEnsembl",
                organism="Drosophila melanogaster",
                release="98",
                genome="BDGP6.22",
                fasta=fastaFTP,
                gtf=gtfPath,
                write=FALSE)
```

```{r message=FALSE}
library(tximeta)
```

```{r}
se <- tximeta(coldata)
```

This warning, "*Warning: the annotation is missing some transcripts that were
quantified.*", is common and occurs when annotation sources provide transcripts
in the FASTA file that aren't annotated in the GTF file. This is upstream of
`tximeta()`, but this package will notify you the number of transcripts for
which this is the case.

# How does it work?

`tximeta()` recognized the computed *digest* of the transcriptome that the files
were quantified against, it accessed the GTF file of the transcriptome source,
found and attached the transcript ranges, and added the appropriate
transcriptome and genome metadata. A *digest* is a small string of alphanumeric
characters that uniquely identifies the collection of sequences that were used
for quantification (it is the hash value from applying the hash function to a
particular collection of nucleotide sequences). We sometimes also call this
value a "checksum" (in the tximeta paper), and we sometimes call the table of
pre-computed digests or linked digests a "hash table".

Note that a remote GTF is only downloaded once, and a local or remote GTF is
only parsed to build a *TxDb* or *EnsDb* once: if `tximeta()` recognizes that it
has seen this *salmon* index before, it will use a cached version of the
metadata and transcript ranges.

# Packages used for caching metadata

`tximeta()` makes use of Bioconductor packages for storing transcript databases
as *TxDb* or *EnsDb* objects, which both are connected by default to `sqlite`
backends. For GENCODE and RefSeq GTF files, `tximeta()` uses the *txdbmaker*
package to parse the GTF and build a *TxDb*. For Ensembl GTF files, `tximeta()`
will first attempt to obtain the correct *EnsDb* object using *AnnotationHub*.
The *ensembldb* package [@ensembldb] contains classes and methods for extracting
relevant data from Ensembl files. If the *EnsDb* has already been made available
on AnnotationHub, `tximeta()` will download the database directly, which saves
the user time parsing the GTF into a database (to avoid this, set
`useHub=FALSE`). If the relevant *EnsDb* is not available on AnnotationHub,
`tximeta()` will build an *EnsDb* using *ensembldb* after downloading the GTF
file. Again, the download/construction of a transcript database occurs only
once, and upon subsequent usage of *tximeta* functions, the cached version will
be used.

# Pre-computed digests

The following digests for human, mouse, and drosophila reference transcripts are
supported in this version of `tximeta()`:

```{r echo=FALSE}
dir2 <- system.file("extdata", package="tximeta")
tab <- read.csv(file.path(dir2, "hashtable.csv"),
                stringsAsFactors=FALSE)
release.range <- function(tab, source, organism) {
  tab.idx <- tab$organism == organism & tab$source == source
  rels <- tab$release[tab.idx]
  if (organism == "Mus musculus" & source == "GENCODE") {
    paste0("M", range(as.numeric(sub("M","",rels))))
  } else if (source == "RefSeq") {
    paste0("p", range(as.numeric(sub(".*p","",rels))))
  } else {
    range(as.numeric(rels))
  }
}
dat <- data.frame(
  source=rep(c("GENCODE","Ensembl","RefSeq"),c(2,3,2)),
  organism=c("Homo sapiens","Mus musculus",
             "Drosophila melanogaster")[c(1:2,1:3,1:2)]
)
rng <- t(sapply(seq_len(nrow(dat)), function(i)
  release.range(tab, dat[i,1], dat[i,2])))
dat$releases <- paste0(rng[,1], "-", rng[,2])
knitr::kable(dat)
```

For Ensembl transcriptomes, we support the combined protein coding (cDNA) and
non-coding (ncRNA) sequences, as well as the protein coding alone (although the
former approach combining coding and non-coding transcripts is recommended for
more accurate quantification).

`tximeta()` also supports *linked transcriptomes*, a mechanism to link
quantification data to key metadata. This can be used to resolve many potential
situations where one of the above pre-computed digests won't be a match (due to
modifying, re-ordering, adding, or removing transcripts, which changes the value
of the compute digest). See the [Linked transcriptomes](#linked-transcriptomes)
section below for a demonstration. (The *makeLinkedTxome* function was used
above to avoid downloading the GTF during the vignette building process.)

For *oarfish* quantification [@oarfish] using the `--annotated` and `--novel`
reference transcripts, use the functions described
[below](#mixed-reference-transcripts).

# SummarizedExperiment output

The `SummarizedExperiment` object resulting from the data import contains 
our coldata from before. Note that the `files` column was removed during the 
import.

```{r}
suppressPackageStartupMessages(library(SummarizedExperiment))
colData(se)
```

Here we show the three matrices that were imported.

```{r}
assayNames(se)
```

If there were inferential replicates (Gibbs samples or bootstrap samples), these
would be imported as additional assays named `"infRep1"`, `"infRep2"`, ...

`tximeta()` has imported the correct ranges for the transcripts:

```{r}
rowRanges(se)
```

We have appropriate genome information, which prevents us from making
bioinformatic mistakes:

```{r}
seqinfo(se)
```

# Retrieve the transcript database

The `se` object has associated metadata that allows `tximeta` to link to locally
stored cached databases and other Bioconductor objects. In further sections, we
will show examples of functions that leverage these databases to add exon
information, summarize transcript-level data to the gene level, or add
identifiers. However, first we mention that the user can easily access the
cached database with the following helper function. In this case, `tximeta` has
an associated *EnsDb* object that we can retrieve and use in our R session:

```{r}
edb <- retrieveDb(se)
class(edb)
```

The database returned by `retrieveDb` is either a *TxDb* in the case of GENCODE
or RefSeq GTF annotation file, or an *EnsDb* in the case of an Ensembl GTF
annotation file. For further use of these two database objects, consult the
*GenomicFeatures* vignettes and the *ensembldb* vignettes, respectively (both
Bioconductor packages).

# Add exons per transcript

Because the SummarizedExperiment maintains all the metadata of its creation, it
also keeps a pointer to the necessary database for pulling out additional
information, as demonstrated in the following sections.

If necessary, the *tximeta* package can pull down the remote source to build a
TxDb, but given that we've already built a TxDb once, it simply loads the cached
version. In order to remove the cached TxDb and regenerate, one can remove the
relevant entry from the `tximeta` file cache that resides at the location given
by `getTximetaBFC()`.

The `se` object created by `tximeta`, has the start, end, and strand information
for each transcript. Here, we swap out the transcript *GRanges* for
exons-by-transcript *GRangesList* (it is a list of *GRanges*, where each element
of the list gives the exons for a particular transcript).

```{r}
se.exons <- addExons(se)
rowRanges(se.exons)[[1]]
```

As with the transcript ranges, the exon ranges will be generated once and cached
locally. As it takes a non-negligible amount of time to generate the
exon-by-transcript *GRangesList*, this local caching offers substantial time
savings for repeated usage of `addExons` with the same transcriptome.

We have implemented `addExons` to work only on the transcript-level
*SummarizedExperiment* object. We provide some motivation for this choice in
`?addExons`. Briefly, if it is desired to know the exons associated with a
particular gene, we feel that it makes more sense to pull out the relevant set
of exons-by-transcript for the transcripts for this gene, rather than losing the
hierarchical structure (exons to transcripts to genes) that would occur with a
*GRangesList* of exons grouped per gene.

# Easy summarization to gene-level

Likewise, the *tximeta* package can make use of the cached TxDb database for the
purpose of summarizing transcript-level quantifications and bias corrections to
the gene-level. After summarization, the `rowRanges` reflect the start and end
position of the gene, which in Bioconductor are defined by the leftmost and
rightmost genomic coordinates of all the transcripts. As with the transcript and
exons, the gene ranges are cached locally for repeated usage. The transcript IDs
are stored as a *CharacterList* column `tx_ids`.

**Note:** you can also use `summarizeToGene` on an object created with
`skipMeta=TRUE` which therefore does not have ranges or an associated *TxDb* by
setting `skipRanges=TRUE` and providing your own `tx2gene` table which is passed
to `tximport`.

```{r}
gse <- summarizeToGene(se)
rowRanges(gse)
```

## Assign ranges by abundance

We also offer a new type of range assignment, based on the most abundant isoform
rather than the leftmost to rightmost coordinate. See the `assignRanges`
argument of `?summarizeToGene`. Using the most abundant isoform arguably will
reflect more accurate genomic distances than the default option.

```{r eval=FALSE}
# unevaluated code chunk
gse <- summarizeToGene(se, assignRanges="abundant")
```

For more explanation about why this may be a better choice, see the following
tutorial chapter:

<https://tidyomics.github.io/tidy-ranges-tutorial/gene-ranges-in-tximeta.html>

In the below diagram, the pink feature is the set of all exons belonging to any
isoform of the gene, such that the TSS is on the right side of this minus strand
feature. However, the blue feature is the most abundant isoform (the brown
features are the next most abundant isoforms). The pink feature is therefore not
a good representation for the locus.

```{r echo=FALSE, fig.alt="Transcripts compared to whole gene extent"}
knitr::include_graphics("images/assignRanges-abundant.png")
```

# Add different identifiers

We would like to add support to easily map transcript or gene identifiers from
one annotation to another. This is just a prototype function, but we show how we
can easily add alternate IDs given that we know the organism and the source of
the transcriptome. (This function currently only works for GENCODE and Ensembl
gene or transcript IDs but could be extended to work for arbitrary sources.)

```{r}
library(org.Dm.eg.db)
gse <- addIds(gse, "REFSEQ", gene=TRUE)
mcols(gse)
```

# Differential gene expression analysis

The following code chunk demonstrates how to build a *DESeqDataSet* and begin a
differential expression analysis with genewise counts.

```{r}
#| eval: false
suppressPackageStartupMessages(library(DESeq2))
# here there is a single sample so we use ~1.
# expect a warning that there is only a single sample...
suppressWarnings({dds <- DESeqDataSet(gse, ~1)})
# ... see DESeq2 vignette
```

The following code demonstrates how build a *DGEList* object for use
with *edgeR* or *limma-voom*.

```{r}
suppressPackageStartupMessages(library(edgeR))
y <- DGEListFromTximeta(gse)
# ... see edgeR or limma User's Guide for further steps
```

Above we generated counts-from-abundance when calling `summarizeToGene`. The
counts-from-abundance status is then stored in the metadata:

```{r}
metadata(gse)$countsFromAbundance 
```

# Differential transcript expression and usage analysis

The *Swish* method in the *fishpond* package directly works with the
*SummarizedExperiment* output from *tximeta*, and can perform differential
analysis on transcript expression taking into account inferential replicates,
e.g. bootstrap or Gibbs samples, which are imported and arranged by `tximeta` if
these were generated during quantification.

```{r}
#| eval: false
library(fishpond)
y <- se
y <- scaleInfReps(y)
y <- labelKeep(y)
y <- swish(y, x="condition")
# ... see Swish vignette in fishpond package
```

The `edgeR::DGEListFromTximeta` function uses the inferential replicates found in `se` or `gse`
to estimate the overdispersion for each transcript or gene arising from the fact that reads have
to be assigned probabilistically to transcripts by the quantification software (*salmon*
in this case).
The `DGEListFromTximeta` function is available in *edgeR* as of version 4.10.0 
(Bioconductor release 3.23, Spring 2026).
Differential analyses of transcript expression or usage can be conducted in *edgeR* or *limma*
using "divided counts", whereby the overdispersion is divided out of the counts [@baldoni2024dividing; @baldoni2025dtu].
The following code produces a *DGEList* object suitable for transcript-level analysis
in *edgeR* or *limma*.

```{r}
y <- DGEListFromTximeta(se, divide = TRUE)
# ... see edgeR or limma User's Guide for further steps
```

# Additional metadata slots

The following information is attached to the *SummarizedExperiment* by
`tximeta`:

```{r}
names(metadata(se))
str(metadata(se)[["quantInfo"]])
str(metadata(se)[["txomeInfo"]])
str(metadata(se)[["tximetaInfo"]])
str(metadata(se)[["txdbInfo"]])
```

# Mixed reference transcripts

The [oarfish](https://github.com/COMBINE-lab/oarfish) [@oarfish] quantification tool
and *salmon* allow specifying distinct *annotated* reference transcripts (e.g. GENCODE,
Ensembl) and *novel* reference transcripts (e.g. *de novo* assemblies) which are
combined together as the index for alignment and quantification. _tximeta_ can now
automatically recognize the provenance of reference transcripts even when sets from
different sources are combined.

For example, _oarfish_ code for indexing and quantification follows the paradigm:

```
oarfish --only-index --annotated gencode.v48.transcripts.fa.gz \
  --novel my_novel_txps.fa.gz --seq-tech ont-cdna --threads 32 \
  --index-out gencode_plus_novel
oarfish --reads reads/experiment_rep1.fastq.gz --index gencode_plus_novel \
  --output quants/experiment_rep1 --seq-tech ont-cdna \
  --filter-group no-filters --threads 32
```

```{r echo=FALSE, fig.alt="Diagram of tximeta mixed reference workflow"}
knitr::include_graphics("images/mixed-ref-diagram.png")
```

Here we introduce a new workflow for importing data and linking quantification data to metadata, 
designed for this mixed reference transcript situation, but which may be generalized
in the future for other transcript quantification settings.

  - `importData()` - imports data as an un-ranged _SummarizedExperiment_
  - `inspectDigests()` - inspects the digest status of the indices for imported data
  - `updateMetadata()` - assists in attaching metadata from matching reference transcriptomes
  - and _linkedTxpData_, a lightweight version of _linkedTxome_, described [below](#linked-transcriptomes)

Below is an un-evaluated code chunk with typical code you may use
for an experiment called `experiment` with samples `rep1` to `rep4`:

```{r}
#| eval: false
# specify oarfish .quant files
# quantified against an index of two .fa files, e.g.:
# `--annotated gencode.v48.transcripts.fa.gz --novel my_novel_txps.fa.gz`
names <- paste0("rep", 1:4)
files <- file.path(dir, paste0("experiment_", names, ".quant.gz"))
coldata <- data.frame(files, names) # the sample info table
se <- importData(coldata, type="oarfish")
```

## salmon mixed reference

*salmon* does not record per-sub-index digests natively. To enable the same
mixed reference workflow, a companion Snakemake rule runs
[`compute_fasta_digest`](https://github.com/COMBINE-lab/FastaDigest) on the
annotated and novel FASTAs at index time and writes a `mixed_ref_digests.json`
file into each quantification output directory alongside `quant.sf`. The
Snakemake rules and further details are available at
[thelovelab/salmon-with-mixed-ref](https://github.com/thelovelab/salmon-with-mixed-ref).

Pass the digest filename to `importData()` via the `mixedDigest` argument:

```{r}
#| eval: false
# specify salmon quant.sf files, quantified against a combined annotated + novel index
names <- paste0("rep", 1:4)
files <- file.path(dir, paste0("experiment_", names, "/quant.sf"))
coldata <- data.frame(files, names)
se <- importData(coldata, type="salmon", mixedDigest="mixed_ref_digests.json")
```

The returned object and all subsequent steps (`inspectDigests()`,
`updateMetadata()`) are identical to the oarfish workflow described below.

## Importing oarfish data

Below is an evaluated code chunk which first points to the location of
the dataset used for the vignette. The above code chunk is more typical
for a user however.

```{r}
dir <- system.file("extdata/oarfish", package="tximportData")
names <- paste0("rep", 2:4)
files <- file.path(dir, paste0("sgnex_h9_", names, ".quant.gz"))
coldata <- data.frame(files, names)
# read in the quantification data
se <- importData(coldata, type="oarfish")
```

The `importData()` function returns an un-ranged SummarizedExperiment, with no
metadata attached. This is similar to what `tximeta()` does with
`skipMeta=TRUE`.

```{r}
class(se)
rowData(se)
```

```{r echo=FALSE, message=FALSE}
# this chunk is required to avoiding downloading GTF file from FTP
gtf_dir <- system.file("extdata/gencode", package="tximportData")
gtf <- file.path(gtf_dir, "gencode.v48.annotation.gtf.gz")
makeLinkedTxome(
  digest = "6fc626c828b7a342ab0c6ff753055761989bf0e2306370e8766fedf45ad3adb3",
  indexName = "gencode.v48",
  source = "LocalGENCODE",
  organism = "Homo sapiens",
  release = "48",
  genome = "GRCh38",
  fasta = "/path/to/fasta.fa",
  gtf = gtf,
  write = FALSE
)
```

We can now inspect the digests of the two indices:

```{r}
# returns a 2-row tibble
# (here localGENCODE avoids downloading an ftp file)
inspectDigests(se)
```

We can see the `source` and other annotation details for
`annotated` and for `novel`.
If a match is found in the pre-computed digests, the
[linkedTxome](#linked-transcriptomes) digests,
or the `linkedTxpData` digests, it will populate the
`source` to `genome` columns and will indicate if it is a 
`linkedTxome` or `linkedTxpData` match. 

**Note**: `linkedTxpData` is a newly developed, lightweight
version of `linkedTxome`, which links quantification data
to metadata in the form of a _GRanges_ object for a set of 
transcripts. For more details see the man page for 
`makeLinkedTxpData()`.

If both `linkedTxome` and `linkedTxpData` are `FALSE`
and the metadata is populated, the digest was a match among the
[pre-computed digests](#pre-computed-digests).

A small 6-character version of the digest is printed. 
One can also obtain the full digest (shown below). 

```{r}
inspectDigests(se, fullDigest=TRUE)
```

One can also obtain the count (`count=TRUE`) of matching transcripts per index,
which involves loading transcript data from locally cached sources
(or generating these from local or remote GTF as needed).

Inspection can be run iteratively, in combination with `makeLinkedTxome()` 
described [below](#linked-transcriptomes) or
`makeLinkedTxpData()`, in order to match up missing digests with GTF files
and/or range-based metadata.

The next step is to run `updateMetadata()`. 
This function does what `tximeta()` does by default for a single index, by
adding available metadata and attaching to `rowData`. Thus `updateMetadata()`
overlaps with previous behavior by `addIds()`. Some options here are to add
`ranges=TRUE` which populates `rowRanges` but necessitates removing transcripts
(rows) without range information. Here, transcripts are preserved but `NA`
filled in for columns where we don't have metadata.

```{r}
se_update <- updateMetadata(se)
mcols(se_update)
```

`updateMetadata()` also allows adding metadata manually, either in the form 
of a _GRanges_ object or _data.frame_-like object. Note that `makeLinkedTxpData()`
can be used for persistent addition of _GRanges_ metadata across sessions.

```{r}
# define novel set so we can add metadata
novel <- data.frame(
  seqnames = paste0("chr", rep(1:22, each = 500)),
  start = 1e6 + 1 + 0:499 * 1000,
  end = 1e6 + 1 + 0:499 * 1000 + 1000 - 1,
  strand = "+",
  tx_name = paste0("novel", 1:(22 * 500)),
  gene_id = paste0("novel_gene", rep(1:(22 * 10), each = 50)),
  type = "protein_coding"
)
head(novel)
library(GenomicRanges)
novel_gr <- as(novel, "GRanges")
names(novel_gr) <- novel$tx_name
```

Metadata specified via the `txpData` argument will be added to transcript labelled
with `index="user"`.

```{r}
se_with_ranges <- updateMetadata(se, txpData=novel_gr, ranges=TRUE)
rowRanges(se_with_ranges)
```

Two additional details for `inspectDigests()` and `updateMetadata()`:

1. The argument `prefer` specifies the preferred order of digest match 
   across various _tximeta_ registries. Default is `txome`: linkedTxome, 
   then `txpdata`: linkedTxpData, finally `precomputed`.
2. One can specify per index, the `key`, _i.e._ the name of the column 
   used for matching metadata. By default `tx_name` is used.

This new workflow for data import is under active development, feel free to post an
[Issue](https://github.com/thelovelab/tximeta/issues/new) 
with any feedback.

# Errors connecting to a database

`tximeta` makes use of *BiocFileCache* to store transcript and other databases,
so saving the relevant databases in a centralized location used by other
Bioconductor packages as well. It is possible that an error can occur in
connecting to these databases, either if the files were accidentally removed
from the file system, or if there was an error generating or writing the
database to the cache location. In each of these cases, it is easy to remove the
entry in the *BiocFileCache* so that `tximeta` will know to regenerate the
transcript database or any other missing database.

If you have used the default cache location, then you can obtain access to your
BiocFileCache with:

```{r}
library(BiocFileCache)
bfc <- BiocFileCache()
```

Otherwise, you can recall your particular `tximeta` cache location with
`getTximetaBFC()`.

You can then inspect the entries in your BiocFileCache using `bfcinfo` and
remove the entry associated with the missing database with `bfcremove`. See the
BiocFileCache vignette for more details on finding and removing entries from a
BiocFileCache.

Note that there may be many entries in the BiocFileCache location, including
`.sqlite` database files and serialized `.rds` files. You should only remove the
entry associated with the missing database, e.g. if R gave an error when trying
to connect to the TxDb associated with GENCODE v99 human transcripts, you should
look for the `rid` of the entry associated with the human v99 GTF from GENCODE.

# What if digest isn't known?

`tximeta` automatically imports relevant metadata when the transcriptome matches
a known source -- *known* in the sense that it is in the set of pre-computed
digests in `tximeta` (GENCODE, Ensembl, and RefSeq for human and mouse).
`tximeta` also facilitates the linking of transcriptomes used in building the
*salmon* index with relevant public sources, in the case that these are not part
of this pre-computed set known to `tximeta`. The linking of the transcriptome
source with the quantification files is important in the case that the
transcript sequence no longer matches a known source (uniquely combined or
filtered FASTA files), or if the source is not known to `tximeta`. Combinations
of coding and non-coding human, mouse, and fruit fly *Ensembl* transcripts
should be automatically recognized by `tximeta` and does not require making a
*linkedTxome*. As the package is further developed, we plan to roll out support
for all common transcriptomes, from all sources.

**Note:** if you are using *salmon* in alignment mode, then there is no salmon
index, and without the salmon index, there is no digest. We don't have a perfect
solution for this yet, but you can still summarize transcript counts to gene
with a `tx2gene` table that you construct manually (see `tximport` vignette for
example code). Just specify the arguments,
`skipMeta=TRUE, txOut=FALSE, tx2gene=tx2gene`, when calling `tximeta` and it
will perform summarization to gene level as in `tximport`.

We now demonstrate how to make a *linkedTxome* and how to share and load a
*linkedTxome*. We point to a *salmon* quantification file which was quantified
against a transcriptome that included the coding and non-coding *Drosophila
melanogaster* transcripts, as well as an artificial transcript of 960 bp (for
demonstration purposes only).

```{r}
dir <- system.file("extdata/salmon_dm", package="tximportData")
file <- file.path(dir, "SRR1197474.plus", "quant.sf")
file.exists(file)
coldata <- data.frame(files=file, names="SRR1197474", sample="1",
                      stringsAsFactors=FALSE)
```

Trying to import the files gives a message that `tximeta` couldn't find a
matching transcriptome, so it returns an non-ranged *SummarizedExperiment*.

```{r}
se <- tximeta(coldata)
```

# Linked transcriptomes {#linked-transcriptomes}

If the transcriptome used to generate the *salmon* index does not match any
transcriptomes from known sources (e.g. from combining or filtering known
transcriptome files), there is not much that can be done to automatically
populate the metadata during quantification import. However, we can facilitate
the following two cases:

1)  the transcriptome was created locally and has been linked to its public
    source(s)
2)  the transcriptome was produced by another group, and they have produced and
    shared a file that links the transcriptome to public source(s)

`tximeta` offers functionality to assist reproducible analysis in both of these
cases.

To make this quantification reproducible, we make a `linkedTxome` which records
key information about the sources of the transcript FASTA files, and the
location of the relevant GTF file. It also records the digest of the
transcriptome that was computed by *salmon* during the `index` step.

**Source:** when creating the `linkedTxome` one must specify the `source` of the
transcriptome. See `?linkedTxome` for a note on the implications of this text
string. For canonical GENCODE or Ensembl transcriptomes, one can use `"GENCODE"`
or `"Ensembl"`, but for modified or otherwise any transcriptomes defined by a
local database, it is recommended to use a different string, `"LocalGENCODE"` or
\`"LocalEnsembl", which will avoid *tximeta* pulling canonical GENCODE or
Ensembl resources from AnnotationHub.

**Multiple GTF/GFF files:** `linkedTxome` and `tximeta` do not currently support
multiple GTF/GFF files, which is a more complicated case than multiple FASTA,
which is supported. Currently, we recommend that users should add or combine
GTF/GFF files themselves to create a single GTF/GFF file that contains all
features used in quantification, and then upload such a file to *Zenodo*, which
can then be linked as shown below. Feel free to contact the developers on the
Bioconductor support site or GitHub Issue page for further details or feature
requests.

**Stringtie:** A special note for building on top of Stringtie-generated
transcripts: it is a good idea to change gene identifiers, to *not* include a
period `.`, as the period will later be used to separate transcript versions
from gene identifiers. This can be done before building the salmon index, by
changing periods in the gene identifier to an underscore. See [this GitHub
issue](https://github.com/thelovelab/tximeta/issues/68) for details.

By default, `linkedTxome` will write out a JSON file which can be shared with
others, linking the digest of the index with the other metadata, including FASTA
and GTF sources. By default, it will write out to a file with the same name as
the `indexDir`, but with a `.json` extension added. This can be prevented with
`write=FALSE`, and the file location can be changed with `jsonFile`.

First we specify the path where *salmon* index directory with `indexDir`, 
which will be used to look up the digest and associate it with the index.
Alternatively one can specify the `digest` itself and an `indexName`.

Typically you would not use `system.file` and `file.path` to locate this
directory, but simply define `indexDir` to be the path of the *salmon* directory
on your machine. Here we use `system.file` and `file.path` because we have
included parts of a *salmon* index directory in the *tximeta* package itself for
demonstration of functionality in this vignette.

```{r}
indexDir <- file.path(dir, "Dm.BDGP6.22.98.plus_salmon-0.14.1")
```

Now we provide the location of the FASTA files and the GTF file for this
transcriptome.

**Note:** the basename for the GTF file is used as a unique identifier for the
cached versions of the *TxDb* and the transcript ranges, which are stored on the
user's behalf via *BiocFileCache*. This is not an issue, as GENCODE, Ensembl,
and RefSeq all provide GTF files which are uniquely identified by their
filename, e.g. `Drosophila_melanogaster.BDGP6.22.98.gtf.gz`.

The recommended usage of `tximeta` would be to specify a remote GTF source, as
seen in the commented-out line below:

```{r}
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz",
              "extra_transcript.fa.gz")
#gtfFTP <- "ftp://path/to/custom/Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz"
```

Instead of the above commented-out FTP location for the GTF file, we specify a
location within an R package. This step is just to avoid downloading from a
remote FTP during vignette building. This use of `file.path` to point to a file
in an R package is specific to this vignette and should not be used in a typical
workflow. The following GTF file is a modified version of the release 98 from
Ensembl, which includes description of a one transcript, one exon artificial
gene which was inserted into the transcriptome (for demonstration purposes
only).

```{r}
gtfPath <- file.path(dir,"Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz")
```

Finally, we create a *linkedTxome*. In this vignette, we point to a temporary
directory for the JSON file, but a more typical workflow would write the JSON
file to the same location as the *salmon* index by not specifying `jsonFile`.

`makeLinkedTxome` performs two operation: (1) it creates a new entry in an
internal table that links the transcriptome used in the *salmon* index to its
sources, and (2) it creates a JSON file such that this *linkedTxome* can be
shared.

Here we can either specify `indexDir` or alternatively, the `digest` itself and
an `indexName`.

```{r}
tmp <- tempdir() # just for vignette demo, make temp directory
jsonFile <- file.path(tmp, paste0(basename(indexDir), ".json"))
makeLinkedTxome(indexDir=indexDir,
                source="LocalEnsembl", organism="Drosophila melanogaster",
                release="98", genome="BDGP6.22",
                fasta=fastaFTP, gtf=gtfPath,
                jsonFile=jsonFile)
```

After running `makeLinkedTxome`, the connection between this *salmon* index (and
its digest) with the sources is saved for persistent usage. Note that because we
added a single transcript of 960bp to the FASTA file used for quantification,
`tximeta` could tell that this was not quantified against release 98 of the
Ensembl transcripts for *Drosophila melanogaster*. Only when the correct set of
transcripts were specified does `tximeta` recognize and import the correct
metadata.

With use of `tximeta` and a *linkedTxome*, the software figures out if the
remote GTF has been accessed and compiled into a *TxDb* before, and on future
calls, it will simply load the pre-computed metadata and transcript ranges.

Note the warning that 5 of the transcripts are missing from the GTF file and so
are dropped from the final output. This is a problem coming from the annotation
source, and not easily avoided by `tximeta`.

```{r}
se <- tximeta(coldata)
```

We can see that the appropriate metadata and transcript ranges are attached.

```{r}
rowRanges(se)
seqinfo(se)
```

# Clear *linkedTxomes*

The following code removes the entire table with information about the
*linkedTxomes*. This is just for demonstration, so that we can show how to load
a JSON file below.

**Note:** Running this code will clear any information about *linkedTxomes*.
Don't run this unless you really want to clear this table!

```{r}
library(BiocFileCache)
if (interactive()) {
  bfcloc <- getTximetaBFC()
} else {
  bfcloc <- tempdir()
}
bfc <- BiocFileCache(bfcloc)
bfcinfo(bfc)
# only run the next line if you want to remove your linkedTxome table!
bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
bfcinfo(bfc)
```

# Loading *linkedTxome* JSON files

If a collaborator or the Suppmentary Files for a publication shares a
`linkedTxome` JSON file, we can likewise use `tximeta` to automatically assemble
the relevant metadata and transcript ranges. This implies that the other person
has used `tximeta` with the function `makeLinkedTxome` demonstrated above,
pointing to their *salmon* index and to the FASTA and GTF source(s).

We point to the JSON file and use `loadLinkedTxome` and then the relevant
metadata is saved for persistent usage. In this case, we saved the JSON file in
a temporary directory.

```{r}
jsonFile <- file.path(tmp, paste0(basename(indexDir), ".json"))
loadLinkedTxome(jsonFile)
```

Again, using `tximeta` figures out whether it needs to access the remote GTF or
not, and assembles the appropriate object on the user's behalf.

```{r}
se <- tximeta(coldata)
```

# Clear *linkedTxomes* again

Finally, we clear the *linkedTxomes* table again so that the above examples will
work. This is just for the vignette code and not part of a typical workflow.

**Note:** Running this code will clear any information about *linkedTxomes*.
Don't run this unless you really want to clear this table!

```{r}
if (interactive()) {
  bfcloc <- getTximetaBFC()
} else {
  bfcloc <- tempdir()
}
bfc <- BiocFileCache(bfcloc)
bfcinfo(bfc)
# only run the next line if you want to remove your linkedTxome table!
bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)
bfcinfo(bfc)
```

# alevin details

For *alevin* quantification, one should point to the `quants_mat.gz` file that
contains the counts for all of the cells. In order to `tximeta()` to work with
*alevin* quantification, it requires that *alevin* was run using gene IDs in the
`tgMap` step and not gene symbols.

# Other quantifiers {#other-quantifiers}

`tximeta` can import the output from any quantifiers that are supported by
`tximport`, and if these are not *salmon*, *alevin*, or *Sailfish* output, it
will simply return a non-ranged *SummarizedExperiment* by default.

An alternative solution is to wrap other quantifiers in workflows that include
metadata information JSON files along with each quantification file. One can
place these files in `aux_info/meta_info.json` or any relative location
specified by `customMetaInfo`, for example `customMetaInfo="meta_info.json"`.
This JSON file is located relative to the quantification file and should contain
a tag `index_seq_hash` with an associated value of the SHA-256 hash (digest) of
the reference transcripts. For computing the hash value of the reference
transcripts, see the [FastaDigest](https://github.com/COMBINE-lab/FastaDigest)
python package. The hash value used by *salmon* is the SHA-256 hash value of the
reference sequences stripped of the header lines, and concatenated together with
the empty string (so only cDNA sequences combined without any new line
characters). *FastaDigest* can be installed with `pip install fasta_digest`.

# Acknowledgments

The development of *tximeta* has benefited from suggestions from these and other
individuals in the community:

-   Vincent Carey (hashing concept)
-   Lori Shepherd (package development, *BiocFileCache*)
-   Martin Morgan (package development)
-   Koen Van den Berge 
-   Johannes Rainer (integration with *ensembldb*)
-   James Ashmore
-   Ben Johnson
-   Tim Triche
-   Kristoffer Vitting-Seerup
-   Gordon Smyth and Pedro Baldoni (*edgeR* and *limma* functions and docs)

# Session info

```{r}
library(devtools)
session_info()
```

# References

# Our Pledge

In the interest of fostering an open and welcoming environment, we as
contributors and maintainers pledge to make participation in our
project and our community a harassment-free experience for everyone,
regardless of age, body size, disability, ethnicity, sex
characteristics, gender identity and expression, level of experience,
education, socio-economic status, nationality, personal appearance,
race, religion, or sexual identity and orientation. 

# Our Standards

Examples of behavior that contributes to creating a positive
environment include: 

* Using welcoming and inclusive language
* Being respectful of differing viewpoints and experiences
* Gracefully accepting constructive criticism
* Focusing on what is best for the community
* Showing empathy towards other community members

Examples of unacceptable behavior by participants include:

* The use of sexualized language or imagery and unwelcome sexual
  attention or advances 
* Trolling, insulting/derogatory comments, and personal or political
  attacks 
* Public or private harassment
* Publishing others’ private information, such as a physical or
  electronic address, without explicit permission 
* Other conduct which could reasonably be considered inappropriate in
  a professional setting 

# Our Responsibilities

Project maintainers are responsible for clarifying the standards of
acceptable behavior and are expected to take appropriate and fair
corrective action in response to any instances of unacceptable
behavior. 

Project maintainers have the right and responsibility to remove, edit,
or reject comments, commits, code, wiki edits, issues, and other
contributions that are not aligned to this Code of Conduct, or to ban
temporarily or permanently any contributor for other behaviors that
they deem inappropriate, threatening, offensive, or harmful. 

# Scope

This Code of Conduct applies within all project spaces, and it also
applies when an individual is representing the project or its
community in public spaces. Examples of representing a project or
community include using an official project e-mail address, posting
via an official social media account, or acting as an appointed
representative at an online or offline event. Representation of a
project may be further defined and clarified by project maintainers. 

# Enforcement

Instances of abusive, harassing, or otherwise unacceptable behavior
may be reported by contacting any of the authors of this package. If
you are uncomfortable reporting to the package authors, incidents can
also be reported to members of the Bioconductor Project core team.

All complaints will be reviewed and investigated and will
result in a response that is deemed necessary and appropriate to the
circumstances. The project team is obligated to maintain
confidentiality with regard to the reporter of an incident. Further
details of specific enforcement policies may be posted separately. 

Project maintainers who do not follow or enforce the Code of Conduct
in good faith may face temporary or permanent repercussions as
determined by other members of the project’s leadership. 
 
# Attribution

This Code of Conduct is adapted from the Contributor Covenant, version
1.4, available at
<https://www.contributor-covenant.org/version/1/4/code-of-conduct.html>

For answers to common questions about this code of conduct, see
<https://www.contributor-covenant.org/faq>

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tximeta.R
\name{tximeta}
\alias{tximeta}
\title{tximeta: Transcript quantification import with automatic metadata}
\usage{
tximeta(
  coldata,
  type = "salmon",
  txOut = TRUE,
  skipMeta = FALSE,
  skipSeqinfo = FALSE,
  useHub = TRUE,
  markDuplicateTxps = FALSE,
  cleanDuplicateTxps = FALSE,
  customMetaInfo = NULL,
  ...
)
}
\arguments{
\item{coldata}{a data.frame with at least two columns (others will propogate to object):
\itemize{
\item{\code{files} - character, paths of quantification files}
\item{\code{names} - character, sample names}
}
if \code{coldata} is a vector, it is assumed to be the paths of quantification files
and unique sample names are created}

\item{type}{what quantifier was used (see \code{\link{tximport}})}

\item{txOut}{whether to output transcript-level data.
\code{tximeta} is designed to have transcript-level output
with Salmon, so default is \code{TRUE},
and it's recommended to use \code{\link{summarizeToGene}}
following \code{tximeta} for gene-level summarization.
For an alevin file, \code{tximeta} will import the
gene level counts ignoring this argument (alevin
produces only gene-level quantification).}

\item{skipMeta}{whether to skip metadata generation
(e.g. to avoid errors if not connected to internet).
This calls \code{tximport} directly and so either
\code{txOut=TRUE} or \code{tx2gene} should be specified.}

\item{skipSeqinfo}{whether to skip the addition of Seqinfo,
which requires an internet connection to download the
relevant chromosome information table from UCSC}

\item{useHub}{whether to first attempt to download a TxDb/EnsDb
object from AnnotationHub, rather than creating from a
GTF file from FTP (default is TRUE). If FALSE, it will
force \code{tximeta} to download and parse the GTF}

\item{markDuplicateTxps}{whether to mark the status
(\code{hasDuplicate}) and names of duplicate transcripts
(\code{duplicates}) in the rowData of the SummarizedExperiment output.
Subsequent summarization to gene level will keep track
of the number of transcripts sets per gene (\code{numDupSets})}

\item{cleanDuplicateTxps}{whether to try to clean
duplicate transcripts (exact sequence duplicates) by replacing
the transcript names that do not appear in the GTF
with those that do appear in the GTF}

\item{customMetaInfo}{the relative path to a custom metadata
information JSON file, relative to the paths in \code{files} of
\code{coldata}. For example, \code{customMetaInfo="meta_info.json"}
would indicate that in the same directory as the quantification
files in \code{files}, there are custom metadata information
JSON files. These should contain the SHA-256 hash of the
reference transcripts with the \code{index_seq_hash} tag
(see details in vignette).}

\item{...}{arguments passed to \code{tximport}}
}
\value{
a SummarizedExperiment with metadata on the \code{rowRanges}.
(if the hashed checksum in the Salmon or Sailfish index does not match
any known transcriptomes, or any locally saved \code{linkedTxome},
\code{tximeta} will just return a non-ranged SummarizedExperiment)
}
\description{
\code{tximeta} leverages the hashed checksum of the Salmon index,
in addition to a number of core Bioconductor packages (GenomicFeatures,
ensembldb, AnnotationHub, GenomeInfoDb, BiocFileCache) to automatically
populate metadata for the user, without additional effort from the user.
Note that \code{tximeta} requires that the entire output directory of Salmon
or alevin is present and unmodified in order to identify the provenance of the
reference transcripts.
}
\details{
Most of the code in \code{tximeta} works to add metadata and transcript ranges
when the quantification was performed with Salmon. However,
\code{tximeta} can be used with any quantification \code{type} that is supported
by \code{\link{tximport}}, where it will return an non-ranged SummarizedExperiment.

\code{tximeta} performs a lookup of the hashed checksum of the index
(stored in an auxilary information directory of the Salmon output)
against a database of known transcriptomes, which lives within the tximeta
package and is continually updated on Bioconductor's release schedule.
In addition, \code{tximeta} performs a lookup of the checksum against a
locally stored table of \code{linkedTxome}'s (see \code{link{makeLinkedTxome}}).
If \code{tximeta} detects a match, it will automatically populate,
e.g. the transcript locations, the transcriptome release,
the genome with correct chromosome lengths, etc. It allows for automatic
and correct summarization of transcript-level quantifications to the gene-level
via \code{\link{summarizeToGene}} without the need to manually build
a \code{tx2gene} table.

\code{tximeta} on the first run will ask where the BiocFileCache for
this package should be kept, either using a default location or a temporary
directory. At any point, the user can specify a location using
\code{\link{setTximetaBFC}} and this choice will be saved for future sessions.
Multiple users can point to the same BiocFileCache, such that
transcript databases (TxDb or EnsDb) associated with certain Salmon indices
and \code{linkedTxomes} can be accessed by different users without additional
effort or time spent downloading and building the relevant TxDb / EnsDb.
Note that, if the TxDb or EnsDb is present in AnnotationHub, \code{tximeta} will
use this object instead of downloading and building a TxDb/EnsDb from GTF
(to disable this set useHub=FALSE).

In order to allow that multiple users can read and write to the
same location, one should set the BiocFileCache directory to
have group write permissions (g+w).
}
\examples{

# point to a Salmon quantification file:
dir <- system.file("extdata/salmon_dm", package="tximportData")
files <- file.path(dir, "SRR1197474", "quant.sf") 
coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)

# normally we would just run the following which would download the appropriate metadata
# se <- tximeta(coldata)

# for this example, we instead point to a local path where the GTF can be found
# by making a linkedTxome:
indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
                release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)
se <- tximeta(coldata)

# to clear the entire linkedTxome table
# (don't run unless you want to clear this table!)
# bfcloc <- getTximetaBFC()
# bfc <- BiocFileCache(bfcloc)
# bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tximeta.R
\name{tximeta}
\alias{tximeta}
\title{Import transcript quantification with metadata}
\usage{
tximeta(
  coldata,
  type = NULL,
  txOut = TRUE,
  skipMeta = FALSE,
  skipSeqinfo = FALSE,
  useHub = TRUE,
  markDuplicateTxps = FALSE,
  cleanDuplicateTxps = FALSE,
  customMetaInfo = NULL,
  skipFtp = FALSE,
  gencode_gtf_prefix = NULL,
  ...
)
}
\arguments{
\item{coldata}{a data.frame with at least two columns (others will propogate to object):
\itemize{
\item \code{files} - character, paths of quantification files
\item \code{names} - character, sample names
if \code{coldata} is a vector, it is assumed to be the paths of quantification files
and unique sample names are created
}}

\item{type}{what quantifier was used, see \code{\link[tximport:tximport]{tximport::tximport()}}}

\item{txOut}{whether to output transcript-level data.
\code{tximeta} is designed to have transcript-level output
with salmon, so default is \code{TRUE},
and it's recommended to use \code{summarizeToGene}
following \code{tximeta} for gene-level summarization.
For an alevin file, \code{tximeta} will import the
gene level counts ignoring this argument (alevin
produces only gene-level quantification).}

\item{skipMeta}{whether to skip metadata generation
(e.g. to avoid errors if not connected to internet).
This calls \code{tximport} directly and so either
\code{txOut=TRUE} or \code{tx2gene} should be specified.}

\item{skipSeqinfo}{whether to skip the addition of Seqinfo,
which requires an internet connection to download the
relevant chromosome information table from UCSC}

\item{useHub}{whether to first attempt to download a TxDb/EnsDb
object from AnnotationHub, rather than creating from a
GTF file from FTP (default is TRUE). If FALSE, it will
force \code{tximeta} to download and parse the GTF}

\item{markDuplicateTxps}{whether to mark the status
(\code{hasDuplicate}) and names of duplicate transcripts
(\code{duplicates}) in the rowData of the SummarizedExperiment output.
Subsequent summarization to gene level will keep track
of the number of transcripts sets per gene (\code{numDupSets}).
see Details}

\item{cleanDuplicateTxps}{whether to "clean"
duplicate transcripts (exact sequence duplicates) by
replacing, when possible, transcript names that do not
appear in the GTF with those that do appear in the GTF.
see Details}

\item{customMetaInfo}{the relative path to a custom metadata
information JSON file, relative to the paths in \code{files} of
\code{coldata}. For example, \code{customMetaInfo="meta_info.json"}
would indicate that in the same directory as the quantification
files in \code{files}, there are custom metadata information
JSON files. These should contain the SHA-256 hash of the
reference transcripts with the \code{index_seq_hash} tag
(see details in vignette).}

\item{skipFtp}{whether to avoid \verb{ftp://} in case of
firewall, default is FALSE}

\item{gencode_gtf_prefix}{for GENCODE transcriptomes, optionally specify
a non-default GTF file by providing the prefix that appears between
\code{gencode.vXX.} and \code{.annotation.gtf.gz} in the GENCODE FTP filename.
For example, \code{"primary_assembly"}, \code{"basic"}, \code{"chr_patch_hapl_scaff"},
\code{"primary_assembly.basic"}, \code{"chr_patch_hapl_scaff.basic"}.
Has no effect for non-GENCODE transcriptomes.}

\item{...}{arguments passed to \code{tximport}}
}
\value{
a SummarizedExperiment with metadata on the \code{rowRanges}.
(if the hashed digest in the salmon or Sailfish index does not match
any known transcriptomes, or any locally saved \code{linkedTxome},
\code{tximeta} will just return a non-ranged SummarizedExperiment)
}
\description{
\code{tximeta} leverages the digest of the reference transcripts that were indexed
in order to identify metadata from the output of quantification tools.
A computed digest (a hash value) can be used to uniquely identify the collection
of reference sequences, and associate the dataset with other useful metadata.
After identification, tximeta uses a number of core Bioconductor packages (GenomicFeatures,
ensembldb, AnnotationHub, Seqinfo, BiocFileCache) to automatically
populate metadata for the user.
}
\details{
Most of the code in tximeta works to add metadata and transcript ranges
when the quantification was performed with salmon or related tools. However,
tximeta can be used with any quantification type that is supported
by \code{\link[tximport:tximport]{tximport::tximport()}}, where it will return an non-ranged SummarizedExperiment.
For other quantification tools see also the \code{customMetaInfo} argument below.
This behavior can also be triggered with \code{skipMeta=TRUE}.

tximeta performs a lookup of the digest (or hash value) of the index
stored in an auxilary information directory of the quantification tool's output
against a database of known transcriptomes, which is stored within the tximeta
package (\code{extdata/hashtable.csv}) and is continually updated to match Ensembl
and GENCODE releases, with updates pushed to Bioconductor current release branch.
In addition, tximeta performs a lookup of the digest against a
locally stored table of linkedTxome references, see \code{\link[=makeLinkedTxome]{makeLinkedTxome()}}.
If tximeta detects a match in either source, it will automatically populate
the transcript locations, the transcriptome release,
the genome with correct chromosome lengths, and connect the SE object to locally
cached derived metadata. tximeta also facilitates automatic summarization of
transcript-level quantifications to the gene-level via \verb{summarizeToGene`` without the need to  manually build the correct }tx2gene` table for the reference used for indexing.

tximeta on the first run will ask where the \code{\link[BiocFileCache:BiocFileCache]{BiocFileCache::BiocFileCache()}}
location for this package (\emph{tximeta}) should be kept, either using a default location or a temporary
directory. At any point, the user can specify a location using
\code{\link[=setTximetaBFC]{setTximetaBFC()}} and this choice will be saved for future sessions.
Multiple users can point to the same BiocFileCache, such that
transcript databases (TxDb or EnsDb) associated with certain salmon indices
and linkedTxomes can be accessed by different users without additional
effort or time spent downloading and building the relevant TxDb / EnsDb.
In order to allow that multiple users can read and write to the
same location, one should set the BiocFileCache directory to
have group write permissions (g+w).
Note that, if the TxDb or EnsDb is present in AnnotationHub, tximeta will
use this object instead of downloading and building a TxDb/EnsDb from GTF
(to disable this set \code{useHub=FALSE}).

Regarding \code{markDuplicateTxps} and \code{cleanDuplicateTxps}: these functions
may be used when salmon has been run in default mode (where it reduces
exact sequence duplicates in the index by replacing them with a single
representative). These won't make sense (and the latter will give an error)
when \code{--keepDuplicates} has been used by salmon during indexing.
They help by either adding metadata ("marking") regarding transcript
duplicates to the rowData, or changing names of transcripts ("cleaning")
where possible to provide better alignment with GTF.
}
\examples{

# point to a salmon quantification file:
dir <- system.file("extdata/salmon_dm", package="tximportData")
files <- file.path(dir, "SRR1197474", "quant.sf") 
coldata <- data.frame(files, names="SRR1197474", condition="A", stringsAsFactors=FALSE)

# normally we would just run the following which would download the appropriate metadata
# se <- tximeta(coldata)

# for this example, we instead point to a local path where the GTF can be found
# by making a linkedTxome:
indexDir <- file.path(dir, "Dm.BDGP6.22.98_salmon-0.14.1")
dmFTP <- "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/"
fastaFTP <- paste0(
  dmFTP,
  c("cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
    "ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")
)
gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.gtf.gz")
makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
                release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)
se <- tximeta(coldata)

# to clear the entire linkedTxome table
# (don't run unless you want to clear this table!)
# bfcloc <- getTximetaBFC()
# bfc <- BiocFileCache(bfcloc)
# bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addIds.R
\name{addIds}
\alias{addIds}
\title{Add IDs to rowRanges of a SummarizedExperiment}
\usage{
addIds(se, column, fromDb = FALSE, gene = FALSE, ...)
}
\arguments{
\item{se}{the SummarizedExperiment}

\item{column}{the name of the new ID to add (a \code{column} of the org package
database or of the TxDb/EnsDb is \code{fromDb=TRUE})}

\item{fromDb}{logical, whether to use the TxDb/EnsDb that is associated
with \code{se}. Default is FALSE, and an org package is used.
Currently only implemented for transcript level (gene=FALSE).
Column names can be viewed with \code{columns(retrieveDb(se))}}

\item{gene}{logical, whether to map by genes or transcripts (default is FALSE).
if rows are genes, and easily detected as such (ENSG or ENSMUSG), it will
automatically switch to TRUE. if rows are transcripts and \code{gene=TRUE},
then it will try to use a \code{gene_id} column to map IDs to \code{column}}

\item{...}{arguments passed to \code{mapIds}}
}
\value{
a SummarizedExperiment
}
\description{
For now this function just works with SummarizedExperiments
with Ensembl gene or transcript IDs. See example
of usage in tximeta vignette. For obtaining
multiple matching IDs for each row of the SummarizedExperiment
set \code{multiVals="list"}. See \code{select} for documentation
on use of \code{multiVals}.
}
\examples{

example(tximeta)
library(org.Dm.eg.db)	
se <- addIds(se, "REFSEQ", gene=FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mixed_reference.R
\name{inspectDigests}
\alias{inspectDigests}
\title{Inspect digest matches from \code{importData()} imported data}
\usage{
inspectDigests(
  se,
  type = "oarfish",
  prefer = c("txome", "txpdata", "precomputed"),
  fullDigest = FALSE,
  count = FALSE
)
}
\arguments{
\item{se}{the \emph{SummarizedExperiment} output by \code{importData()},
or alternatively just
\code{metadata(se)$quantInfo}, a list of metadata
information from the quantification tool
(assuming \code{annotated} and \code{novel} indices both used)}

\item{type}{what quantifier was used (see \code{\link[tximport:tximport]{tximport::tximport()}})}

\item{prefer}{vector of length up to 3, giving the preferred order of
\emph{tximeta}'s transcript registries to when finding matches, with elements:
\code{txome}: linkedTxome,
\code{txpdata}: linkedTxpData,
\code{precomputed}: the pre-computed digests in tximeta}

\item{fullDigest}{whether to include the full digest string in the output,
in addition to the shortened 6-char version}

\item{count}{whether to count the number of matching transcripts ID to each index
(only possible for those indices that have matching metadata).
Counting requires loading transcript data, either from locally cached databases
or from GTF files.}
}
\value{
a 2-row tibble of the \code{annotated} and \code{novel} index,
their matching information if available
(source, organism, release), for matches,
whether it is a \code{linkedTxome} or a \code{linkedTxpData}
(both `FALSE`` for pre-computed)
and a small 6 character version of the digest itself.
}
\description{
This function takes as input a \emph{SummarizedExperiment} as output by \code{importData()}
and returns a tibble with information about the digest-match status of two
indices (\code{annotated} and \code{novel}), with respect to \emph{tximeta} metadata.
Inspection of index digests can be run iteratively, checking if
the digests used in the mixed reference transcript set
have a match against 1) pre-computed digests representing
standard annotated sets (e.g. GENCODE, Ensembl, etc.)
or 2) digests added by the user to a local registry with
\code{makeLinkedTxome()} (GTF file)
or \code{makeLinkedTxpData} (\emph{GRanges}-based metadata).
Optional columns may be added if specified by
\code{fullDigest=TRUE} (include the full digest) and/or
\code{count=TRUE} (add matching transcript ID counts per index).
Following inspection, one can run \code{updateMetadata()} to automatically update
the transcript metadata using the sources indicated by this function.
}
\examples{

example(importData)
# now we have an `se` created by importData()...
inspectDigests(se)
# can then update the registry via makeLinkedTxome() and re-run inspection

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/linkedTxome.R
\name{linkedTxome}
\alias{linkedTxome}
\alias{makeLinkedTxome}
\alias{loadLinkedTxome}
\title{Make and load linked transcriptomes ("linkedTxome")}
\usage{
makeLinkedTxome(
  indexDir,
  source,
  organism,
  release,
  genome,
  fasta,
  gtf,
  write = TRUE,
  jsonFile
)

loadLinkedTxome(jsonFile)
}
\arguments{
\item{indexDir}{the local path to the Salmon index}

\item{source}{the source of transcriptome (e.g. "de-novo").
Note: if you specify "GENCODE" or "Ensembl", this will trigger
behavior by tximeta that may not be desired: e.g. attempts to
download canonical transcriptome data from AnnotationHub
(unless useHub=FALSE when running tximeta) and parsing of
Ensembl GTF using ensembldb (which may fail if the GTF file
has been modified). For transcriptomes that are defined by
local GTF files, it is recommended to use the terms "LocalGENCODE"
or "LocalEnsembl". Setting "LocalEnsembl" will also strip
version numbers from the FASTA transcript IDs to enable matching
with the Ensembl GTF.}

\item{organism}{organism (e.g. "Homo sapiens")}

\item{release}{release number (e.g. "27")}

\item{genome}{genome (e.g. "GRCh38", or "none")}

\item{fasta}{location(s) for the FASTA transcript sequences
(of which the transcripts used to build the index is equal or a subset).
This can be a local path, or an HTTP or FTP URL}

\item{gtf}{location for the GTF/GFF file
(of which the transcripts used to build the index is equal or a subset).
This can be a local path, or an HTTP or FTP URL
While the \code{fasta} argument can take a vector of length greater than one
(more than one FASTA file containing transcripts used in indexing),
the \code{gtf} argument has to be a single GTF/GFF file.
This can also be a serialized GRanges object (location of a .rds file)
imported with rtracklayer.
If transcripts were added to a standard set of reference transcripts (e.g. fusion genes,
or pathogen transcripts), it is recommended that the tximeta user would manually
add these to the GTF/GFF file, and post the modified GTF/GFF publicly, such as
on Zenodo. This enables consistent annotation and downstream annotation
tasks, such as by \code{summarizeToGene}.}

\item{write}{logical, should a JSON file be written out
which documents the transcriptome checksum and metadata? (default is TRUE)}

\item{jsonFile}{the path to the json file for the linkedTxome}
}
\value{
nothing, the function is run for its side effects
}
\description{
\code{makeLinkedTxome} reads the checksum associated with a Salmon
index at \code{indexDir}, and links it to key information
about the transcriptome, including the \code{source}, \code{organism},
\code{release}, and \code{genome} (these are custom character strings),
as well as the locations (e.g. local, HTTP, or FTP) for one or more \code{fasta}
files and one \code{gtf} file. \code{loadLinkedTxome} loads this
information from a JSON file. See Details.
}
\details{
\code{makeLinkedTxome} links the information about the transcriptome
used for quantification in two ways:
1) the function will store a record in tximeta's cache such that
future import of quantification data will automatically access and
parse the GTF as if the transcriptome were one of those automatically
detected by tximeta. Then all features of tximeta (e.g. summarization
to gene, programmatic adding of IDs or metadata) will be available;
2) it will by default write out a JSON file
that can be shared, or posted online, and which can be read by
\code{loadLinkedTxome} which will store the information in tximeta's
cache. This should make the full quantification-import pipeline
computationally reproducible / auditable even for transcriptomes
which differ from those provided by references (GENCODE, Ensembl,
RefSeq).

For further details please see the "Linked transcriptomes"
section of the tximeta vignette.
}
\examples{

# point to a Salmon quantification file with an additional artificial transcript
dir <- system.file("extdata/salmon_dm", package="tximportData")
file <- file.path(dir, "SRR1197474.plus", "quant.sf")
coldata <- data.frame(files=file, names="SRR1197474", sample="1",
                      stringsAsFactors=FALSE)

# now point to the Salmon index itself to create a linkedTxome
# as the index will not match a known txome
indexDir <- file.path(dir, "Dm.BDGP6.22.98.plus_salmon-0.14.1")

# point to the source FASTA and GTF:
fastaFTP <- c("ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
              "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz",
              "extra_transcript.fa.gz")
gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz")

# now create a linkedTxome, linking the Salmon index to its FASTA and GTF sources
makeLinkedTxome(indexDir=indexDir, source="Ensembl", organism="Drosophila melanogaster",
                release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)

# to clear the entire linkedTxome table
# (don't run unless you want to clear this table!)
# bfcloc <- getTximetaBFC()
# bfc <- BiocFileCache(bfcloc)
# bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/linkedTxome.R
\name{linkedTxome}
\alias{linkedTxome}
\alias{makeLinkedTxome}
\alias{loadLinkedTxome}
\title{Make and load linked transcriptomes (linked GTF and FASTA)}
\usage{
makeLinkedTxome(
  digest = NULL,
  indexName,
  indexDir = NULL,
  source,
  organism,
  release,
  genome,
  fasta,
  gtf,
  write = TRUE,
  jsonFile
)

loadLinkedTxome(jsonFile)
}
\arguments{
\item{digest}{the full digest as character string,
(this or \code{indexDir} is required, only one should be specified)}

\item{indexName}{a name for the \code{index} when storing the linkedTxome,
required if providing the \code{digest} string, suggest using the
basename of the FASTA file and the software used,
e.g. "gencode.vXX_salmon-0.XX.Y"}

\item{indexDir}{the local path to the salmon index
(this or \code{digest} is required, only one should be specified)}

\item{source}{the source of transcriptome (e.g. "de-novo").
Note: if you specify "GENCODE" or "Ensembl", this will trigger
behavior by tximeta that may not be desired: e.g. attempts to
download canonical transcriptome data from AnnotationHub
(unless useHub=FALSE when running tximeta) and parsing of
Ensembl GTF using ensembldb (which may fail if the GTF file
has been modified). For transcriptomes that are defined by
local GTF files, it is recommended to use the terms "LocalGENCODE"
or "LocalEnsembl". Setting "LocalEnsembl" will also strip
version numbers from the FASTA transcript IDs to enable matching
with the Ensembl GTF.}

\item{organism}{organism (e.g. "Homo sapiens")}

\item{release}{release number (e.g. "27")}

\item{genome}{genome (e.g. "GRCh38", or "none")}

\item{fasta}{location(s) for the FASTA transcript sequences
(of which the transcripts used to build the index is equal or a subset).
This can be a local path, or an HTTP or FTP URL}

\item{gtf}{location for the GTF/GFF file
(of which the transcripts used to build the index is equal or a subset).
This can be a local path, or an HTTP or FTP URL
While the \code{fasta} argument can take a vector of length greater than one
(more than one FASTA file containing transcripts used in indexing),
the \code{gtf} argument has to be a single GTF/GFF file.
This can also be a serialized GRanges object (location of a .rds file)
imported with rtracklayer.
If transcripts were added to a standard set of reference transcripts (e.g. fusion genes,
or pathogen transcripts), it is recommended that the tximeta user would manually
add these to the GTF/GFF file, and post the modified GTF/GFF publicly, such as
on Zenodo. This enables consistent annotation and downstream annotation
tasks, such as by
\code{\link[=summarizeToGene,SummarizedExperiment-method]{summarizeToGene()}}.}

\item{write}{logical, should a JSON file be written out
which documents the transcriptome digest and metadata? (default is TRUE)}

\item{jsonFile}{the path to the json file for the linkedTxome}
}
\value{
nothing, the function is run for its side effects
}
\description{
\code{makeLinkedTxome()} reads the digest associated with a salmon
index at \code{indexDir}, and persistently links it to metadata
(alternatively the \code{digest} string itself and an
\code{indexName} can be provided).
Linked metadata includes key information
about the transcriptome, including the \code{source}, \code{organism},
\code{release}, and \code{genome} (these are custom character strings),
as well as the locations (e.g. local, HTTP, or FTP) for one or more \code{fasta}
files and one \code{gtf} file. \code{loadLinkedTxome()} loads this
information from a JSON file. See \emph{Details}.
}
\details{
\code{makeLinkedTxome()} links the information about the transcriptome
used for quantification in two ways:
\enumerate{
\item the function will store a record in tximeta's cache such that
future import of quantification data will automatically access and
parse the GTF as if the transcriptome were one of those automatically
detected by tximeta. Then all features of tximeta (e.g. summarization
to gene, programmatic adding of IDs or metadata) will be available;
\item it will by default write out a JSON file
that can be shared, or posted online, and which can be read by
\code{loadLinkedTxome()} which will store the information in tximeta's
cache. This should make the full quantification-import pipeline
computationally reproducible / auditable even for transcriptomes
which differ from those provided by references (GENCODE, Ensembl,
RefSeq).
}

For further details please see the "Linked transcriptomes"
section of the tximeta vignette.

This function can be used in combination with \code{inspectDigests()}
and oarfish data from \code{importData()}, when multiple
reference transcript sets have been indexed. See also
\code{makeLinkedTxpData()}.
}
\examples{

# point to a salmon quantification file with an additional artificial transcript
dir <- system.file("extdata/salmon_dm", package="tximportData")
file <- file.path(dir, "SRR1197474.plus", "quant.sf")
coldata <- data.frame(files=file, names="SRR1197474", sample="1",
                      stringsAsFactors=FALSE)

# now point to the salmon index itself to create a linkedTxome
# as the index will not match a known txome
indexDir <- file.path(dir, "Dm.BDGP6.22.98.plus_salmon-0.14.1")

# point to the source FASTA and GTF:
baseFTP <- "ftp://ftp.ensembl.org/pub/release-98/fasta/drosophila_melanogaster/"
fastaFTP <- c(
  paste0(baseFTP,
    c("cdna/Drosophila_melanogaster.BDGP6.22.cdna.all.fa.gz",
      "ncrna/Drosophila_melanogaster.BDGP6.22.ncrna.fa.gz")),
  "extra_transcript.fa.gz"
)
gtfPath <- file.path(dir, "Drosophila_melanogaster.BDGP6.22.98.plus.gtf.gz")

# now create a linkedTxome, linking the salmon index to its FASTA and GTF sources
makeLinkedTxome(indexDir=indexDir, source="LocalEnsembl", organism="Drosophila melanogaster",
                release="98", genome="BDGP6.22", fasta=fastaFTP, gtf=gtfPath, write=FALSE)

# to clear the entire linkedTxome table
# (don't run unless you want to clear this table!)
# bfcloc <- getTximetaBFC()
# bfc <- BiocFileCache(bfcloc)
# bfcremove(bfc, bfcquery(bfc, "linkedTxomeTbl")$rid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarizeToGene.R
\docType{methods}
\name{summarizeToGene,SummarizedExperiment-method}
\alias{summarizeToGene,SummarizedExperiment-method}
\title{Summarize estimated quantitites to gene-level}
\usage{
\S4method{summarizeToGene}{SummarizedExperiment}(object, varReduce = FALSE, ...)
}
\arguments{
\item{object}{a SummarizedExperiment produced by \code{tximeta}}

\item{varReduce}{whether to reduce per-sample inferential replicates
information into a matrix of sample variances \code{variance} (default FALSE)}

\item{...}{arguments passed to \code{tximport}}
}
\value{
a SummarizedExperiment with summarized quantifications
and transcript IDs as a CharacterList in the \code{mcols}
}
\description{
Summarizes abundances, counts, lengths, (and inferential
replicates or variance) from transcript- to gene-level.
Transcript IDs are stored as a CharacterList in the \code{mcols}
of the output object.
This function operates on SummarizedExperiment objects, and
will automatically access the relevant TxDb (by either finding it
in the BiocFileCache or by building it from an ftp location).
This function uses the tximport package to perform summarization,
where a method is defined that works on simple lists.
}
\examples{

example(tximeta)
gse <- summarizeToGene(se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mixed_reference.R
\name{updateMetadata}
\alias{updateMetadata}
\title{Update transcript metadatda for \code{importData()} imported data}
\usage{
updateMetadata(
  se,
  txpData = NULL,
  ranges = FALSE,
  prefer = c("txome", "txpdata", "precomputed"),
  order = c("annotated", "novel", "user"),
  key = c(annotated = "tx_name", novel = "tx_name", user = "tx_name")
)
}
\arguments{
\item{se}{the \emph{SummarizedExperiment} (SE) output by \code{importData()}}

\item{txpData}{either \emph{GRanges} or \emph{data.frame}-type object
to use if there is not a match based on digest.
This is used on a one-time basis, and transcripts
will be marked in metadata columns as \verb{index = "user"``. See }makeLinkedTxome()\code{or}makeLinkedTxpData()` for persistent
metadata storage/retrieval}

\item{ranges}{logical, whether to add \code{rowRanges} (or just \code{rowData})}

\item{prefer}{vector of length up to 3, giving the preferred order of
\emph{tximeta}'s transcript registries to when finding matches, with elements:
\code{txome}: linkedTxome,
\code{txpdata}: linkedTxpData,
\code{precomputed}: the pre-computed digests in tximeta}

\item{order}{order of index, in which to update the metadata, by default
the order is \code{annotation}, then \code{novel}, then \code{user}, info supplied
here as \code{txpData}}

\item{key}{a named character vector of length 3. For each index
(annotated, novel, and user) \code{key} is the name of the column to
use for merging metadata with \code{rownames(se)}.
The \code{user} index corresponds to data provided here as \code{txpData}
Defaults to \code{"tx_name"} which often matches the transcript
names in GENCODE}
}
\value{
a \emph{SummarizedExperiment} with new \code{rowData},
or a \emph{RangedSummarizedExperiment} with new metadata
}
\description{
This function takes as input a \emph{SummarizedExperiment} as output by \code{importData()},
and will update the metadata on the transcripts when possible
(updating \code{rowData} and/or \code{rowRanges} depending on the value of \code{ranges}).
\code{importData()} uses metadata pulled from digest matches in registries used by \emph{tximeta}
(\code{linkedTxome}, \code{linkedTxpData}, and the pre-computed digests).
Additionally, \emph{GRanges} or \emph{data.frame}-type data can be provided on a one-time basis
via the argument \code{txpData}, which will annotate transcripts with \code{index="user"}.
See \code{inspectDigests()} for how to inspect which indices have matching digests,
and how to link data to local metadata in a persistent manner.
}
\examples{

example(importData)

# build custom novel GRanges data
library(GenomicRanges)
novel <- data.frame(
  seqnames = paste0("chr", rep(1:22, each=500)),  
  start = 1e6 + 1 + 0:499 * 1000, end = 1e6 + 1 + 0:499 * 1000 + 1000 - 1,
  strand = "+", tx_name = paste0("novel", 1:(22*500)),
  gene_id = paste0("novel_gene", rep(1:(22*10), each=50)), type = "protein_coding"
)
novel_gr <- as(novel, "GRanges")
names(novel_gr) <- novel$tx_name

# now update the metadata + ranges:
\dontrun{
# this requires connection to internet (will download GENCODE GTF via FTP)
se_with_ranges <- updateMetadata(
  se, txpData=novel_gr, ranges=TRUE
)
mcols(se_with_ranges)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/retrievers.R
\name{retrieveCDNA}
\alias{retrieveCDNA}
\title{Retrieve the cDNA transcript sequence for a SummarizedExperiment}
\usage{
retrieveCDNA(se, quiet = FALSE)
}
\arguments{
\item{se}{the SummarizedExperiment}

\item{quiet}{logical, suppress messages}
}
\value{
a DNAStringSet object
}
\description{
This helper function retrieves the cDNA sequence of
the transcripts used for expression quantification.
This function either downloads or loads the transcript
sequence from cache, it does not re-order or check against
the rows of the SummarizedExperiment (which could be
already summarized to genes for example).
}
\examples{

\dontrun{
# this example is not run because it requires access to Ensembl ftp
example(tximeta)
cdna <- retrieveCDNA(se)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/retrievers.R
\name{retrieveCDNA}
\alias{retrieveCDNA}
\title{Retrieve the cDNA transcript sequence for a SummarizedExperiment}
\usage{
retrieveCDNA(se, quiet = FALSE)
}
\arguments{
\item{se}{the SummarizedExperiment}

\item{quiet}{logical, suppress messages}
}
\value{
a DNAStringSet object
}
\description{
This helper function retrieves the cDNA sequence of
the transcripts used for expression quantification.
This function either downloads or loads the transcript
sequence from cache, it does not re-order or check against
the rows of the SummarizedExperiment (which could be
already summarized to genes for example).
}
\examples{

example(tximeta)
cdna <- retrieveCDNA(se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarizeToGene.R
\docType{methods}
\name{summarizeToGene,SummarizedExperiment-method}
\alias{summarizeToGene,SummarizedExperiment-method}
\title{Summarize estimated quantitites to gene-level}
\usage{
\S4method{summarizeToGene}{SummarizedExperiment}(
  object,
  assignRanges = c("range", "abundant"),
  varReduce = FALSE,
  skipRanges = FALSE,
  ...
)
}
\arguments{
\item{object}{a SummarizedExperiment produced by \code{tximeta}}

\item{assignRanges}{\code{"range"} or \code{"abundant"}, this argument
controls the way that the \code{rowRanges} of the output object are assigned
(note that this argument does not affect data aggregation at all).
The default is to just output the entire \code{range} of the gene,
i.e. the leftmost basepair to the rightmost basepair across all isoforms.
Alternatively, for expressed genes, one can obtain the start and end
of the most \code{abundant} isoform (averaging over all samples).
Non-expressed genes will have \code{range}-based positions.
For \code{abundant}, for expressed genes,
the name of the range-assigned \code{isoform}, \code{max_prop}
(maximum isoform proportion), and \code{iso_prop} (numeric values for
isoform proportions) are also returned in \code{mcols}}

\item{varReduce}{whether to reduce per-sample inferential replicates
information into a matrix of sample variances \code{variance} (default FALSE)}

\item{skipRanges}{whether to skip making use of, or outputting, rowRanges
(default FALSE)}

\item{...}{arguments passed to \code{tximport}}
}
\value{
a SummarizedExperiment with summarized quantifications
and transcript IDs as a CharacterList in the \code{mcols}
}
\description{
Summarizes abundances, counts, lengths, (and inferential
replicates or variance) from transcript- to gene-level.
Transcript IDs are stored as a CharacterList in the \code{mcols}
of the output object.
This function operates on SummarizedExperiment objects, and
will automatically access the relevant TxDb (by either finding it
in the BiocFileCache or by building it from an ftp location).
This function uses the tximport package to perform summarization,
where a method is defined that works on simple lists.
}
\examples{

example(tximeta)
gse <- summarizeToGene(se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tximeta.R
\docType{package}
\name{tximeta-package}
\alias{tximeta-package}
\title{Import transcript-level quantification data with automatic metadata}
\description{
The tximeta package imports abundances (TPM), estimated counts,
and effective lengths from Salmon, alevin, or other quantification
tools, and will output a SummarizedExperiment object. For Salmon
and alevin quantification directories, \code{tximeta} will
try to identify the correct provenance of the reference transcripts
and automatically attach the transcript ranges to the
SummarizedExperiment, to facilitate downstream integration with
other datasets. The automatic identification of reference transcripts
should work out-of-the-box for human or mouse transcriptomes from
the sources: GENCODE, Ensembl, or RefSeq.
}
\details{
The main functions are:
\itemize{
\item \code{\link{tximeta}} - with key argument: \code{coldata}
\item \code{\link{summarizeToGene}} - summarize quants to gene-level
\item \code{\link{retrieveDb}} - retrieve the transcript database
\item \code{\link{addIds}} - add transcript or gene ID (see \code{gene} argument)
\item \code{\link{addExons}} - convert from GRanges to GRangesList
}

All software-related questions should be posted to the Bioconductor Support Site:

\url{https://support.bioconductor.org}

The code can be viewed at the GitHub repository,
which also lists the contributor code of conduct:

\url{https://github.com/mikelove/tximeta}
}
\references{
\strong{tximeta} reference:

Michael I. Love, Charlotte Soneson, Peter F. Hickey, Lisa K. Johnson
N. Tessa Pierce, Lori Shepherd, Martin Morgan, Rob Patro (2020)
Tximeta: reference sequence checksums for provenance identification
in RNA-seq. PLOS Computational Biology.
\url{https://doi.org/10.1371/journal.pcbi.1007664}

\strong{tximport} reference (the effective length offset and counts-from-abundance):

Charlotte Soneson, Michael I. Love, Mark D. Robinson (2015)
Differential analyses for RNA-seq: transcript-level estimates
improve gene-level inferences. F1000Research.
\url{http://doi.org/10.12688/f1000research.7563}
}
\author{
Michael I. Love, Charlotte Soneson, Peter Hickey, Rob Patro
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bfcLocation.R
\name{getTximetaBFC}
\alias{getTximetaBFC}
\alias{setTximetaBFC}
\title{Get or set the directory of the BiocFileCache used by tximeta}
\usage{
getTximetaBFC()

setTximetaBFC(dir, quiet = FALSE)
}
\arguments{
\item{dir}{the location for tximeta's BiocFileCache. can be missing
in which case the function will call \code{file.choose} for choosing
location interactively}

\item{quiet}{whether to suppress feedback message}
}
\value{
the directory of the BiocFileCache used by tximeta
(or nothing, in the case of \code{setTximetaBFC})
}
\description{
Running \code{getTximetaBFC} will report the saved directory,
if it has been determined, or will return NULL.
Running \code{setTximetaBFC} will ask the user to specify a
BiocFileCache directory for accessing and saving TxDb sqlite files.
Note that tximeta's BiocFileCache can be set by the environmental
variable \code{TXIMETA_HUB_CACHE}, which will reset the cache location.
}
\examples{

# getting the BiocFileCache used by tximeta
# (may not be set, which uses BiocFileCache default or temp directory)
getTximetaBFC()

# don't want to actually change user settings so this is not run:
# setTximetaBFC()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tximeta.R
\docType{package}
\name{tximeta-package}
\alias{tximeta-package}
\title{Import transcript quantification with metadata}
\description{
The tximeta package imports abundances (TPM), estimated counts,
and effective lengths from quantification tools,
and will output a \emph{SummarizedExperiment} (SE) object.
For salmon and related quantification tools, \code{\link[=tximeta]{tximeta()}} will
attempt to identify the correct provenance of the reference transcripts
and automatically attach the transcript ranges to the
SummarizedExperiment, to facilitate downstream integration with
other datasets. The automatic identification of reference transcripts
should work out-of-the-box for human or mouse transcriptomes from
the sources: GENCODE, Ensembl, or RefSeq. See also \code{\link[=importData]{importData()}} for
importing data when the reference transcripts were derived from
a mix of annotated (e.g. GENCODE) and novel or custom transcripts.
}
\details{
The main functions are:
\itemize{
\item \code{\link[=tximeta]{tximeta()}} - with key argument \code{coldata} specifying sample information
\item \code{\link[=summarizeToGene,SummarizedExperiment-method]{summarizeToGene()}} - summarize quantification to gene-level
\item \code{\link[=importData]{importData()}} - import quantification with mixed reference transcript sets
}

All software-related questions should be posted to the Bioconductor Support Site:

\url{https://support.bioconductor.org}

The code can be viewed at the GitHub repository,
which also lists the contributor code of conduct:

\url{https://github.com/thelovelab/tximeta}
}
\references{
\itemize{
\item \emph{tximeta} reference:
}

Michael I. Love, Charlotte Soneson, Peter F. Hickey, Lisa K. Johnson
N. Tessa Pierce, Lori Shepherd, Martin Morgan, Rob Patro (2020)
\emph{Tximeta: reference sequence checksums for provenance identification
in RNA-seq}. PLOS Computational Biology.
\url{https://doi.org/10.1371/journal.pcbi.1007664}
\itemize{
\item \emph{tximport} reference (the effective length GLM offset and counts-from-abundance):
}

Charlotte Soneson, Michael I. Love, Mark D. Robinson (2015)
\emph{Differential analyses for RNA-seq: transcript-level estimates
improve gene-level inferences}. F1000Research.
\url{http://doi.org/10.12688/f1000research.7563}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://thelovelab.github.io/tximeta}
  \item \url{https://github.com/thelovelab/tximeta}
}

}
\author{
Michael I. Love, Charlotte Soneson, Peter Hickey, Rob Patro
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addRanges.R
\name{addCDS}
\alias{addCDS}
\title{Add CDS to rowRanges of a transcript-level SummarizedExperiment}
\usage{
addCDS(se)
}
\arguments{
\item{se}{the SummarizedExperiment}
}
\value{
a SummarizedExperiment
}
\description{
Working similarly to \code{\link{addExons}}, this function
can be used to add information about CDS (coding sequence)
to the \code{SummarizedExperiment} object. As not all transcripts
are coding, we have CDS information for only a subset of the
rows of the object. For this reason, a logical indicator for
whether the transcript is coding, \code{mcols(se)$coding},
is added as a column to the metadata columns of the \code{rowRanges}
of the object. An additional column, \code{mcols(se)$cds},
is added to the metadata columns, which is a \code{GRangesList}
with either the CDS regions (if the transcript is coding),
or the original transcript/exon ranges (if the transcript is non-coding).
This is necessary, as \code{GRangesList} cannot have NA elements.
As with \code{\link{addExons}}, this function is designed only
for transcript-level objects.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dgelist.R
\name{makeDGEList}
\alias{makeDGEList}
\title{Make a DGEList from tximeta output}
\usage{
makeDGEList(se)
}
\arguments{
\item{se}{a SummarizedExperiment produced by tximeta}
}
\value{
a DGEList
}
\description{
A simple wrapper function for constructing a DGEList for use with edgeR.
See vignette for an example. Requires installation of the edgeR
package from Bioconductor.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mixed_reference.R
\name{importData}
\alias{importData}
\title{Import quantification across mixed reference transcripts}
\usage{
importData(coldata, type = "oarfish", mixedDigest = NULL, quiet = FALSE, ...)
}
\arguments{
\item{coldata}{data.frame with columns \code{files} and \code{names} as in \code{tximeta()}}

\item{type}{what quantifier was used (see \code{\link[tximport:tximport]{tximport::tximport()}});
\code{importData()} supports \code{"oarfish"} and \code{"salmon"} (with \code{mixedDigest})}

\item{mixedDigest}{for \code{type="salmon"}, the filename (relative to each
sample's quantification directory) of the JSON file containing per-sub-index
sha256 digests, e.g. \code{"mixed_ref_digests.json"}. This file is produced by
the companion Snakemake rule that runs \code{compute_fasta_digest} on the
annotated and novel FASTAs at index time and writes the results in
a structure compatible with \code{inspectDigests()} and \code{updateMetadata()}.
Not needed for \code{type="oarfish"}, which records digests natively.}

\item{quiet}{whether to suppress printed messages}

\item{...}{arguments passed to \code{\link[tximport:tximport]{tximport::tximport()}}}
}
\value{
an un-ranged SummarizedExperiment (SE) object, for
use with subsequent functions described in \emph{See also} section
}
\description{
The \emph{oarfish} and \emph{salmon} quantification tools allow a mix of
\code{--annotated} reference transcripts (e.g. GENCODE, Ensembl) and
\code{--novel} or custom transcripts (e.g. de novo assembled transcripts not present
in the annotated set) to be used as the index for quantification.
\code{importData()} and associated functions facilitate import, reference identification,
and addition of metadata across \code{annotated} and/or \code{novel} transcripts.
The \code{importData()} function alone imports the data, while inspection of the
recognized digests and updating of transcript metadata is handled by subsequent functions
(listed in \emph{See also} section below).
}
\details{
oarfish with mixed reference transcript sets may have been generated with e.g.

\preformatted{
oarfish --only-index --annotated gencode.v48.transcripts.fa.gz \
  --novel my_novel_txps.fa.gz --seq-tech ont-cdna --threads 32 \
  --index-out gencode_plus_novel
oarfish --reads reads/experiment_rep1.fastq.gz --index gencode_plus_novel \
  --output quants/experiment_rep1 --seq-tech ont-cdna \
  --filter-group no-filters --threads 32
}

For \emph{salmon}, per-sub-index digests are not recorded natively. Instead, a
companion Snakemake rule runs \code{compute_fasta_digest} on each FASTA at index
time and writes \code{mixed_ref_digests.json} into each quantification directory.
Pass the filename via \code{mixedDigest} so that \code{importData()} can find it:

\preformatted{
se <- importData(coldata, type="salmon", mixedDigest="mixed_ref_digests.json")
}
}
\examples{

# oarfish files using a mix of --annotated and --novel transcripts
dir <- system.file("extdata/oarfish", package="tximportData")
names <- paste0("rep", 2:4)
files <- file.path(dir, paste0("sgnex_h9_", names, ".quant.gz"))
coldata <- data.frame(files, names)

# returns an un-ranged SE object
se <- importData(coldata, type="oarfish")

}
\seealso{
\code{inspectDigests()} and \code{updateMetadata()} for subsequent tasks
of inspecting digest matches and updating metadata, respectively.
\code{makeLinkedTxome()} can be used to add custom metadata into the registry used
for inspecting digests and then updating transcript data. A user may
follow the workflow \code{importData()} > \code{inspectDigests()} >
\code{makeLinkedTxome()} > \code{inspectDigests()} > \code{updateMetadata()}.
See also \code{makeLinkedTxpData()} for a lightweight alternative of linking
\emph{GRanges} metadata to a digest.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitSE.R
\name{splitSE}
\alias{splitSE}
\title{Split SummarizedExperiment by gene categories}
\usage{
splitSE(se, splitDf, assayName)
}
\arguments{
\item{se}{A \code{SummarizedExperiment} object.}

\item{splitDf}{A \code{data.frame} with feature IDs. Each column 
represents a separate feature type, and the features in a given 
row are considered representatives of the same feature (and will 
be represented as one feature in the output object).}

\item{assayName}{A character scalar, indicating the assay of \code{se}
that will be split. Must be one of \code{assayNames(se)}.}
}
\value{
A \code{SummarizedExperiment} object with the same columns 
  as the input object, and the same number of assays as the number 
  of columns in \code{splitDf}. The assays will be named by the 
  column names of \code{splitDf}. The \code{colData} and \code{metadata}
  of the input \code{SummarizedExperiment} object are copied to the 
  output object. The row names are set to the feature IDs in the 
  first column of \code{splitDf}.
}
\description{
Construct a new SummarizedExperiment by splitting one of the assays 
into a list of assays, each of which contains features of a given 
'type'. It is assumed that there is a one-to-one correspondence 
between feature sets of different types; for example, these can be 
spliced and unspliced variants of the same transcripts. The type of
each feature in the original SummarizedExperiment, and the correspondence
between the features of different types, are given in a \code{data.frame}.
}
\examples{
se <- SummarizedExperiment::SummarizedExperiment(
  assays = S4Vectors::SimpleList(
    counts = as(matrix(1:15, nrow = 5), "sparseMatrix"),
    logcounts = log2(matrix(1:15, nrow = 5))
  ), 
  colData = S4Vectors::DataFrame(sID = paste0("S", 1:3),
                                 condition = c("A", "A", "B")),
  metadata = list(md1 = "annotation")
)
rownames(se) <- paste0("G", 1:5)
colnames(se) <- paste0("P", 1:3)
splitDf <- data.frame(spliced = c("G1", "G2", "G6"), 
                      unspliced = c("G3", "G5", "G4"),
                      stringsAsFactors = FALSE)
                      
splse <- splitSE(se = se, splitDf = splitDf, assayName = "counts")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/retrievers.R
\name{retrieveDb}
\alias{retrieveDb}
\title{Retrieve the TxDb or EnsDb associated with a SummarizedExperiment}
\usage{
retrieveDb(se)
}
\arguments{
\item{se}{the SummarizedExperiment}
}
\value{
a database object
}
\description{
SummarizedExperiment objects returned by \code{\link{tximeta}} have
associated TxDb or EnsDb databases which are cached locally and used
to perform various metadata related tasks. This helper function
retrieves the database itself for the user to perform any additional
operations.
}
\examples{

example(tximeta)
edb <- retrieveDb(se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitSE.R
\name{splitSE}
\alias{splitSE}
\title{Split SummarizedExperiment by gene categories}
\usage{
splitSE(se, splitDf, assayName)
}
\arguments{
\item{se}{A \code{SummarizedExperiment} object.}

\item{splitDf}{A \code{data.frame} with feature IDs. Each column
represents a separate feature type, and the features in a given
row are considered representatives of the same feature (and will
be represented as one feature in the output object).}

\item{assayName}{A character scalar, indicating the assay of \code{se}
that will be split. Must be one of \code{assayNames(se)}.}
}
\value{
A \code{SummarizedExperiment} object with the same columns
as the input object, and the same number of assays as the number
of columns in \code{splitDf}. The assays will be named by the
column names of \code{splitDf}. The \code{colData} and \code{metadata}
of the input \code{SummarizedExperiment} object are copied to the
output object. The row names are set to the feature IDs in the
first column of \code{splitDf}.
}
\description{
Construct a new SummarizedExperiment by splitting one of the assays
into a list of assays, each of which contains features of a given
'type'. It is assumed that there is a one-to-one correspondence
between feature sets of different types; for example, these can be
spliced and unspliced variants of the same transcripts. The type of
each feature in the original SummarizedExperiment, and the correspondence
between the features of different types, are given in a \code{data.frame}.
}
\examples{
se <- SummarizedExperiment::SummarizedExperiment(
  assays = S4Vectors::SimpleList(
    counts = as(matrix(1:15, nrow = 5), "sparseMatrix"),
    logcounts = log2(matrix(1:15, nrow = 5))
  ), 
  colData = S4Vectors::DataFrame(sID = paste0("S", 1:3),
                                 condition = c("A", "A", "B")),
  metadata = list(md1 = "annotation")
)
rownames(se) <- paste0("G", 1:5)
colnames(se) <- paste0("P", 1:3)
splitDf <- data.frame(spliced = c("G1", "G2", "G6"), 
                      unspliced = c("G3", "G5", "G4"),
                      stringsAsFactors = FALSE)
                      
splse <- splitSE(se = se, splitDf = splitDf, assayName = "counts")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addRanges.R
\name{addExons}
\alias{addExons}
\title{Add exons to rowRanges of a transcript-level SummarizedExperiment}
\usage{
addExons(se)
}
\arguments{
\item{se}{the SummarizedExperiment}
}
\value{
a SummarizedExperiment
}
\description{
After running \code{tximeta}, the \code{SummarizedExperiment} output
will have \code{GRanges} representing the transcript locations
attached as \code{rowRanges} to the object. These provide the
start and end of the transcript in the genomic coordiantes, and
strand information. However, the exonic locations are not provided.
This function, \code{addExons}, swaps out the \code{GRanges}
with a \code{GRangesList}, essentially a list along the rows of the
\code{SummarizedExperiment}, where each element of the list is a
\code{GRanges} providing the locations of the exons for that transcript.
}
\details{
This function is designed only for transcript-level objects.
This "lack of a feature" reflects a belief on the part of the package author
that it makes more sense to think about exons belonging to transcripts
than to genes. For users desiring exonic information alongside
gene-level objects, for example, which exons are associated with
a particular gene, it is recommended to pull out the relevant
\code{GRangesList} for the transcripts of this gene, while the object
represents transcript-level data, such that the exons are still
associated with transcripts.

For an example of \code{addExons}, please see the tximeta vignette.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/linkedTxome.R
\name{linkedTxpData}
\alias{linkedTxpData}
\alias{makeLinkedTxpData}
\title{Make linked transcript data (linked GRanges)}
\usage{
makeLinkedTxpData(
  digest,
  digestType = "sha256",
  indexName,
  txpData,
  source,
  organism,
  release,
  genome
)
}
\arguments{
\item{digest}{character string of the full digest of the
reference transcripts, see \code{inspectDigests()} with \code{fullDigest=TRUE}}

\item{digestType}{character string of the digest, default \code{"sha256"}}

\item{indexName}{a name for the \code{index} when storing the linkedTxpData,}

\item{txpData}{\emph{GRanges} providing information about ranges
representing the transcript sequences linked to \code{digest}}

\item{source}{the source of transcriptome, e.g. \code{denovo}.
See \code{makeLinkedTxome()} for more information on specifying source}

\item{organism}{organism (e.g. "Homo sapiens")}

\item{release}{release number (e.g. "27")}

\item{genome}{genome (e.g. "GRCh38", or "none")}
}
\value{
nothing, the function is run for its side effects
}
\description{
\code{linkedTxpData} allows the user to save relevant \emph{GRanges} transcript data
for identifying and updating transcript metadata in a persistent manner
across R sessions. It can be used in combination with \code{inspectDigests()}
and \code{updateMetadata()}.
This is a lightweight version of \code{linkedTxome} (see
\code{makeLinkedTxome()}), which requires specifying a GTF file for building a
\emph{TxDb} and optionally a FASTA file for sequence retrieval.)
}
\details{
The \code{txpData} object is saved in the \code{getTximetaBFC()} location,
appended with a 32-character substring of \code{digest}.
The tibble listing all \code{linkedTxpData} is named
\code{linkedTxpDataTbl} and is listed in the same location.
}
\examples{

novel <- data.frame(seqnames = paste0("chr", rep(1:22, each=500)),
  start = 1e6 + 1 + 0:499 * 1000, end = 1e6 + 1 + 0:499 * 1000 + 1000 - 1,
  strand = "+", tx_name = paste0("novel", 1:(22*500)), 
  gene_id = paste0("novel_gene", rep(1:(22*10), each=50)), 
type = "protein_coding")
novel_gr <- as(novel, "GRanges")
names(novel_gr) <- novel$tx_name

makeLinkedTxpData(
 digest = "43158f2c8e88e3acd77c22aee557625a6f1b6a5038cfc7deb5e64903892d8070",
 digestType = "sha256",
 indexName = "my_novel_txps",
 txpData = novel_gr,
 source = "novel", organism="Homo sapiens", 
 release="v1", genome="GRCh38"
)

# to clear the entire linkedTxome table
# (don't run unless you want to clear this table!)
# bfcloc <- getTximetaBFC()
# bfc <- BiocFileCache(bfcloc)
# bfcremove(bfc, bfcquery(bfc, "linkedTxpDataTbl")$rid)

}
